/*
 * AtkDocument.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.atk.Document;
import org.gnome.atk.Plumbing;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;

final class AtkDocument extends Plumbing
{
    private AtkDocument() {}

    static final String getDocumentType(Document self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_document_get_document_type(pointerOf((Object) self));

            return result;
        }
    }

    private static native final String atk_document_get_document_type(long self);

    static final FIXME getDocument(Document self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("gpointer");
    }

    static final FIXME getAttributes(Document self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("AtkAttributeSet*");
    }

    static final String getAttributeValue(Document self, String attributeName) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (attributeName == null) {
            throw new IllegalArgumentException("attributeName can't be null");
        }

        synchronized (lock) {
            result = atk_document_get_attribute_value(pointerOf((Object) self), attributeName);

            return result;
        }
    }

    private static native final String atk_document_get_attribute_value(long self, String attributeName);

    static final boolean setAttributeValue(Document self, String attributeName, String attributeValue) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (attributeName == null) {
            throw new IllegalArgumentException("attributeName can't be null");
        }

        if (attributeValue == null) {
            throw new IllegalArgumentException("attributeValue can't be null");
        }

        synchronized (lock) {
            result = atk_document_set_attribute_value(pointerOf((Object) self), attributeName, attributeValue);

            return result;
        }
    }

    private static native final boolean atk_document_set_attribute_value(long self, String attributeName, String attributeValue);

    interface GetDocumentTypeSignal extends Signal
    {
        String onGetDocumentType(Document source);
    }

    static final void connect(Document self, AtkDocument.GetDocumentTypeSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkDocument.class, "get-document-type", after);
    }

    protected static final String receiveGetDocumentType(Signal handler, long source) {
        String result;

        result = ((AtkDocument.GetDocumentTypeSignal) handler).onGetDocumentType((Document) objectFor(source));

        return result;
    }

    interface GetDocumentSignal extends Signal
    {
        FIXME onGetDocument(Document source);
    }

    static final void connect(Document self, AtkDocument.GetDocumentSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkDocument.class, "get-document", after);
    }

    protected static final java.lang.Object receiveGetDocument(Signal handler, long source) {
        FIXME result;

        result = ((AtkDocument.GetDocumentSignal) handler).onGetDocument((Document) objectFor(source));

        return result;
    }

    interface GetDocumentAttributesSignal extends Signal
    {
        FIXME onGetDocumentAttributes(Document source);
    }

    static final void connect(Document self, AtkDocument.GetDocumentAttributesSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkDocument.class, "get-document-attributes", after);
    }

    protected static final java.lang.Object receiveGetDocumentAttributes(Signal handler, long source) {
        FIXME result;

        result = ((AtkDocument.GetDocumentAttributesSignal) handler).onGetDocumentAttributes((Document) objectFor(source));

        return result;
    }

    interface GetDocumentAttributeValueSignal extends Signal
    {
        FIXME onGetDocumentAttributeValue(Document source, String attributeName);
    }

    static final void connect(Document self, AtkDocument.GetDocumentAttributeValueSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkDocument.class, "get-document-attribute-value", after);
    }

    protected static final java.lang.Object receiveGetDocumentAttributeValue(Signal handler, long source, String attributeName) {
        FIXME result;

        result = ((AtkDocument.GetDocumentAttributeValueSignal) handler).onGetDocumentAttributeValue((Document) objectFor(source), attributeName);

        return result;
    }

    interface SetDocumentAttributeSignal extends Signal
    {
        boolean onSetDocumentAttribute(Document source, String attributeName, String attributeValue);
    }

    static final void connect(Document self, AtkDocument.SetDocumentAttributeSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkDocument.class, "set-document-attribute", after);
    }

    protected static final boolean receiveSetDocumentAttribute(Signal handler, long source, String attributeName, String attributeValue) {
        boolean result;

        result = ((AtkDocument.SetDocumentAttributeSignal) handler).onSetDocumentAttribute((Document) objectFor(source), attributeName, attributeValue);

        return result;
    }
}

