/*
 * AtkEditableText.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.atk.EditableText;
import org.gnome.atk.Plumbing;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;

final class AtkEditableText extends Plumbing
{
    private AtkEditableText() {}

    static final boolean setRunAttributes(EditableText self, FIXME attribSet, int startOffset, int endOffset) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("AtkAttributeSet*");
    }

    static final void setTextContents(EditableText self, String string) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (string == null) {
            throw new IllegalArgumentException("string can't be null");
        }

        synchronized (lock) {
            atk_editable_text_set_text_contents(pointerOf((Object) self), string);
        }
    }

    private static native final void atk_editable_text_set_text_contents(long self, String string);

    static final void insertText(EditableText self, String string, int length, int[] position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (string == null) {
            throw new IllegalArgumentException("string can't be null");
        }

        if (position == null) {
            throw new IllegalArgumentException("position can't be null");
        }

        synchronized (lock) {
            atk_editable_text_insert_text(pointerOf((Object) self), string, length, position);
        }
    }

    private static native final void atk_editable_text_insert_text(long self, String string, int length, int[] position);

    static final void copyText(EditableText self, int startPos, int endPos) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            atk_editable_text_copy_text(pointerOf((Object) self), startPos, endPos);
        }
    }

    private static native final void atk_editable_text_copy_text(long self, int startPos, int endPos);

    static final void cutText(EditableText self, int startPos, int endPos) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            atk_editable_text_cut_text(pointerOf((Object) self), startPos, endPos);
        }
    }

    private static native final void atk_editable_text_cut_text(long self, int startPos, int endPos);

    static final void deleteText(EditableText self, int startPos, int endPos) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            atk_editable_text_delete_text(pointerOf((Object) self), startPos, endPos);
        }
    }

    private static native final void atk_editable_text_delete_text(long self, int startPos, int endPos);

    static final void pasteText(EditableText self, int position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            atk_editable_text_paste_text(pointerOf((Object) self), position);
        }
    }

    private static native final void atk_editable_text_paste_text(long self, int position);

    interface SetRunAttributesSignal extends Signal
    {
        boolean onSetRunAttributes(EditableText source, FIXME attribSet, int startOffset, int endOffset);
    }

    static final void connect(EditableText self, AtkEditableText.SetRunAttributesSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkEditableText.class, "set-run-attributes", after);
    }

    protected static final boolean receiveSetRunAttributes(Signal handler, long source, java.lang.Object attribSet, int startOffset, int endOffset) {
        boolean result;

        result = ((AtkEditableText.SetRunAttributesSignal) handler).onSetRunAttributes((EditableText) objectFor(source), (FIXME) attribSet, startOffset, endOffset);

        return result;
    }

    interface SetTextContentsSignal extends Signal
    {
        void onSetTextContents(EditableText source, String string);
    }

    static final void connect(EditableText self, AtkEditableText.SetTextContentsSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkEditableText.class, "set-text-contents", after);
    }

    protected static final void receiveSetTextContents(Signal handler, long source, String string) {
        ((AtkEditableText.SetTextContentsSignal) handler).onSetTextContents((EditableText) objectFor(source), string);
    }

    interface InsertTextSignal extends Signal
    {
        void onInsertText(EditableText source, String string, int length, int[] position);
    }

    static final void connect(EditableText self, AtkEditableText.InsertTextSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkEditableText.class, "insert-text", after);
    }

    protected static final void receiveInsertText(Signal handler, long source, String string, int length, int[] position) {
        ((AtkEditableText.InsertTextSignal) handler).onInsertText((EditableText) objectFor(source), string, length, position);
    }

    interface CopyTextSignal extends Signal
    {
        void onCopyText(EditableText source, int startPos, int endPos);
    }

    static final void connect(EditableText self, AtkEditableText.CopyTextSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkEditableText.class, "copy-text", after);
    }

    protected static final void receiveCopyText(Signal handler, long source, int startPos, int endPos) {
        ((AtkEditableText.CopyTextSignal) handler).onCopyText((EditableText) objectFor(source), startPos, endPos);
    }

    interface CutTextSignal extends Signal
    {
        void onCutText(EditableText source, int startPos, int endPos);
    }

    static final void connect(EditableText self, AtkEditableText.CutTextSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkEditableText.class, "cut-text", after);
    }

    protected static final void receiveCutText(Signal handler, long source, int startPos, int endPos) {
        ((AtkEditableText.CutTextSignal) handler).onCutText((EditableText) objectFor(source), startPos, endPos);
    }

    interface DeleteTextSignal extends Signal
    {
        void onDeleteText(EditableText source, int startPos, int endPos);
    }

    static final void connect(EditableText self, AtkEditableText.DeleteTextSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkEditableText.class, "delete-text", after);
    }

    protected static final void receiveDeleteText(Signal handler, long source, int startPos, int endPos) {
        ((AtkEditableText.DeleteTextSignal) handler).onDeleteText((EditableText) objectFor(source), startPos, endPos);
    }

    interface PasteTextSignal extends Signal
    {
        void onPasteText(EditableText source, int position);
    }

    static final void connect(EditableText self, AtkEditableText.PasteTextSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkEditableText.class, "paste-text", after);
    }

    protected static final void receivePasteText(Signal handler, long source, int position) {
        ((AtkEditableText.PasteTextSignal) handler).onPasteText((EditableText) objectFor(source), position);
    }
}

