/*
 * AtkHyperlink.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.gnome.atk.Hyperlink;
import org.gnome.atk.Object;
import org.gnome.atk.Plumbing;
import org.gnome.glib.Signal;

final class AtkHyperlink extends Plumbing
{
    private AtkHyperlink() {}

    static final String getUri(Hyperlink self, int i) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hyperlink_get_uri(pointerOf(self), i);

            return result;
        }
    }

    private static native final String atk_hyperlink_get_uri(long self, int i);

    static final Object getObject(Hyperlink self, int i) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hyperlink_get_object(pointerOf(self), i);

            return (Object) objectFor(result);
        }
    }

    private static native final long atk_hyperlink_get_object(long self, int i);

    static final int getEndIndex(Hyperlink self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hyperlink_get_end_index(pointerOf(self));

            return result;
        }
    }

    private static native final int atk_hyperlink_get_end_index(long self);

    static final int getStartIndex(Hyperlink self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hyperlink_get_start_index(pointerOf(self));

            return result;
        }
    }

    private static native final int atk_hyperlink_get_start_index(long self);

    static final boolean isValid(Hyperlink self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hyperlink_is_valid(pointerOf(self));

            return result;
        }
    }

    private static native final boolean atk_hyperlink_is_valid(long self);

    static final int getNAnchors(Hyperlink self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hyperlink_get_n_anchors(pointerOf(self));

            return result;
        }
    }

    private static native final int atk_hyperlink_get_n_anchors(long self);

    static final boolean isInline(Hyperlink self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hyperlink_is_inline(pointerOf(self));

            return result;
        }
    }

    private static native final boolean atk_hyperlink_is_inline(long self);

    static final boolean isSelectedLink(Hyperlink self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hyperlink_is_selected_link(pointerOf(self));

            return result;
        }
    }

    private static native final boolean atk_hyperlink_is_selected_link(long self);

    interface GetUriSignal extends Signal
    {
        String onGetUri(Hyperlink source, int i);
    }

    static final void connect(Hyperlink self, AtkHyperlink.GetUriSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkHyperlink.class, "get-uri", after);
    }

    protected static final String receiveGetUri(Signal handler, long source, int i) {
        String result;

        result = ((AtkHyperlink.GetUriSignal) handler).onGetUri((Hyperlink) objectFor(source), i);

        return result;
    }

    interface GetObjectSignal extends Signal
    {
        Object onGetObject(Hyperlink source, int i);
    }

    static final void connect(Hyperlink self, AtkHyperlink.GetObjectSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkHyperlink.class, "get-object", after);
    }

    protected static final long receiveGetObject(Signal handler, long source, int i) {
        Object result;

        result = ((AtkHyperlink.GetObjectSignal) handler).onGetObject((Hyperlink) objectFor(source), i);

        return pointerOf(result);
    }

    interface GetEndIndexSignal extends Signal
    {
        int onGetEndIndex(Hyperlink source);
    }

    static final void connect(Hyperlink self, AtkHyperlink.GetEndIndexSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkHyperlink.class, "get-end-index", after);
    }

    protected static final int receiveGetEndIndex(Signal handler, long source) {
        int result;

        result = ((AtkHyperlink.GetEndIndexSignal) handler).onGetEndIndex((Hyperlink) objectFor(source));

        return result;
    }

    interface GetStartIndexSignal extends Signal
    {
        int onGetStartIndex(Hyperlink source);
    }

    static final void connect(Hyperlink self, AtkHyperlink.GetStartIndexSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkHyperlink.class, "get-start-index", after);
    }

    protected static final int receiveGetStartIndex(Signal handler, long source) {
        int result;

        result = ((AtkHyperlink.GetStartIndexSignal) handler).onGetStartIndex((Hyperlink) objectFor(source));

        return result;
    }

    interface IsValidSignal extends Signal
    {
        boolean onIsValid(Hyperlink source);
    }

    static final void connect(Hyperlink self, AtkHyperlink.IsValidSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkHyperlink.class, "is-valid", after);
    }

    protected static final boolean receiveIsValid(Signal handler, long source) {
        boolean result;

        result = ((AtkHyperlink.IsValidSignal) handler).onIsValid((Hyperlink) objectFor(source));

        return result;
    }

    interface GetNAnchorsSignal extends Signal
    {
        int onGetNAnchors(Hyperlink source);
    }

    static final void connect(Hyperlink self, AtkHyperlink.GetNAnchorsSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkHyperlink.class, "get-n-anchors", after);
    }

    protected static final int receiveGetNAnchors(Signal handler, long source) {
        int result;

        result = ((AtkHyperlink.GetNAnchorsSignal) handler).onGetNAnchors((Hyperlink) objectFor(source));

        return result;
    }

    interface LinkStateSignal extends Signal
    {
        int onLinkState(Hyperlink source);
    }

    static final void connect(Hyperlink self, AtkHyperlink.LinkStateSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkHyperlink.class, "link-state", after);
    }

    protected static final int receiveLinkState(Signal handler, long source) {
        int result;

        result = ((AtkHyperlink.LinkStateSignal) handler).onLinkState((Hyperlink) objectFor(source));

        return result;
    }

    interface IsSelectedLinkSignal extends Signal
    {
        boolean onIsSelectedLink(Hyperlink source);
    }

    static final void connect(Hyperlink self, AtkHyperlink.IsSelectedLinkSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkHyperlink.class, "is-selected-link", after);
    }

    protected static final boolean receiveIsSelectedLink(Signal handler, long source) {
        boolean result;

        result = ((AtkHyperlink.IsSelectedLinkSignal) handler).onIsSelectedLink((Hyperlink) objectFor(source));

        return result;
    }

    interface LinkActivatedSignal extends Signal
    {
        void onLinkActivated(Hyperlink source);
    }

    static final void connect(Hyperlink self, AtkHyperlink.LinkActivatedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkHyperlink.class, "link-activated", after);
    }

    protected static final void receiveLinkActivated(Signal handler, long source) {
        ((AtkHyperlink.LinkActivatedSignal) handler).onLinkActivated((Hyperlink) objectFor(source));
    }
}

