/*
 * AtkHypertext.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.gnome.atk.Hyperlink;
import org.gnome.atk.Hypertext;
import org.gnome.atk.Plumbing;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;

final class AtkHypertext extends Plumbing
{
    private AtkHypertext() {}

    static final Hyperlink getLink(Hypertext self, int linkIndex) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hypertext_get_link(pointerOf((Object) self), linkIndex);

            return (Hyperlink) objectFor(result);
        }
    }

    private static native final long atk_hypertext_get_link(long self, int linkIndex);

    static final int getNLinks(Hypertext self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hypertext_get_n_links(pointerOf((Object) self));

            return result;
        }
    }

    private static native final int atk_hypertext_get_n_links(long self);

    static final int getLinkIndex(Hypertext self, int charIndex) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_hypertext_get_link_index(pointerOf((Object) self), charIndex);

            return result;
        }
    }

    private static native final int atk_hypertext_get_link_index(long self, int charIndex);

    interface GetLinkSignal extends Signal
    {
        Hyperlink onGetLink(Hypertext source, int linkIndex);
    }

    static final void connect(Hypertext self, AtkHypertext.GetLinkSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkHypertext.class, "get-link", after);
    }

    protected static final long receiveGetLink(Signal handler, long source, int linkIndex) {
        Hyperlink result;

        result = ((AtkHypertext.GetLinkSignal) handler).onGetLink((Hypertext) objectFor(source), linkIndex);

        return pointerOf(result);
    }

    interface GetNLinksSignal extends Signal
    {
        int onGetNLinks(Hypertext source);
    }

    static final void connect(Hypertext self, AtkHypertext.GetNLinksSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkHypertext.class, "get-n-links", after);
    }

    protected static final int receiveGetNLinks(Signal handler, long source) {
        int result;

        result = ((AtkHypertext.GetNLinksSignal) handler).onGetNLinks((Hypertext) objectFor(source));

        return result;
    }

    interface GetLinkIndexSignal extends Signal
    {
        int onGetLinkIndex(Hypertext source, int charIndex);
    }

    static final void connect(Hypertext self, AtkHypertext.GetLinkIndexSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkHypertext.class, "get-link-index", after);
    }

    protected static final int receiveGetLinkIndex(Signal handler, long source, int charIndex) {
        int result;

        result = ((AtkHypertext.GetLinkIndexSignal) handler).onGetLinkIndex((Hypertext) objectFor(source), charIndex);

        return result;
    }

    interface LinkSelectedSignal extends Signal
    {
        void onLinkSelected(Hypertext source, int linkIndex);
    }

    static final void connect(Hypertext self, AtkHypertext.LinkSelectedSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkHypertext.class, "link-selected", after);
    }

    protected static final void receiveLinkSelected(Signal handler, long source, int linkIndex) {
        ((AtkHypertext.LinkSelectedSignal) handler).onLinkSelected((Hypertext) objectFor(source), linkIndex);
    }
}

