/*
 * AtkImage.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.gnome.atk.CoordType;
import org.gnome.atk.Image;
import org.gnome.atk.Plumbing;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;

final class AtkImage extends Plumbing
{
    private AtkImage() {}

    static final String getImageDescription(Image self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_image_get_image_description(pointerOf((Object) self));

            return result;
        }
    }

    private static native final String atk_image_get_image_description(long self);

    static final void getImageSize(Image self, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (width == null) {
            throw new IllegalArgumentException("width can't be null");
        }

        if (height == null) {
            throw new IllegalArgumentException("height can't be null");
        }

        synchronized (lock) {
            atk_image_get_image_size(pointerOf((Object) self), width, height);
        }
    }

    private static native final void atk_image_get_image_size(long self, int[] width, int[] height);

    static final boolean setImageDescription(Image self, String description) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (description == null) {
            throw new IllegalArgumentException("description can't be null");
        }

        synchronized (lock) {
            result = atk_image_set_image_description(pointerOf((Object) self), description);

            return result;
        }
    }

    private static native final boolean atk_image_set_image_description(long self, String description);

    static final void getImagePosition(Image self, int[] x, int[] y, CoordType coordType) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (x == null) {
            throw new IllegalArgumentException("x can't be null");
        }

        if (y == null) {
            throw new IllegalArgumentException("y can't be null");
        }

        if (coordType == null) {
            throw new IllegalArgumentException("coordType can't be null");
        }

        synchronized (lock) {
            atk_image_get_image_position(pointerOf((Object) self), x, y, numOf(coordType));
        }
    }

    private static native final void atk_image_get_image_position(long self, int[] x, int[] y, int coordType);

    interface GetImagePositionSignal extends Signal
    {
        void onGetImagePosition(Image source, int[] x, int[] y, CoordType coordType);
    }

    static final void connect(Image self, AtkImage.GetImagePositionSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkImage.class, "get-image-position", after);
    }

    protected static final void receiveGetImagePosition(Signal handler, long source, int[] x, int[] y, int coordType) {
        ((AtkImage.GetImagePositionSignal) handler).onGetImagePosition((Image) objectFor(source), x, y, (CoordType) enumFor(CoordType.class, coordType));
    }

    interface GetImageDescriptionSignal extends Signal
    {
        String onGetImageDescription(Image source);
    }

    static final void connect(Image self, AtkImage.GetImageDescriptionSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkImage.class, "get-image-description", after);
    }

    protected static final String receiveGetImageDescription(Signal handler, long source) {
        String result;

        result = ((AtkImage.GetImageDescriptionSignal) handler).onGetImageDescription((Image) objectFor(source));

        return result;
    }

    interface GetImageSizeSignal extends Signal
    {
        void onGetImageSize(Image source, int[] width, int[] height);
    }

    static final void connect(Image self, AtkImage.GetImageSizeSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkImage.class, "get-image-size", after);
    }

    protected static final void receiveGetImageSize(Signal handler, long source, int[] width, int[] height) {
        ((AtkImage.GetImageSizeSignal) handler).onGetImageSize((Image) objectFor(source), width, height);
    }

    interface SetImageDescriptionSignal extends Signal
    {
        boolean onSetImageDescription(Image source, String description);
    }

    static final void connect(Image self, AtkImage.SetImageDescriptionSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkImage.class, "set-image-description", after);
    }

    protected static final boolean receiveSetImageDescription(Signal handler, long source, String description) {
        boolean result;

        result = ((AtkImage.SetImageDescriptionSignal) handler).onSetImageDescription((Image) objectFor(source), description);

        return result;
    }
}

