/*
 * AtkObjectFactory.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.atk.Object;
import org.gnome.atk.ObjectFactory;
import org.gnome.atk.Plumbing;
import org.gnome.glib.Signal;

final class AtkObjectFactory extends Plumbing
{
    private AtkObjectFactory() {}

    static final Object createAccessible(ObjectFactory self, org.gnome.glib.Object obj) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (obj == null) {
            throw new IllegalArgumentException("obj can't be null");
        }

        synchronized (lock) {
            result = atk_object_factory_create_accessible(pointerOf(self), pointerOf(obj));

            return (Object) objectFor(result);
        }
    }

    private static native final long atk_object_factory_create_accessible(long self, long obj);

    static final void invalidate(ObjectFactory self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            atk_object_factory_invalidate(pointerOf(self));
        }
    }

    private static native final void atk_object_factory_invalidate(long self);

    static final FIXME getAccessibleType(ObjectFactory self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GType");
    }

    interface CreateAccessibleSignal extends Signal
    {
        Object onCreateAccessible(ObjectFactory source);
    }

    static final void connect(ObjectFactory self, AtkObjectFactory.CreateAccessibleSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkObjectFactory.class, "create-accessible", after);
    }

    protected static final long receiveCreateAccessible(Signal handler, long source) {
        Object result;

        result = ((AtkObjectFactory.CreateAccessibleSignal) handler).onCreateAccessible((ObjectFactory) objectFor(source));

        return pointerOf(result);
    }

    interface InvalidateSignal extends Signal
    {
        void onInvalidate(ObjectFactory source);
    }

    static final void connect(ObjectFactory self, AtkObjectFactory.InvalidateSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkObjectFactory.class, "invalidate", after);
    }

    protected static final void receiveInvalidate(Signal handler, long source) {
        ((AtkObjectFactory.InvalidateSignal) handler).onInvalidate((ObjectFactory) objectFor(source));
    }
}

