/*
 * AtkRelation.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.atk.Object;
import org.gnome.atk.Plumbing;
import org.gnome.atk.Relation;
import org.gnome.atk.RelationType;

final class AtkRelation extends Plumbing
{
    private AtkRelation() {}

    static final long createRelation(Object[] targets, int nTargets, RelationType relationship) {
        long result;
        long[] _targets;

        if (targets == null) {
            throw new IllegalArgumentException("targets can't be null");
        }

        if (relationship == null) {
            throw new IllegalArgumentException("relationship can't be null");
        }

        _targets = pointersOf(targets);

        synchronized (lock) {
            result = atk_relation_new(_targets, nTargets, numOf(relationship));
            fillObjectArray(targets, _targets);

            return result;
        }
    }

    private static native final long atk_relation_new(long[] targets, int nTargets, int relationship);

    static final RelationType getRelationType(Relation self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_relation_get_relation_type(pointerOf(self));

            return (RelationType) enumFor(RelationType.class, result);
        }
    }

    private static native final int atk_relation_get_relation_type(long self);

    static final FIXME getTarget(Relation self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GPtrArray*");
    }

    static final void addTarget(Relation self, Object target) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (target == null) {
            throw new IllegalArgumentException("target can't be null");
        }

        synchronized (lock) {
            atk_relation_add_target(pointerOf(self), pointerOf(target));
        }
    }

    private static native final void atk_relation_add_target(long self, long target);
}

