/*
 * AtkRelationSet.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.gnome.atk.Object;
import org.gnome.atk.Plumbing;
import org.gnome.atk.Relation;
import org.gnome.atk.RelationSet;
import org.gnome.atk.RelationType;

final class AtkRelationSet extends Plumbing
{
    private AtkRelationSet() {}

    static final long createRelationSet() {
        long result;

        synchronized (lock) {
            result = atk_relation_set_new();

            return result;
        }
    }

    private static native final long atk_relation_set_new();

    static final boolean contains(RelationSet self, RelationType relationship) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (relationship == null) {
            throw new IllegalArgumentException("relationship can't be null");
        }

        synchronized (lock) {
            result = atk_relation_set_contains(pointerOf(self), numOf(relationship));

            return result;
        }
    }

    private static native final boolean atk_relation_set_contains(long self, int relationship);

    static final void remove(RelationSet self, Relation relation) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (relation == null) {
            throw new IllegalArgumentException("relation can't be null");
        }

        synchronized (lock) {
            atk_relation_set_remove(pointerOf(self), pointerOf(relation));
        }
    }

    private static native final void atk_relation_set_remove(long self, long relation);

    static final void add(RelationSet self, Relation relation) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (relation == null) {
            throw new IllegalArgumentException("relation can't be null");
        }

        synchronized (lock) {
            atk_relation_set_add(pointerOf(self), pointerOf(relation));
        }
    }

    private static native final void atk_relation_set_add(long self, long relation);

    static final int getNRelations(RelationSet self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_relation_set_get_n_relations(pointerOf(self));

            return result;
        }
    }

    private static native final int atk_relation_set_get_n_relations(long self);

    static final Relation getRelation(RelationSet self, int i) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_relation_set_get_relation(pointerOf(self), i);

            return (Relation) objectFor(result);
        }
    }

    private static native final long atk_relation_set_get_relation(long self, int i);

    static final Relation getRelationByType(RelationSet self, RelationType relationship) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (relationship == null) {
            throw new IllegalArgumentException("relationship can't be null");
        }

        synchronized (lock) {
            result = atk_relation_set_get_relation_by_type(pointerOf(self), numOf(relationship));

            return (Relation) objectFor(result);
        }
    }

    private static native final long atk_relation_set_get_relation_by_type(long self, int relationship);

    static final void addRelationByType(RelationSet self, RelationType relationship, Object target) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (relationship == null) {
            throw new IllegalArgumentException("relationship can't be null");
        }

        if (target == null) {
            throw new IllegalArgumentException("target can't be null");
        }

        synchronized (lock) {
            atk_relation_set_add_relation_by_type(pointerOf(self), numOf(relationship), pointerOf(target));
        }
    }

    private static native final void atk_relation_set_add_relation_by_type(long self, int relationship, long target);
}

