/*
 * AtkTextRange.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.gnome.atk.Plumbing;

final class AtkTextRange extends Plumbing
{
    private AtkTextRange() {}

    static final int getStartOffset(TextRange self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_text_range_get_start_offset(pointerOf(self));

            return result;
        }
    }

    private static native final int atk_text_range_get_start_offset(long self);

    static final void setStartOffset(TextRange self, int startOffset) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            atk_text_range_set_start_offset(pointerOf(self), startOffset);
        }
    }

    private static native final void atk_text_range_set_start_offset(long self, int startOffset);

    static final int getEndOffset(TextRange self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_text_range_get_end_offset(pointerOf(self));

            return result;
        }
    }

    private static native final int atk_text_range_get_end_offset(long self);

    static final void setEndOffset(TextRange self, int endOffset) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            atk_text_range_set_end_offset(pointerOf(self), endOffset);
        }
    }

    private static native final void atk_text_range_set_end_offset(long self, int endOffset);

    static final String getContent(TextRange self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = atk_text_range_get_content(pointerOf(self));

            return result;
        }
    }

    private static native final String atk_text_range_get_content(long self);

    static final void setContent(TextRange self, String content) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (content == null) {
            throw new IllegalArgumentException("content can't be null");
        }

        synchronized (lock) {
            atk_text_range_set_content(pointerOf(self), content);
        }
    }

    private static native final void atk_text_range_set_content(long self, String content);
}

