/*
 * AtkUtil.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.atk.Plumbing;
import org.gnome.glib.Signal;

final class AtkUtil extends Plumbing
{
    private AtkUtil() {}

    interface AddGlobalEventListenerSignal extends Signal
    {
        int onAddGlobalEventListener(Util source, String eventType);
    }

    static final void connect(Util self, AtkUtil.AddGlobalEventListenerSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkUtil.class, "add-global-event-listener", after);
    }

    protected static final int receiveAddGlobalEventListener(Signal handler, long source, String eventType) {
        int result;

        result = ((AtkUtil.AddGlobalEventListenerSignal) handler).onAddGlobalEventListener((Util) objectFor(source), eventType);

        return result;
    }

    interface RemoveGlobalEventListenerSignal extends Signal
    {
        void onRemoveGlobalEventListener(Util source);
    }

    static final void connect(Util self, AtkUtil.RemoveGlobalEventListenerSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkUtil.class, "remove-global-event-listener", after);
    }

    protected static final void receiveRemoveGlobalEventListener(Signal handler, long source) {
        ((AtkUtil.RemoveGlobalEventListenerSignal) handler).onRemoveGlobalEventListener((Util) objectFor(source));
    }

    interface AddKeyEventListenerSignal extends Signal
    {
        int onAddKeyEventListener(Util source, FIXME data);
    }

    static final void connect(Util self, AtkUtil.AddKeyEventListenerSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkUtil.class, "add-key-event-listener", after);
    }

    protected static final int receiveAddKeyEventListener(Signal handler, long source, java.lang.Object data) {
        int result;

        result = ((AtkUtil.AddKeyEventListenerSignal) handler).onAddKeyEventListener((Util) objectFor(source), (FIXME) data);

        return result;
    }

    interface RemoveKeyEventListenerSignal extends Signal
    {
        void onRemoveKeyEventListener(Util source);
    }

    static final void connect(Util self, AtkUtil.RemoveKeyEventListenerSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, AtkUtil.class, "remove-key-event-listener", after);
    }

    protected static final void receiveRemoveKeyEventListener(Signal handler, long source) {
        ((AtkUtil.RemoveKeyEventListenerSignal) handler).onRemoveKeyEventListener((Util) objectFor(source));
    }
}

