/*
 * AtkValue.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.atk;

import org.gnome.atk.Plumbing;
import org.gnome.atk.Value;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;

final class AtkValue extends Plumbing
{
    private AtkValue() {}

    static final void getCurrentValue(Value self, org.gnome.glib.Value value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            atk_value_get_current_value(pointerOf((Object) self), pointerOf(value));
        }
    }

    private static native final void atk_value_get_current_value(long self, long value);

    static final void getMaximumValue(Value self, org.gnome.glib.Value value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            atk_value_get_maximum_value(pointerOf((Object) self), pointerOf(value));
        }
    }

    private static native final void atk_value_get_maximum_value(long self, long value);

    static final void getMinimumValue(Value self, org.gnome.glib.Value value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            atk_value_get_minimum_value(pointerOf((Object) self), pointerOf(value));
        }
    }

    private static native final void atk_value_get_minimum_value(long self, long value);

    static final boolean setCurrentValue(Value self, org.gnome.glib.Value value) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            result = atk_value_set_current_value(pointerOf((Object) self), pointerOf(value));

            return result;
        }
    }

    private static native final boolean atk_value_set_current_value(long self, long value);

    static final void getMinimumIncrement(Value self, org.gnome.glib.Value value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            atk_value_get_minimum_increment(pointerOf((Object) self), pointerOf(value));
        }
    }

    private static native final void atk_value_get_minimum_increment(long self, long value);

    interface GetCurrentValueSignal extends Signal
    {
        void onGetCurrentValue(Value source, org.gnome.glib.Value value);
    }

    static final void connect(Value self, AtkValue.GetCurrentValueSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkValue.class, "get-current-value", after);
    }

    protected static final void receiveGetCurrentValue(Signal handler, long source, long value) {
        ((AtkValue.GetCurrentValueSignal) handler).onGetCurrentValue((Value) objectFor(source), valueFor(value));
    }

    interface GetMaximumValueSignal extends Signal
    {
        void onGetMaximumValue(Value source, org.gnome.glib.Value value);
    }

    static final void connect(Value self, AtkValue.GetMaximumValueSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkValue.class, "get-maximum-value", after);
    }

    protected static final void receiveGetMaximumValue(Signal handler, long source, long value) {
        ((AtkValue.GetMaximumValueSignal) handler).onGetMaximumValue((Value) objectFor(source), valueFor(value));
    }

    interface GetMinimumValueSignal extends Signal
    {
        void onGetMinimumValue(Value source, org.gnome.glib.Value value);
    }

    static final void connect(Value self, AtkValue.GetMinimumValueSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkValue.class, "get-minimum-value", after);
    }

    protected static final void receiveGetMinimumValue(Signal handler, long source, long value) {
        ((AtkValue.GetMinimumValueSignal) handler).onGetMinimumValue((Value) objectFor(source), valueFor(value));
    }

    interface SetCurrentValueSignal extends Signal
    {
        boolean onSetCurrentValue(Value source, org.gnome.glib.Value value);
    }

    static final void connect(Value self, AtkValue.SetCurrentValueSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkValue.class, "set-current-value", after);
    }

    protected static final boolean receiveSetCurrentValue(Signal handler, long source, long value) {
        boolean result;

        result = ((AtkValue.SetCurrentValueSignal) handler).onSetCurrentValue((Value) objectFor(source), valueFor(value));

        return result;
    }

    interface GetMinimumIncrementSignal extends Signal
    {
        void onGetMinimumIncrement(Value source, org.gnome.glib.Value value);
    }

    static final void connect(Value self, AtkValue.GetMinimumIncrementSignal handlerInstance, boolean after) {
        connectSignal((Object) self, handlerInstance, AtkValue.class, "get-minimum-increment", after);
    }

    protected static final void receiveGetMinimumIncrement(Signal handler, long source, long value) {
        ((AtkValue.GetMinimumIncrementSignal) handler).onGetMinimumIncrement((Value) objectFor(source), valueFor(value));
    }
}

