/*
 * GdkColor.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Color;
import org.gnome.gdk.Plumbing;

final class GdkColor extends Plumbing
{
    private GdkColor() {}

    static final int getPixel(Color self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_color_get_pixel(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_color_get_pixel(long self);

    static final void setPixel(Color self, int pixel) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_color_set_pixel(pointerOf(self), pixel);
        }
    }

    private static native final void gdk_color_set_pixel(long self, int pixel);

    static final char getRed(Color self) {
        char result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_color_get_red(pointerOf(self));

            return result;
        }
    }

    private static native final char gdk_color_get_red(long self);

    static final void setRed(Color self, char red) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_color_set_red(pointerOf(self), red);
        }
    }

    private static native final void gdk_color_set_red(long self, char red);

    static final char getGreen(Color self) {
        char result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_color_get_green(pointerOf(self));

            return result;
        }
    }

    private static native final char gdk_color_get_green(long self);

    static final void setGreen(Color self, char green) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_color_set_green(pointerOf(self), green);
        }
    }

    private static native final void gdk_color_set_green(long self, char green);

    static final char getBlue(Color self) {
        char result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_color_get_blue(pointerOf(self));

            return result;
        }
    }

    private static native final char gdk_color_get_blue(long self);

    static final void setBlue(Color self, char blue) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_color_set_blue(pointerOf(self), blue);
        }
    }

    private static native final void gdk_color_set_blue(long self, char blue);

    static final Color copy(Color self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_color_copy(pointerOf(self));

            return (Color) boxedFor(Color.class, result);
        }
    }

    private static native final long gdk_color_copy(long self);

    static final void free(Color self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_color_free(pointerOf(self));
        }
    }

    private static native final void gdk_color_free(long self);

    static final int hash(Color self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_color_hash(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_color_hash(long self);

    static final boolean equal(Color self, org.gnome.gdk.Color colorb) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (colorb == null) {
            throw new IllegalArgumentException("colorb can't be null");
        }

        synchronized (lock) {
            result = gdk_color_equal(pointerOf(self), pointerOf(colorb));

            return result;
        }
    }

    private static native final boolean gdk_color_equal(long self, long colorb);
}

