/*
 * GdkCursor.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Color;
import org.gnome.gdk.Cursor;
import org.gnome.gdk.CursorType;
import org.gnome.gdk.Display;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.Pixmap;
import org.gnome.gdk.Plumbing;

final class GdkCursor extends Plumbing
{
    private GdkCursor() {}

    static final CursorType getType(Cursor self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_cursor_get_type(pointerOf(self));

            return (CursorType) flagFor(CursorType.class, result);
        }
    }

    private static native final int gdk_cursor_get_type(long self);

    static final void setType(Cursor self, CursorType type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gdk_cursor_set_type(pointerOf(self), numOf(type));
        }
    }

    private static native final void gdk_cursor_set_type(long self, int type);

    static final Cursor ref(Cursor self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_cursor_ref(pointerOf(self));

            return (Cursor) boxedFor(Cursor.class, result);
        }
    }

    private static native final long gdk_cursor_ref(long self);

    static final void unref(Cursor self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_cursor_unref(pointerOf(self));
        }
    }

    private static native final void gdk_cursor_unref(long self);

    static final Pixbuf getImage(Cursor self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_cursor_get_image(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gdk_cursor_get_image(long self);

    static final long createCursor(CursorType cursorType) {
        long result;

        if (cursorType == null) {
            throw new IllegalArgumentException("cursorType can't be null");
        }

        synchronized (lock) {
            result = gdk_cursor_new(numOf(cursorType));

            return result;
        }
    }

    private static native final long gdk_cursor_new(int cursorType);

    static final long createCursorForDisplay(Display display, CursorType cursorType) {
        long result;

        if (display == null) {
            throw new IllegalArgumentException("display can't be null");
        }

        if (cursorType == null) {
            throw new IllegalArgumentException("cursorType can't be null");
        }

        synchronized (lock) {
            result = gdk_cursor_new_for_display(pointerOf(display), numOf(cursorType));

            return result;
        }
    }

    private static native final long gdk_cursor_new_for_display(long display, int cursorType);

    static final long createCursorFromPixmap(Pixmap source, Pixmap mask, Color fg, Color bg, int x, int y) {
        long result;

        if (source == null) {
            throw new IllegalArgumentException("source can't be null");
        }

        if (mask == null) {
            throw new IllegalArgumentException("mask can't be null");
        }

        if (fg == null) {
            throw new IllegalArgumentException("fg can't be null");
        }

        if (bg == null) {
            throw new IllegalArgumentException("bg can't be null");
        }

        synchronized (lock) {
            result = gdk_cursor_new_from_pixmap(pointerOf(source), pointerOf(mask), pointerOf(fg), pointerOf(bg), x, y);

            return result;
        }
    }

    private static native final long gdk_cursor_new_from_pixmap(long source, long mask, long fg, long bg, int x, int y);

    static final long createCursorFromPixbuf(Display display, Pixbuf source, int x, int y) {
        long result;

        if (display == null) {
            throw new IllegalArgumentException("display can't be null");
        }

        if (source == null) {
            throw new IllegalArgumentException("source can't be null");
        }

        synchronized (lock) {
            result = gdk_cursor_new_from_pixbuf(pointerOf(display), pointerOf(source), x, y);

            return result;
        }
    }

    private static native final long gdk_cursor_new_from_pixbuf(long display, long source, int x, int y);

    static final Display getDisplay(Cursor self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_cursor_get_display(pointerOf(self));

            return (Display) objectFor(result);
        }
    }

    private static native final long gdk_cursor_get_display(long self);
}

