/*
 * GdkDevice.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.AxisUse;
import org.gnome.gdk.Device;
import org.gnome.gdk.InputMode;
import org.gnome.gdk.InputSource;
import org.gnome.gdk.ModifierType;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Window;

final class GdkDevice extends Plumbing
{
    private GdkDevice() {}

    static final void setSource(Device self, InputSource source) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (source == null) {
            throw new IllegalArgumentException("source can't be null");
        }

        synchronized (lock) {
            gdk_device_set_source(pointerOf(self), numOf(source));
        }
    }

    private static native final void gdk_device_set_source(long self, int source);

    static final boolean setMode(Device self, InputMode mode) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mode == null) {
            throw new IllegalArgumentException("mode can't be null");
        }

        synchronized (lock) {
            result = gdk_device_set_mode(pointerOf(self), numOf(mode));

            return result;
        }
    }

    private static native final boolean gdk_device_set_mode(long self, int mode);

    static final void setKey(Device self, int index, int keyval, ModifierType modifiers) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (modifiers == null) {
            throw new IllegalArgumentException("modifiers can't be null");
        }

        synchronized (lock) {
            gdk_device_set_key(pointerOf(self), index, keyval, numOf(modifiers));
        }
    }

    private static native final void gdk_device_set_key(long self, int index, int keyval, int modifiers);

    static final void setAxisUse(Device self, int index, AxisUse use) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (use == null) {
            throw new IllegalArgumentException("use can't be null");
        }

        synchronized (lock) {
            gdk_device_set_axis_use(pointerOf(self), index, numOf(use));
        }
    }

    private static native final void gdk_device_set_axis_use(long self, int index, int use);

    static final void getState(Device self, Window window, double[] axes, ModifierType[] mask) {
        int[] _mask;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (axes == null) {
            throw new IllegalArgumentException("axes can't be null");
        }

        if (mask == null) {
            throw new IllegalArgumentException("mask can't be null");
        }

        _mask = numsOf(mask);

        synchronized (lock) {
            gdk_device_get_state(pointerOf(self), pointerOf(window), axes, _mask);
            fillFlagArray(ModifierType.class, mask, _mask);
        }
    }

    private static native final void gdk_device_get_state(long self, long window, double[] axes, int[] mask);

    static final boolean getHistory(Device self, Window window, int start, int stop, FIXME events, int[] nEvents) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkTimeCoord***");
    }

    static final boolean getAxis(Device self, double[] axes, AxisUse use, double[] value) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (axes == null) {
            throw new IllegalArgumentException("axes can't be null");
        }

        if (use == null) {
            throw new IllegalArgumentException("use can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            result = gdk_device_get_axis(pointerOf(self), axes, numOf(use), value);

            return result;
        }
    }

    private static native final boolean gdk_device_get_axis(long self, double[] axes, int use, double[] value);
}

