/*
 * GdkDisplayManager.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Display;
import org.gnome.gdk.DisplayManager;
import org.gnome.gdk.Plumbing;
import org.gnome.glib.Signal;

final class GdkDisplayManager extends Plumbing
{
    private GdkDisplayManager() {}

    static final Display getDefaultDisplay(DisplayManager self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_manager_get_default_display(pointerOf(self));

            return (Display) objectFor(result);
        }
    }

    private static native final long gdk_display_manager_get_default_display(long self);

    static final void setDefaultDisplay(DisplayManager self, Display display) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (display == null) {
            throw new IllegalArgumentException("display can't be null");
        }

        synchronized (lock) {
            gdk_display_manager_set_default_display(pointerOf(self), pointerOf(display));
        }
    }

    private static native final void gdk_display_manager_set_default_display(long self, long display);

    static final Display[] listDisplays(DisplayManager self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_display_manager_list_displays(pointerOf(self));

            return (Display[]) objectArrayFor(result, new Display[result.length]);
        }
    }

    private static native final long[] gdk_display_manager_list_displays(long self);

    interface DisplayOpenedSignal extends Signal
    {
        void onDisplayOpened(DisplayManager source, Display display);
    }

    static final void connect(DisplayManager self, GdkDisplayManager.DisplayOpenedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkDisplayManager.class, "display-opened", after);
    }

    protected static final void receiveDisplayOpened(Signal handler, long source, long display) {
        ((GdkDisplayManager.DisplayOpenedSignal) handler).onDisplayOpened((DisplayManager) objectFor(source), (Display) objectFor(display));
    }
}

