/*
 * GdkDrawable.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Colormap;
import org.gnome.gdk.Display;
import org.gnome.gdk.Drawable;
import org.gnome.gdk.GC;
import org.gnome.gdk.GCValues;
import org.gnome.gdk.GCValuesMask;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Point;
import org.gnome.gdk.Region;
import org.gnome.gdk.RgbCmap;
import org.gnome.gdk.RgbDither;
import org.gnome.gdk.Screen;
import org.gnome.gdk.Segment;
import org.gnome.gdk.Visual;
import org.gnome.pango.Font;
import org.gnome.pango.GlyphString;
import org.gnome.pango.Layout;
import org.gnome.pango.LayoutLine;

final class GdkDrawable extends Plumbing
{
    private GdkDrawable() {}

    static final FIXME copyToImage(Drawable self, FIXME image, int srcX, int srcY, int destX, int destY, int width, int height) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkImage*");
    }

    static final void setData(Drawable self, String key, FIXME data, FIXME destroyFunc) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("gpointer");
    }

    static final FIXME getData(Drawable self, String key) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("gpointer");
    }

    static final void getSize(Drawable self, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_drawable_get_size(pointerOf(self), width, height);
        }
    }

    private static native final void gdk_drawable_get_size(long self, int[] width, int[] height);

    static final void setColormap(Drawable self, Colormap colormap) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (colormap == null) {
            throw new IllegalArgumentException("colormap can't be null");
        }

        synchronized (lock) {
            gdk_drawable_set_colormap(pointerOf(self), pointerOf(colormap));
        }
    }

    private static native final void gdk_drawable_set_colormap(long self, long colormap);

    static final Colormap getColormap(Drawable self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_drawable_get_colormap(pointerOf(self));

            return (Colormap) objectFor(result);
        }
    }

    private static native final long gdk_drawable_get_colormap(long self);

    static final Visual getVisual(Drawable self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_drawable_get_visual(pointerOf(self));

            return (Visual) objectFor(result);
        }
    }

    private static native final long gdk_drawable_get_visual(long self);

    static final int getDepth(Drawable self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_drawable_get_depth(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_drawable_get_depth(long self);

    static final Screen getScreen(Drawable self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_drawable_get_screen(pointerOf(self));

            return (Screen) objectFor(result);
        }
    }

    private static native final long gdk_drawable_get_screen(long self);

    static final Display getDisplay(Drawable self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_drawable_get_display(pointerOf(self));

            return (Display) objectFor(result);
        }
    }

    private static native final long gdk_drawable_get_display(long self);

    static final void drawPoint(Drawable self, GC gc, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        synchronized (lock) {
            gdk_draw_point(pointerOf(self), pointerOf(gc), x, y);
        }
    }

    private static native final void gdk_draw_point(long self, long gc, int x, int y);

    static final void drawLine(Drawable self, GC gc, int x1, int y1, int x2, int y2) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        synchronized (lock) {
            gdk_draw_line(pointerOf(self), pointerOf(gc), x1, y1, x2, y2);
        }
    }

    private static native final void gdk_draw_line(long self, long gc, int x1, int y1, int x2, int y2);

    static final void drawRectangle(Drawable self, GC gc, boolean filled, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        synchronized (lock) {
            gdk_draw_rectangle(pointerOf(self), pointerOf(gc), filled, x, y, width, height);
        }
    }

    private static native final void gdk_draw_rectangle(long self, long gc, boolean filled, int x, int y, int width, int height);

    static final void drawArc(Drawable self, GC gc, boolean filled, int x, int y, int width, int height, int angle1, int angle2) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        synchronized (lock) {
            gdk_draw_arc(pointerOf(self), pointerOf(gc), filled, x, y, width, height, angle1, angle2);
        }
    }

    private static native final void gdk_draw_arc(long self, long gc, boolean filled, int x, int y, int width, int height, int angle1, int angle2);

    static final void drawPolygon(Drawable self, GC gc, boolean filled, Point points, int npoints) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        if (points == null) {
            throw new IllegalArgumentException("points can't be null");
        }

        synchronized (lock) {
            gdk_draw_polygon(pointerOf(self), pointerOf(gc), filled, pointerOf(points), npoints);
        }
    }

    private static native final void gdk_draw_polygon(long self, long gc, boolean filled, long points, int npoints);

    static final void drawDrawable(Drawable self, GC gc, Drawable src, int xsrc, int ysrc, int xdest, int ydest, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        if (src == null) {
            throw new IllegalArgumentException("src can't be null");
        }

        synchronized (lock) {
            gdk_draw_drawable(pointerOf(self), pointerOf(gc), pointerOf(src), xsrc, ysrc, xdest, ydest, width, height);
        }
    }

    private static native final void gdk_draw_drawable(long self, long gc, long src, int xsrc, int ysrc, int xdest, int ydest, int width, int height);

    static final void drawImage(Drawable self, GC gc, FIXME image, int xsrc, int ysrc, int xdest, int ydest, int width, int height) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkImage*");
    }

    static final void drawPoints(Drawable self, GC gc, Point points, int npoints) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        if (points == null) {
            throw new IllegalArgumentException("points can't be null");
        }

        synchronized (lock) {
            gdk_draw_points(pointerOf(self), pointerOf(gc), pointerOf(points), npoints);
        }
    }

    private static native final void gdk_draw_points(long self, long gc, long points, int npoints);

    static final void drawSegments(Drawable self, GC gc, Segment segs, int nsegs) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        if (segs == null) {
            throw new IllegalArgumentException("segs can't be null");
        }

        synchronized (lock) {
            gdk_draw_segments(pointerOf(self), pointerOf(gc), pointerOf(segs), nsegs);
        }
    }

    private static native final void gdk_draw_segments(long self, long gc, long segs, int nsegs);

    static final void drawLines(Drawable self, GC gc, Point points, int npoints) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        if (points == null) {
            throw new IllegalArgumentException("points can't be null");
        }

        synchronized (lock) {
            gdk_draw_lines(pointerOf(self), pointerOf(gc), pointerOf(points), npoints);
        }
    }

    private static native final void gdk_draw_lines(long self, long gc, long points, int npoints);

    static final void drawPixbuf(Drawable self, GC gc, Pixbuf pixbuf, int srcX, int srcY, int destX, int destY, int width, int height, RgbDither dither, int xDither, int yDither) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pixbuf == null) {
            throw new IllegalArgumentException("pixbuf can't be null");
        }

        if (dither == null) {
            throw new IllegalArgumentException("dither can't be null");
        }

        synchronized (lock) {
            gdk_draw_pixbuf(pointerOf(self), pointerOf(gc), pointerOf(pixbuf), srcX, srcY, destX, destY, width, height, numOf(dither), xDither, yDither);
        }
    }

    private static native final void gdk_draw_pixbuf(long self, long gc, long pixbuf, int srcX, int srcY, int destX, int destY, int width, int height, int dither, int xDither, int yDither);

    static final void drawGlyphs(Drawable self, GC gc, Font font, int x, int y, GlyphString glyphs) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        if (font == null) {
            throw new IllegalArgumentException("font can't be null");
        }

        if (glyphs == null) {
            throw new IllegalArgumentException("glyphs can't be null");
        }

        synchronized (lock) {
            gdk_draw_glyphs(pointerOf(self), pointerOf(gc), pointerOf(font), x, y, pointerOf(glyphs));
        }
    }

    private static native final void gdk_draw_glyphs(long self, long gc, long font, int x, int y, long glyphs);

    static final void drawLayoutLine(Drawable self, GC gc, int x, int y, LayoutLine line) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        if (line == null) {
            throw new IllegalArgumentException("line can't be null");
        }

        synchronized (lock) {
            gdk_draw_layout_line(pointerOf(self), pointerOf(gc), x, y, pointerOf(line));
        }
    }

    private static native final void gdk_draw_layout_line(long self, long gc, int x, int y, long line);

    static final void drawLayout(Drawable self, GC gc, int x, int y, Layout layout) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gc == null) {
            throw new IllegalArgumentException("gc can't be null");
        }

        if (layout == null) {
            throw new IllegalArgumentException("layout can't be null");
        }

        synchronized (lock) {
            gdk_draw_layout(pointerOf(self), pointerOf(gc), x, y, pointerOf(layout));
        }
    }

    private static native final void gdk_draw_layout(long self, long gc, int x, int y, long layout);

    static final FIXME getImage(Drawable self, int x, int y, int width, int height) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkImage*");
    }

    static final Region getClipRegion(Drawable self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_drawable_get_clip_region(pointerOf(self));

            return (Region) boxedFor(Region.class, result);
        }
    }

    private static native final long gdk_drawable_get_clip_region(long self);

    static final Region getVisibleRegion(Drawable self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_drawable_get_visible_region(pointerOf(self));

            return (Region) boxedFor(Region.class, result);
        }
    }

    private static native final long gdk_drawable_get_visible_region(long self);

    static final GC newGc(Drawable self, GCValues values, GCValuesMask valuesMask) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (values == null) {
            throw new IllegalArgumentException("values can't be null");
        }

        if (valuesMask == null) {
            throw new IllegalArgumentException("valuesMask can't be null");
        }

        synchronized (lock) {
            result = gdk_gc_new_with_values(pointerOf(self), pointerOf(values), numOf(valuesMask));

            return (GC) objectFor(result);
        }
    }

    private static native final long gdk_gc_new_with_values(long self, long values, int valuesMask);

    static final void drawRgbImage(Drawable self, GC gc, int x, int y, int width, int height, RgbDither dith, FIXME rgbBuf, int rowstride) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guchar*");
    }

    static final void drawRgbImageDithalign(Drawable self, GC gc, int x, int y, int width, int height, RgbDither dith, FIXME rgbBuf, int rowstride, int xdith, int ydith) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guchar*");
    }

    static final void drawRgb32Image(Drawable self, GC gc, int x, int y, int width, int height, RgbDither dith, FIXME buf, int rowstride) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guchar*");
    }

    static final void drawGrayImage(Drawable self, GC gc, int x, int y, int width, int height, RgbDither dith, FIXME buf, int rowstride) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guchar*");
    }

    static final void drawIndexedImage(Drawable self, GC gc, int x, int y, int width, int height, RgbDither dith, FIXME buf, int rowstride, RgbCmap cmap) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guchar*");
    }
}

