/*
 * GdkEventExpose.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.EventType;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Region;
import org.gnome.gdk.Window;

final class GdkEventExpose extends Plumbing
{
    private GdkEventExpose() {}

    static final EventType getType(EventExpose self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_expose_get_type(pointerOf(self));

            return (EventType) enumFor(EventType.class, result);
        }
    }

    private static native final int gdk_event_expose_get_type(long self);

    static final void setType(EventExpose self, EventType type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gdk_event_expose_set_type(pointerOf(self), numOf(type));
        }
    }

    private static native final void gdk_event_expose_set_type(long self, int type);

    static final Window getWindow(EventExpose self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_expose_get_window(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_event_expose_get_window(long self);

    static final void setWindow(EventExpose self, Window window) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        synchronized (lock) {
            gdk_event_expose_set_window(pointerOf(self), pointerOf(window));
        }
    }

    private static native final void gdk_event_expose_set_window(long self, long window);

    static final byte getSendEvent(EventExpose self) {
        byte result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_expose_get_send_event(pointerOf(self));

            return result;
        }
    }

    private static native final byte gdk_event_expose_get_send_event(long self);

    static final void setSendEvent(EventExpose self, byte sendEvent) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_expose_set_send_event(pointerOf(self), sendEvent);
        }
    }

    private static native final void gdk_event_expose_set_send_event(long self, byte sendEvent);

    static final FIXME getArea(EventExpose self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkRectangle");
    }

    static final void setArea(EventExpose self, FIXME area) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkRectangle");
    }

    static final Region getRegion(EventExpose self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_expose_get_region(pointerOf(self));

            return (Region) boxedFor(Region.class, result);
        }
    }

    private static native final long gdk_event_expose_get_region(long self);

    static final void setRegion(EventExpose self, Region region) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (region == null) {
            throw new IllegalArgumentException("region can't be null");
        }

        synchronized (lock) {
            gdk_event_expose_set_region(pointerOf(self), pointerOf(region));
        }
    }

    private static native final void gdk_event_expose_set_region(long self, long region);

    static final int getCount(EventExpose self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_event_expose_get_count(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_event_expose_get_count(long self);

    static final void setCount(EventExpose self, int count) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_event_expose_set_count(pointerOf(self), count);
        }
    }

    private static native final void gdk_event_expose_set_count(long self, int count);
}

