/*
 * GdkGC.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Bitmap;
import org.gnome.gdk.CapStyle;
import org.gnome.gdk.Color;
import org.gnome.gdk.Colormap;
import org.gnome.gdk.Drawable;
import org.gnome.gdk.Fill;
import org.gnome.gdk.Function;
import org.gnome.gdk.GC;
import org.gnome.gdk.GCValues;
import org.gnome.gdk.GCValuesMask;
import org.gnome.gdk.JoinStyle;
import org.gnome.gdk.LineStyle;
import org.gnome.gdk.Pixmap;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Rectangle;
import org.gnome.gdk.Region;
import org.gnome.gdk.Screen;
import org.gnome.gdk.SubwindowMode;
import org.gnome.glib.Signal;

final class GdkGC extends Plumbing
{
    private GdkGC() {}

    static final long createGC(Drawable drawable) {
        long result;

        if (drawable == null) {
            throw new IllegalArgumentException("drawable can't be null");
        }

        synchronized (lock) {
            result = gdk_gc_new(pointerOf(drawable));

            return result;
        }
    }

    private static native final long gdk_gc_new(long drawable);

    static final void getValues(GC self, GCValues values) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (values == null) {
            throw new IllegalArgumentException("values can't be null");
        }

        synchronized (lock) {
            gdk_gc_get_values(pointerOf(self), pointerOf(values));
        }
    }

    private static native final void gdk_gc_get_values(long self, long values);

    static final void setValues(GC self, GCValues values, GCValuesMask valuesMask) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (values == null) {
            throw new IllegalArgumentException("values can't be null");
        }

        if (valuesMask == null) {
            throw new IllegalArgumentException("valuesMask can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_values(pointerOf(self), pointerOf(values), numOf(valuesMask));
        }
    }

    private static native final void gdk_gc_set_values(long self, long values, int valuesMask);

    static final void setForeground(GC self, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_foreground(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gdk_gc_set_foreground(long self, long color);

    static final void setBackground(GC self, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_background(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gdk_gc_set_background(long self, long color);

    static final void setFont(GC self, FIXME font) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkFont*");
    }

    static final void setFunction(GC self, Function function) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (function == null) {
            throw new IllegalArgumentException("function can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_function(pointerOf(self), numOf(function));
        }
    }

    private static native final void gdk_gc_set_function(long self, int function);

    static final void setFill(GC self, Fill fill) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (fill == null) {
            throw new IllegalArgumentException("fill can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_fill(pointerOf(self), numOf(fill));
        }
    }

    private static native final void gdk_gc_set_fill(long self, int fill);

    static final void setTile(GC self, Pixmap tile) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (tile == null) {
            throw new IllegalArgumentException("tile can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_tile(pointerOf(self), pointerOf(tile));
        }
    }

    private static native final void gdk_gc_set_tile(long self, long tile);

    static final void setStipple(GC self, Pixmap stipple) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (stipple == null) {
            throw new IllegalArgumentException("stipple can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_stipple(pointerOf(self), pointerOf(stipple));
        }
    }

    private static native final void gdk_gc_set_stipple(long self, long stipple);

    static final void setTsOrigin(GC self, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_ts_origin(pointerOf(self), x, y);
        }
    }

    private static native final void gdk_gc_set_ts_origin(long self, int x, int y);

    static final void setClipOrigin(GC self, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_clip_origin(pointerOf(self), x, y);
        }
    }

    private static native final void gdk_gc_set_clip_origin(long self, int x, int y);

    static final void setClipMask(GC self, Bitmap mask) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mask == null) {
            throw new IllegalArgumentException("mask can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_clip_mask(pointerOf(self), pointerOf(mask));
        }
    }

    private static native final void gdk_gc_set_clip_mask(long self, long mask);

    static final void setClipRectangle(GC self, Rectangle rectangle) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rectangle == null) {
            throw new IllegalArgumentException("rectangle can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_clip_rectangle(pointerOf(self), pointerOf(rectangle));
        }
    }

    private static native final void gdk_gc_set_clip_rectangle(long self, long rectangle);

    static final void setClipRegion(GC self, Region region) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (region == null) {
            throw new IllegalArgumentException("region can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_clip_region(pointerOf(self), pointerOf(region));
        }
    }

    private static native final void gdk_gc_set_clip_region(long self, long region);

    static final void setSubwindow(GC self, SubwindowMode mode) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mode == null) {
            throw new IllegalArgumentException("mode can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_subwindow(pointerOf(self), numOf(mode));
        }
    }

    private static native final void gdk_gc_set_subwindow(long self, int mode);

    static final void setExposures(GC self, boolean exposures) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_exposures(pointerOf(self), exposures);
        }
    }

    private static native final void gdk_gc_set_exposures(long self, boolean exposures);

    static final void setLineAttributes(GC self, int lineWidth, LineStyle lineStyle, CapStyle capStyle, JoinStyle joinStyle) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (lineStyle == null) {
            throw new IllegalArgumentException("lineStyle can't be null");
        }

        if (capStyle == null) {
            throw new IllegalArgumentException("capStyle can't be null");
        }

        if (joinStyle == null) {
            throw new IllegalArgumentException("joinStyle can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_line_attributes(pointerOf(self), lineWidth, numOf(lineStyle), numOf(capStyle), numOf(joinStyle));
        }
    }

    private static native final void gdk_gc_set_line_attributes(long self, int lineWidth, int lineStyle, int capStyle, int joinStyle);

    static final void setDashes(GC self, int dashOffset, byte[] dashList, int n) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (dashList == null) {
            throw new IllegalArgumentException("dashList can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_dashes(pointerOf(self), dashOffset, dashList, n);
        }
    }

    private static native final void gdk_gc_set_dashes(long self, int dashOffset, byte[] dashList, int n);

    static final void offset(GC self, int xOffset, int yOffset) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_gc_offset(pointerOf(self), xOffset, yOffset);
        }
    }

    private static native final void gdk_gc_offset(long self, int xOffset, int yOffset);

    static final void copy(GC self, GC srcGc) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (srcGc == null) {
            throw new IllegalArgumentException("srcGc can't be null");
        }

        synchronized (lock) {
            gdk_gc_copy(pointerOf(self), pointerOf(srcGc));
        }
    }

    private static native final void gdk_gc_copy(long self, long srcGc);

    static final void setColormap(GC self, Colormap colormap) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (colormap == null) {
            throw new IllegalArgumentException("colormap can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_colormap(pointerOf(self), pointerOf(colormap));
        }
    }

    private static native final void gdk_gc_set_colormap(long self, long colormap);

    static final Colormap getColormap(GC self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_gc_get_colormap(pointerOf(self));

            return (Colormap) objectFor(result);
        }
    }

    private static native final long gdk_gc_get_colormap(long self);

    static final void setRgbFgColor(GC self, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_rgb_fg_color(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gdk_gc_set_rgb_fg_color(long self, long color);

    static final void setRgbBgColor(GC self, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gdk_gc_set_rgb_bg_color(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gdk_gc_set_rgb_bg_color(long self, long color);

    static final Screen getScreen(GC self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_gc_get_screen(pointerOf(self));

            return (Screen) objectFor(result);
        }
    }

    private static native final long gdk_gc_get_screen(long self);

    interface GetValuesSignal extends Signal
    {
        void onGetValues(GC source, GCValues values);
    }

    static final void connect(GC self, GdkGC.GetValuesSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkGC.class, "get-values", after);
    }

    protected static final void receiveGetValues(Signal handler, long source, long values) {
        ((GdkGC.GetValuesSignal) handler).onGetValues((GC) objectFor(source), (GCValues) boxedFor(GCValues.class, values));
    }

    interface SetValuesSignal extends Signal
    {
        void onSetValues(GC source, GCValues values, GCValuesMask mask);
    }

    static final void connect(GC self, GdkGC.SetValuesSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkGC.class, "set-values", after);
    }

    protected static final void receiveSetValues(Signal handler, long source, long values, int mask) {
        ((GdkGC.SetValuesSignal) handler).onSetValues((GC) objectFor(source), (GCValues) boxedFor(GCValues.class, values), (GCValuesMask) flagFor(GCValuesMask.class, mask));
    }

    interface SetDashesSignal extends Signal
    {
        void onSetDashes(GC source, int dashOffset, byte[] dashList, int n);
    }

    static final void connect(GC self, GdkGC.SetDashesSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkGC.class, "set-dashes", after);
    }

    protected static final void receiveSetDashes(Signal handler, long source, int dashOffset, byte[] dashList, int n) {
        ((GdkGC.SetDashesSignal) handler).onSetDashes((GC) objectFor(source), dashOffset, dashList, n);
    }
}

