/*
 * GdkGeometry.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Gravity;
import org.gnome.gdk.Plumbing;

final class GdkGeometry extends Plumbing
{
    private GdkGeometry() {}

    static final int getMinWidth(Geometry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_geometry_get_min_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_geometry_get_min_width(long self);

    static final void setMinWidth(Geometry self, int minWidth) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_geometry_set_min_width(pointerOf(self), minWidth);
        }
    }

    private static native final void gdk_geometry_set_min_width(long self, int minWidth);

    static final int getMinHeight(Geometry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_geometry_get_min_height(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_geometry_get_min_height(long self);

    static final void setMinHeight(Geometry self, int minHeight) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_geometry_set_min_height(pointerOf(self), minHeight);
        }
    }

    private static native final void gdk_geometry_set_min_height(long self, int minHeight);

    static final int getMaxWidth(Geometry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_geometry_get_max_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_geometry_get_max_width(long self);

    static final void setMaxWidth(Geometry self, int maxWidth) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_geometry_set_max_width(pointerOf(self), maxWidth);
        }
    }

    private static native final void gdk_geometry_set_max_width(long self, int maxWidth);

    static final int getMaxHeight(Geometry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_geometry_get_max_height(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_geometry_get_max_height(long self);

    static final void setMaxHeight(Geometry self, int maxHeight) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_geometry_set_max_height(pointerOf(self), maxHeight);
        }
    }

    private static native final void gdk_geometry_set_max_height(long self, int maxHeight);

    static final int getBaseWidth(Geometry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_geometry_get_base_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_geometry_get_base_width(long self);

    static final void setBaseWidth(Geometry self, int baseWidth) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_geometry_set_base_width(pointerOf(self), baseWidth);
        }
    }

    private static native final void gdk_geometry_set_base_width(long self, int baseWidth);

    static final int getBaseHeight(Geometry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_geometry_get_base_height(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_geometry_get_base_height(long self);

    static final void setBaseHeight(Geometry self, int baseHeight) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_geometry_set_base_height(pointerOf(self), baseHeight);
        }
    }

    private static native final void gdk_geometry_set_base_height(long self, int baseHeight);

    static final int getWidthInc(Geometry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_geometry_get_width_inc(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_geometry_get_width_inc(long self);

    static final void setWidthInc(Geometry self, int widthInc) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_geometry_set_width_inc(pointerOf(self), widthInc);
        }
    }

    private static native final void gdk_geometry_set_width_inc(long self, int widthInc);

    static final int getHeightInc(Geometry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_geometry_get_height_inc(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_geometry_get_height_inc(long self);

    static final void setHeightInc(Geometry self, int heightInc) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_geometry_set_height_inc(pointerOf(self), heightInc);
        }
    }

    private static native final void gdk_geometry_set_height_inc(long self, int heightInc);

    static final double getMinAspect(Geometry self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_geometry_get_min_aspect(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_geometry_get_min_aspect(long self);

    static final void setMinAspect(Geometry self, double minAspect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_geometry_set_min_aspect(pointerOf(self), minAspect);
        }
    }

    private static native final void gdk_geometry_set_min_aspect(long self, double minAspect);

    static final double getMaxAspect(Geometry self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_geometry_get_max_aspect(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_geometry_get_max_aspect(long self);

    static final void setMaxAspect(Geometry self, double maxAspect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_geometry_set_max_aspect(pointerOf(self), maxAspect);
        }
    }

    private static native final void gdk_geometry_set_max_aspect(long self, double maxAspect);

    static final Gravity getWinGravity(Geometry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_geometry_get_win_gravity(pointerOf(self));

            return (Gravity) enumFor(Gravity.class, result);
        }
    }

    private static native final int gdk_geometry_get_win_gravity(long self);

    static final void setWinGravity(Geometry self, Gravity winGravity) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (winGravity == null) {
            throw new IllegalArgumentException("winGravity can't be null");
        }

        synchronized (lock) {
            gdk_geometry_set_win_gravity(pointerOf(self), numOf(winGravity));
        }
    }

    private static native final void gdk_geometry_set_win_gravity(long self, int winGravity);
}

