/*
 * GdkKeymap.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Keymap;
import org.gnome.gdk.KeymapKey;
import org.gnome.gdk.ModifierType;
import org.gnome.gdk.Plumbing;
import org.gnome.glib.Signal;
import org.gnome.pango.Direction;

final class GdkKeymap extends Plumbing
{
    private GdkKeymap() {}

    static final int lookupKey(Keymap self, KeymapKey key) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (key == null) {
            throw new IllegalArgumentException("key can't be null");
        }

        synchronized (lock) {
            result = gdk_keymap_lookup_key(pointerOf(self), pointerOf(key));

            return result;
        }
    }

    private static native final int gdk_keymap_lookup_key(long self, long key);

    static final boolean translateKeyboardState(Keymap self, int hardwareKeycode, ModifierType state, int group, int[] keyval, int[] effectiveGroup, int[] level, ModifierType[] consumedModifiers) {
        boolean result;
        int[] _consumedModifiers;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (state == null) {
            throw new IllegalArgumentException("state can't be null");
        }

        if (keyval == null) {
            throw new IllegalArgumentException("keyval can't be null");
        }

        if (effectiveGroup == null) {
            throw new IllegalArgumentException("effectiveGroup can't be null");
        }

        if (level == null) {
            throw new IllegalArgumentException("level can't be null");
        }

        if (consumedModifiers == null) {
            throw new IllegalArgumentException("consumedModifiers can't be null");
        }

        _consumedModifiers = numsOf(consumedModifiers);

        synchronized (lock) {
            result = gdk_keymap_translate_keyboard_state(pointerOf(self), hardwareKeycode, numOf(state), group, keyval, effectiveGroup, level, _consumedModifiers);
            fillFlagArray(ModifierType.class, consumedModifiers, _consumedModifiers);

            return result;
        }
    }

    private static native final boolean gdk_keymap_translate_keyboard_state(long self, int hardwareKeycode, int state, int group, int[] keyval, int[] effectiveGroup, int[] level, int[] consumedModifiers);

    static final boolean getEntriesForKeyval(Keymap self, int keyval, KeymapKey[] keys, int[] nKeys) {
        boolean result;
        long[] _keys;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (keys == null) {
            throw new IllegalArgumentException("keys can't be null");
        }

        if (nKeys == null) {
            throw new IllegalArgumentException("nKeys can't be null");
        }

        _keys = pointersOf(keys);

        synchronized (lock) {
            result = gdk_keymap_get_entries_for_keyval(pointerOf(self), keyval, _keys, nKeys);
            fillBoxedArray(org.gnome.gdk.KeymapKey.class, keys, _keys);

            return result;
        }
    }

    private static native final boolean gdk_keymap_get_entries_for_keyval(long self, int keyval, long[] keys, int[] nKeys);

    static final boolean getEntriesForKeycode(Keymap self, int hardwareKeycode, KeymapKey[] keys, FIXME keyvals, int[] nEntries) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guint**");
    }

    static final Direction getDirection(Keymap self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_keymap_get_direction(pointerOf(self));

            return (Direction) enumFor(Direction.class, result);
        }
    }

    private static native final int gdk_keymap_get_direction(long self);

    interface DirectionChangedSignal extends Signal
    {
        void onDirectionChanged(Keymap source);
    }

    static final void connect(Keymap self, GdkKeymap.DirectionChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkKeymap.class, "direction-changed", after);
    }

    protected static final void receiveDirectionChanged(Signal handler, long source) {
        ((GdkKeymap.DirectionChangedSignal) handler).onDirectionChanged((Keymap) objectFor(source));
    }

    interface KeysChangedSignal extends Signal
    {
        void onKeysChanged(Keymap source);
    }

    static final void connect(Keymap self, GdkKeymap.KeysChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkKeymap.class, "keys-changed", after);
    }

    protected static final void receiveKeysChanged(Signal handler, long source) {
        ((GdkKeymap.KeysChangedSignal) handler).onKeysChanged((Keymap) objectFor(source));
    }
}

