/*
 * GdkPixbufAnimation.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.PixbufAnimation;
import org.gnome.gdk.PixbufAnimationIter;
import org.gnome.gdk.Plumbing;
import org.gnome.glib.GlibException;

final class GdkPixbufAnimation extends Plumbing
{
    private GdkPixbufAnimation() {}

    static final long createPixbufAnimationFromFile(String filename) throws GlibException {
        long result;

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_animation_new_from_file(filename);

            return result;
        }
    }

    private static native final long gdk_pixbuf_animation_new_from_file(String filename) throws GlibException;

    static final int getWidth(PixbufAnimation self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_animation_get_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_pixbuf_animation_get_width(long self);

    static final int getHeight(PixbufAnimation self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_animation_get_height(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_pixbuf_animation_get_height(long self);

    static final boolean isStaticImage(PixbufAnimation self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_animation_is_static_image(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_pixbuf_animation_is_static_image(long self);

    static final Pixbuf getStaticImage(PixbufAnimation self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_animation_get_static_image(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gdk_pixbuf_animation_get_static_image(long self);

    static final PixbufAnimationIter getIter(PixbufAnimation self, FIXME startTime) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("const-GTimeVal*");
    }
}

