/*
 * GdkPixbufLoader.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.PixbufAnimation;
import org.gnome.gdk.PixbufLoader;
import org.gnome.gdk.Plumbing;
import org.gnome.glib.GlibException;
import org.gnome.glib.Signal;

final class GdkPixbufLoader extends Plumbing
{
    private GdkPixbufLoader() {}

    static final long createPixbufLoaderWithType(String imageType) throws GlibException {
        long result;

        if (imageType == null) {
            throw new IllegalArgumentException("imageType can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_loader_new_with_type(imageType);

            return result;
        }
    }

    private static native final long gdk_pixbuf_loader_new_with_type(String imageType) throws GlibException;

    static final boolean write(PixbufLoader self, FIXME buf, long count) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("const-guchar*");
    }

    static final Pixbuf getPixbuf(PixbufLoader self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_loader_get_pixbuf(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gdk_pixbuf_loader_get_pixbuf(long self);

    static final PixbufAnimation getAnimation(PixbufLoader self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_loader_get_animation(pointerOf(self));

            return (PixbufAnimation) objectFor(result);
        }
    }

    private static native final long gdk_pixbuf_loader_get_animation(long self);

    static final boolean close(PixbufLoader self) throws GlibException {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_pixbuf_loader_close(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_pixbuf_loader_close(long self) throws GlibException;

    static final void setSize(PixbufLoader self, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_pixbuf_loader_set_size(pointerOf(self), width, height);
        }
    }

    private static native final void gdk_pixbuf_loader_set_size(long self, int width, int height);

    static final FIXME getFormat(PixbufLoader self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkPixbufFormat*");
    }

    interface SizePreparedSignal extends Signal
    {
        void onSizePrepared(PixbufLoader source, int width, int height);
    }

    static final void connect(PixbufLoader self, GdkPixbufLoader.SizePreparedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkPixbufLoader.class, "size-prepared", after);
    }

    protected static final void receiveSizePrepared(Signal handler, long source, int width, int height) {
        ((GdkPixbufLoader.SizePreparedSignal) handler).onSizePrepared((PixbufLoader) objectFor(source), width, height);
    }

    interface AreaPreparedSignal extends Signal
    {
        void onAreaPrepared(PixbufLoader source);
    }

    static final void connect(PixbufLoader self, GdkPixbufLoader.AreaPreparedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkPixbufLoader.class, "area-prepared", after);
    }

    protected static final void receiveAreaPrepared(Signal handler, long source) {
        ((GdkPixbufLoader.AreaPreparedSignal) handler).onAreaPrepared((PixbufLoader) objectFor(source));
    }

    interface AreaUpdatedSignal extends Signal
    {
        void onAreaUpdated(PixbufLoader source, int x, int y, int width, int height);
    }

    static final void connect(PixbufLoader self, GdkPixbufLoader.AreaUpdatedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkPixbufLoader.class, "area-updated", after);
    }

    protected static final void receiveAreaUpdated(Signal handler, long source, int x, int y, int width, int height) {
        ((GdkPixbufLoader.AreaUpdatedSignal) handler).onAreaUpdated((PixbufLoader) objectFor(source), x, y, width, height);
    }

    interface ClosedSignal extends Signal
    {
        void onClosed(PixbufLoader source);
    }

    static final void connect(PixbufLoader self, GdkPixbufLoader.ClosedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GdkPixbufLoader.class, "closed", after);
    }

    protected static final void receiveClosed(Signal handler, long source) {
        ((GdkPixbufLoader.ClosedSignal) handler).onClosed((PixbufLoader) objectFor(source));
    }
}

