/*
 * GdkRectangle.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Rectangle;

final class GdkRectangle extends Plumbing
{
    private GdkRectangle() {}

    static final int getX(Rectangle self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_rectangle_get_x(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_rectangle_get_x(long self);

    static final void setX(Rectangle self, int x) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_rectangle_set_x(pointerOf(self), x);
        }
    }

    private static native final void gdk_rectangle_set_x(long self, int x);

    static final int getY(Rectangle self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_rectangle_get_y(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_rectangle_get_y(long self);

    static final void setY(Rectangle self, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_rectangle_set_y(pointerOf(self), y);
        }
    }

    private static native final void gdk_rectangle_set_y(long self, int y);

    static final int getWidth(Rectangle self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_rectangle_get_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_rectangle_get_width(long self);

    static final void setWidth(Rectangle self, int width) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_rectangle_set_width(pointerOf(self), width);
        }
    }

    private static native final void gdk_rectangle_set_width(long self, int width);

    static final int getHeight(Rectangle self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_rectangle_get_height(pointerOf(self));

            return result;
        }
    }

    private static native final int gdk_rectangle_get_height(long self);

    static final void setHeight(Rectangle self, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_rectangle_set_height(pointerOf(self), height);
        }
    }

    private static native final void gdk_rectangle_set_height(long self, int height);

    static final boolean intersect(Rectangle self, Rectangle src2, Rectangle dest) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (src2 == null) {
            throw new IllegalArgumentException("src2 can't be null");
        }

        if (dest == null) {
            throw new IllegalArgumentException("dest can't be null");
        }

        synchronized (lock) {
            result = gdk_rectangle_intersect(pointerOf(self), pointerOf(src2), pointerOf(dest));

            return result;
        }
    }

    private static native final boolean gdk_rectangle_intersect(long self, long src2, long dest);

    static final void union(Rectangle self, Rectangle src2, Rectangle dest) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (src2 == null) {
            throw new IllegalArgumentException("src2 can't be null");
        }

        if (dest == null) {
            throw new IllegalArgumentException("dest can't be null");
        }

        synchronized (lock) {
            gdk_rectangle_union(pointerOf(self), pointerOf(src2), pointerOf(dest));
        }
    }

    private static native final void gdk_rectangle_union(long self, long src2, long dest);
}

