/*
 * GdkTrapezoid.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;

final class GdkTrapezoid extends Plumbing
{
    private GdkTrapezoid() {}

    static final double getY1(Trapezoid self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_trapezoid_get_y1(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_trapezoid_get_y1(long self);

    static final void setY1(Trapezoid self, double y1) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_trapezoid_set_y1(pointerOf(self), y1);
        }
    }

    private static native final void gdk_trapezoid_set_y1(long self, double y1);

    static final double getX11(Trapezoid self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_trapezoid_get_x11(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_trapezoid_get_x11(long self);

    static final void setX11(Trapezoid self, double x11) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_trapezoid_set_x11(pointerOf(self), x11);
        }
    }

    private static native final void gdk_trapezoid_set_x11(long self, double x11);

    static final double getX21(Trapezoid self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_trapezoid_get_x21(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_trapezoid_get_x21(long self);

    static final void setX21(Trapezoid self, double x21) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_trapezoid_set_x21(pointerOf(self), x21);
        }
    }

    private static native final void gdk_trapezoid_set_x21(long self, double x21);

    static final double getY2(Trapezoid self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_trapezoid_get_y2(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_trapezoid_get_y2(long self);

    static final void setY2(Trapezoid self, double y2) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_trapezoid_set_y2(pointerOf(self), y2);
        }
    }

    private static native final void gdk_trapezoid_set_y2(long self, double y2);

    static final double getX12(Trapezoid self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_trapezoid_get_x12(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_trapezoid_get_x12(long self);

    static final void setX12(Trapezoid self, double x12) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_trapezoid_set_x12(pointerOf(self), x12);
        }
    }

    private static native final void gdk_trapezoid_set_x12(long self, double x12);

    static final double getX22(Trapezoid self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_trapezoid_get_x22(pointerOf(self));

            return result;
        }
    }

    private static native final double gdk_trapezoid_get_x22(long self);

    static final void setX22(Trapezoid self, double x22) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_trapezoid_set_x22(pointerOf(self), x22);
        }
    }

    private static native final void gdk_trapezoid_set_x22(long self, double x22);
}

