/*
 * GdkVisual.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.gnome.gdk.Plumbing;
import org.gnome.gdk.Screen;
import org.gnome.gdk.Visual;
import org.gnome.gdk.VisualType;

final class GdkVisual extends Plumbing
{
    private GdkVisual() {}

    static final long createVisualualGetBestWithBoth(int depth, VisualType visualType) {
        long result;

        if (visualType == null) {
            throw new IllegalArgumentException("visualType can't be null");
        }

        synchronized (lock) {
            result = gdk_visual_get_best_with_both(depth, numOf(visualType));

            return result;
        }
    }

    private static native final long gdk_visual_get_best_with_both(int depth, int visualType);

    static final Screen getScreen(Visual self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_visual_get_screen(pointerOf(self));

            return (Screen) objectFor(result);
        }
    }

    private static native final long gdk_visual_get_screen(long self);

    static final int getBestDepth() {
        int result;

        synchronized (lock) {
            result = gdk_visual_get_best_depth();

            return result;
        }
    }

    private static native final int gdk_visual_get_best_depth();
}

