/*
 * GdkWindow.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gdk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Bitmap;
import org.gnome.gdk.Color;
import org.gnome.gdk.Cursor;
import org.gnome.gdk.DragContext;
import org.gnome.gdk.Drawable;
import org.gnome.gdk.EventMask;
import org.gnome.gdk.ExtensionMode;
import org.gnome.gdk.Geometry;
import org.gnome.gdk.ModifierType;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.Pixmap;
import org.gnome.gdk.Plumbing;
import org.gnome.gdk.PropMode;
import org.gnome.gdk.Rectangle;
import org.gnome.gdk.Region;
import org.gnome.gdk.Window;
import org.gnome.gdk.WindowAttr;
import org.gnome.gdk.WindowEdge;
import org.gnome.gdk.WindowHints;
import org.gnome.gdk.WindowState;
import org.gnome.gdk.WindowType;
import org.gnome.gdk.WindowTypeHint;

final class GdkWindow extends Plumbing
{
    private GdkWindow() {}

    static final DragContext dragBegin(Window self, FIXME targets) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GList*");
    }

    static final void inputSetExtensionEvents(Window self, int mask, ExtensionMode mode) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mode == null) {
            throw new IllegalArgumentException("mode can't be null");
        }

        synchronized (lock) {
            gdk_input_set_extension_events(pointerOf(self), mask, numOf(mode));
        }
    }

    private static native final void gdk_input_set_extension_events(long self, int mask, int mode);

    static final boolean propertyGet(Window self, FIXME property, FIXME type, long offset, long length, int pdelete, FIXME actualPropertyType, int[] actualFormat, int[] actualLength, FIXME data) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void propertyChange(Window self, FIXME property, FIXME type, int format, PropMode mode, FIXME data, int nelements) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void propertyDelete(Window self, FIXME property) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void selectionConvert(Window self, FIXME selection, FIXME target, int time) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final boolean selectionPropertyGet(Window self, FIXME data, FIXME propType, int[] propFormat) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guchar**");
    }

    static final long createWindow(Window parent, WindowAttr attributes, int attributesMask) {
        long result;

        if (parent == null) {
            throw new IllegalArgumentException("parent can't be null");
        }

        if (attributes == null) {
            throw new IllegalArgumentException("attributes can't be null");
        }

        synchronized (lock) {
            result = gdk_window_new(pointerOf(parent), pointerOf(attributes), attributesMask);

            return result;
        }
    }

    private static native final long gdk_window_new(long parent, long attributes, int attributesMask);

    static final void setKeepAbove(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_keep_above(pointerOf(self), setting);
        }
    }

    private static native final void gdk_window_set_keep_above(long self, boolean setting);

    static final void setKeepBelow(Window self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_keep_below(pointerOf(self), setting);
        }
    }

    private static native final void gdk_window_set_keep_below(long self, boolean setting);

    static final void destroy(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_destroy(pointerOf(self));
        }
    }

    private static native final void gdk_window_destroy(long self);

    static final WindowType getWindowType(Window self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_get_window_type(pointerOf(self));

            return (WindowType) enumFor(WindowType.class, result);
        }
    }

    private static native final int gdk_window_get_window_type(long self);

    static final void show(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_show(pointerOf(self));
        }
    }

    private static native final void gdk_window_show(long self);

    static final void hide(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_hide(pointerOf(self));
        }
    }

    private static native final void gdk_window_hide(long self);

    static final void withdraw(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_withdraw(pointerOf(self));
        }
    }

    private static native final void gdk_window_withdraw(long self);

    static final void move(Window self, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_move(pointerOf(self), x, y);
        }
    }

    private static native final void gdk_window_move(long self, int x, int y);

    static final void resize(Window self, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_resize(pointerOf(self), width, height);
        }
    }

    private static native final void gdk_window_resize(long self, int width, int height);

    static final void moveResize(Window self, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_move_resize(pointerOf(self), x, y, width, height);
        }
    }

    private static native final void gdk_window_move_resize(long self, int x, int y, int width, int height);

    static final void reparent(Window self, Window newParent, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (newParent == null) {
            throw new IllegalArgumentException("newParent can't be null");
        }

        synchronized (lock) {
            gdk_window_reparent(pointerOf(self), pointerOf(newParent), x, y);
        }
    }

    private static native final void gdk_window_reparent(long self, long newParent, int x, int y);

    static final void clear(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_clear(pointerOf(self));
        }
    }

    private static native final void gdk_window_clear(long self);

    static final void clearArea(Window self, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_clear_area(pointerOf(self), x, y, width, height);
        }
    }

    private static native final void gdk_window_clear_area(long self, int x, int y, int width, int height);

    static final void clearAreaE(Window self, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_clear_area_e(pointerOf(self), x, y, width, height);
        }
    }

    private static native final void gdk_window_clear_area_e(long self, int x, int y, int width, int height);

    static final void raise(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_raise(pointerOf(self));
        }
    }

    private static native final void gdk_window_raise(long self);

    static final void lower(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_lower(pointerOf(self));
        }
    }

    private static native final void gdk_window_lower(long self);

    static final void focus(Window self, int timestamp) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_focus(pointerOf(self), timestamp);
        }
    }

    private static native final void gdk_window_focus(long self, int timestamp);

    static final void setUserData(Window self, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("gpointer");
    }

    static final void getUserData(Window self, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("gpointer*");
    }

    static final void setOverrideRedirect(Window self, boolean overrideRedirect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_override_redirect(pointerOf(self), overrideRedirect);
        }
    }

    private static native final void gdk_window_set_override_redirect(long self, boolean overrideRedirect);

    static final void addFilter(Window self, FIXME function, FIXME data) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkFilterFunc");
    }

    static final void removeFilter(Window self, FIXME function, FIXME data) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkFilterFunc");
    }

    static final void scroll(Window self, int dx, int dy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_scroll(pointerOf(self), dx, dy);
        }
    }

    private static native final void gdk_window_scroll(long self, int dx, int dy);

    static final void shapeCombineMask(Window self, Bitmap shapeMask, int offsetX, int offsetY) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_shape_combine_mask(pointerOf(self), pointerOf(shapeMask), offsetX, offsetY);
        }
    }

    private static native final void gdk_window_shape_combine_mask(long self, long shapeMask, int offsetX, int offsetY);

    static final void setChildShapes(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_child_shapes(pointerOf(self));
        }
    }

    private static native final void gdk_window_set_child_shapes(long self);

    static final void mergeChildShapes(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_merge_child_shapes(pointerOf(self));
        }
    }

    private static native final void gdk_window_merge_child_shapes(long self);

    static final boolean isVisible(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_is_visible(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_window_is_visible(long self);

    static final boolean isViewable(Window self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_is_viewable(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gdk_window_is_viewable(long self);

    static final WindowState getState(Window self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_get_state(pointerOf(self));

            return (WindowState) flagFor(WindowState.class, result);
        }
    }

    private static native final int gdk_window_get_state(long self);

    static final boolean setStaticGravities(Window self, boolean useStatic) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_set_static_gravities(pointerOf(self), useStatic);

            return result;
        }
    }

    private static native final boolean gdk_window_set_static_gravities(long self, boolean useStatic);

    static final void setTypeHint(Window self, WindowTypeHint hint) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (hint == null) {
            throw new IllegalArgumentException("hint can't be null");
        }

        synchronized (lock) {
            gdk_window_set_type_hint(pointerOf(self), numOf(hint));
        }
    }

    private static native final void gdk_window_set_type_hint(long self, int hint);

    static final void setModalHint(Window self, boolean modal) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_modal_hint(pointerOf(self), modal);
        }
    }

    private static native final void gdk_window_set_modal_hint(long self, boolean modal);

    static final void setSkipTaskbarHint(Window self, boolean modal) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_skip_taskbar_hint(pointerOf(self), modal);
        }
    }

    private static native final void gdk_window_set_skip_taskbar_hint(long self, boolean modal);

    static final void setSkipPagerHint(Window self, boolean modal) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_skip_pager_hint(pointerOf(self), modal);
        }
    }

    private static native final void gdk_window_set_skip_pager_hint(long self, boolean modal);

    static final void setGeometryHints(Window self, Geometry geometry, WindowHints flags) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (geometry == null) {
            throw new IllegalArgumentException("geometry can't be null");
        }

        if (flags == null) {
            throw new IllegalArgumentException("flags can't be null");
        }

        synchronized (lock) {
            gdk_window_set_geometry_hints(pointerOf(self), pointerOf(geometry), numOf(flags));
        }
    }

    private static native final void gdk_window_set_geometry_hints(long self, long geometry, int flags);

    static final void beginPaintRect(Window self, Rectangle rectangle) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rectangle == null) {
            throw new IllegalArgumentException("rectangle can't be null");
        }

        synchronized (lock) {
            gdk_window_begin_paint_rect(pointerOf(self), pointerOf(rectangle));
        }
    }

    private static native final void gdk_window_begin_paint_rect(long self, long rectangle);

    static final void beginPaintRegion(Window self, Region region) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (region == null) {
            throw new IllegalArgumentException("region can't be null");
        }

        synchronized (lock) {
            gdk_window_begin_paint_region(pointerOf(self), pointerOf(region));
        }
    }

    private static native final void gdk_window_begin_paint_region(long self, long region);

    static final void endPaint(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_end_paint(pointerOf(self));
        }
    }

    private static native final void gdk_window_end_paint(long self);

    static final void setTitle(Window self, String title) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        synchronized (lock) {
            gdk_window_set_title(pointerOf(self), title);
        }
    }

    private static native final void gdk_window_set_title(long self, String title);

    static final void setRole(Window self, String role) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (role == null) {
            throw new IllegalArgumentException("role can't be null");
        }

        synchronized (lock) {
            gdk_window_set_role(pointerOf(self), role);
        }
    }

    private static native final void gdk_window_set_role(long self, String role);

    static final void setTransientFor(Window self, Window leader) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (leader == null) {
            throw new IllegalArgumentException("leader can't be null");
        }

        synchronized (lock) {
            gdk_window_set_transient_for(pointerOf(self), pointerOf(leader));
        }
    }

    private static native final void gdk_window_set_transient_for(long self, long leader);

    static final void setBackground(Window self, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gdk_window_set_background(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gdk_window_set_background(long self, long color);

    static final void setBackPixmap(Window self, Pixmap pixmap, boolean parentRelative) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_back_pixmap(pointerOf(self), pointerOf(pixmap), parentRelative);
        }
    }

    private static native final void gdk_window_set_back_pixmap(long self, long pixmap, boolean parentRelative);

    static final void setCursor(Window self, Cursor cursor) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_cursor(pointerOf(self), pointerOf(cursor));
        }
    }

    private static native final void gdk_window_set_cursor(long self, long cursor);

    static final void getGeometry(Window self, int[] x, int[] y, int[] width, int[] height, int[] depth) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (x == null) {
            throw new IllegalArgumentException("x can't be null");
        }

        if (y == null) {
            throw new IllegalArgumentException("y can't be null");
        }

        if (width == null) {
            throw new IllegalArgumentException("width can't be null");
        }

        if (height == null) {
            throw new IllegalArgumentException("height can't be null");
        }

        if (depth == null) {
            throw new IllegalArgumentException("depth can't be null");
        }

        synchronized (lock) {
            gdk_window_get_geometry(pointerOf(self), x, y, width, height, depth);
        }
    }

    private static native final void gdk_window_get_geometry(long self, int[] x, int[] y, int[] width, int[] height, int[] depth);

    static final void getPosition(Window self, int[] x, int[] y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (x == null) {
            throw new IllegalArgumentException("x can't be null");
        }

        if (y == null) {
            throw new IllegalArgumentException("y can't be null");
        }

        synchronized (lock) {
            gdk_window_get_position(pointerOf(self), x, y);
        }
    }

    private static native final void gdk_window_get_position(long self, int[] x, int[] y);

    static final int getOrigin(Window self, int[] x, int[] y) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (x == null) {
            throw new IllegalArgumentException("x can't be null");
        }

        if (y == null) {
            throw new IllegalArgumentException("y can't be null");
        }

        synchronized (lock) {
            result = gdk_window_get_origin(pointerOf(self), x, y);

            return result;
        }
    }

    private static native final int gdk_window_get_origin(long self, int[] x, int[] y);

    static final void getRootOrigin(Window self, int[] x, int[] y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (x == null) {
            throw new IllegalArgumentException("x can't be null");
        }

        if (y == null) {
            throw new IllegalArgumentException("y can't be null");
        }

        synchronized (lock) {
            gdk_window_get_root_origin(pointerOf(self), x, y);
        }
    }

    private static native final void gdk_window_get_root_origin(long self, int[] x, int[] y);

    static final void getFrameExtents(Window self, Rectangle rect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rect == null) {
            throw new IllegalArgumentException("rect can't be null");
        }

        synchronized (lock) {
            gdk_window_get_frame_extents(pointerOf(self), pointerOf(rect));
        }
    }

    private static native final void gdk_window_get_frame_extents(long self, long rect);

    static final Window getPointer(Window self, int[] x, int[] y, ModifierType[] mask) {
        long result;
        int[] _mask;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (x == null) {
            throw new IllegalArgumentException("x can't be null");
        }

        if (y == null) {
            throw new IllegalArgumentException("y can't be null");
        }

        if (mask == null) {
            throw new IllegalArgumentException("mask can't be null");
        }

        _mask = numsOf(mask);

        synchronized (lock) {
            result = gdk_window_get_pointer(pointerOf(self), x, y, _mask);
            fillFlagArray(ModifierType.class, mask, _mask);

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_window_get_pointer(long self, int[] x, int[] y, int[] mask);

    static final Window getParent(Window self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_get_parent(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_window_get_parent(long self);

    static final Window getToplevel(Window self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_get_toplevel(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_window_get_toplevel(long self);

    static final Window[] getChildren(Window self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_get_children(pointerOf(self));

            return (Window[]) objectArrayFor(result, new Window[result.length]);
        }
    }

    private static native final long[] gdk_window_get_children(long self);

    static final Window[] peekChildren(Window self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_peek_children(pointerOf(self));

            return (Window[]) objectArrayFor(result, new Window[result.length]);
        }
    }

    private static native final long[] gdk_window_peek_children(long self);

    static final EventMask getEvents(Window self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_get_events(pointerOf(self));

            return (EventMask) flagFor(EventMask.class, result);
        }
    }

    private static native final int gdk_window_get_events(long self);

    static final void setEvents(Window self, EventMask eventMask) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (eventMask == null) {
            throw new IllegalArgumentException("eventMask can't be null");
        }

        synchronized (lock) {
            gdk_window_set_events(pointerOf(self), numOf(eventMask));
        }
    }

    private static native final void gdk_window_set_events(long self, int eventMask);

    static final void setIconList(Window self, Pixbuf[] pixbufs) {
        long[] _pixbufs;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pixbufs == null) {
            throw new IllegalArgumentException("pixbufs can't be null");
        }

        _pixbufs = pointersOf(pixbufs);

        synchronized (lock) {
            gdk_window_set_icon_list(pointerOf(self), _pixbufs);
            fillObjectArray(pixbufs, _pixbufs);
        }
    }

    private static native final void gdk_window_set_icon_list(long self, long[] pixbufs);

    static final void setIcon(Window self, Window iconWindow, Pixmap pixmap, Bitmap mask) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconWindow == null) {
            throw new IllegalArgumentException("iconWindow can't be null");
        }

        if (pixmap == null) {
            throw new IllegalArgumentException("pixmap can't be null");
        }

        if (mask == null) {
            throw new IllegalArgumentException("mask can't be null");
        }

        synchronized (lock) {
            gdk_window_set_icon(pointerOf(self), pointerOf(iconWindow), pointerOf(pixmap), pointerOf(mask));
        }
    }

    private static native final void gdk_window_set_icon(long self, long iconWindow, long pixmap, long mask);

    static final void setIconName(Window self, String name) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            gdk_window_set_icon_name(pointerOf(self), name);
        }
    }

    private static native final void gdk_window_set_icon_name(long self, String name);

    static final void setGroup(Window self, Window leader) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (leader == null) {
            throw new IllegalArgumentException("leader can't be null");
        }

        synchronized (lock) {
            gdk_window_set_group(pointerOf(self), pointerOf(leader));
        }
    }

    private static native final void gdk_window_set_group(long self, long leader);

    static final Window getGroup(Window self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_get_group(pointerOf(self));

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_window_get_group(long self);

    static final void iconify(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_iconify(pointerOf(self));
        }
    }

    private static native final void gdk_window_iconify(long self);

    static final void deiconify(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_deiconify(pointerOf(self));
        }
    }

    private static native final void gdk_window_deiconify(long self);

    static final void stick(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_stick(pointerOf(self));
        }
    }

    private static native final void gdk_window_stick(long self);

    static final void unstick(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_unstick(pointerOf(self));
        }
    }

    private static native final void gdk_window_unstick(long self);

    static final void maximize(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_maximize(pointerOf(self));
        }
    }

    private static native final void gdk_window_maximize(long self);

    static final void unmaximize(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_unmaximize(pointerOf(self));
        }
    }

    private static native final void gdk_window_unmaximize(long self);

    static final void fullscreen(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_fullscreen(pointerOf(self));
        }
    }

    private static native final void gdk_window_fullscreen(long self);

    static final void unfullscreen(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_unfullscreen(pointerOf(self));
        }
    }

    private static native final void gdk_window_unfullscreen(long self);

    static final void registerDnd(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_register_dnd(pointerOf(self));
        }
    }

    private static native final void gdk_window_register_dnd(long self);

    static final void beginResizeDrag(Window self, WindowEdge edge, int button, int rootX, int rootY, int timestamp) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (edge == null) {
            throw new IllegalArgumentException("edge can't be null");
        }

        synchronized (lock) {
            gdk_window_begin_resize_drag(pointerOf(self), numOf(edge), button, rootX, rootY, timestamp);
        }
    }

    private static native final void gdk_window_begin_resize_drag(long self, int edge, int button, int rootX, int rootY, int timestamp);

    static final void beginMoveDrag(Window self, int button, int rootX, int rootY, int timestamp) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_begin_move_drag(pointerOf(self), button, rootX, rootY, timestamp);
        }
    }

    private static native final void gdk_window_begin_move_drag(long self, int button, int rootX, int rootY, int timestamp);

    static final void invalidateRect(Window self, Rectangle rect, boolean invalidateChildren) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_invalidate_rect(pointerOf(self), pointerOf(rect), invalidateChildren);
        }
    }

    private static native final void gdk_window_invalidate_rect(long self, long rect, boolean invalidateChildren);

    static final void invalidateRegion(Window self, Region region, boolean invalidateChildren) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (region == null) {
            throw new IllegalArgumentException("region can't be null");
        }

        synchronized (lock) {
            gdk_window_invalidate_region(pointerOf(self), pointerOf(region), invalidateChildren);
        }
    }

    private static native final void gdk_window_invalidate_region(long self, long region, boolean invalidateChildren);

    static final Region getUpdateArea(Window self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_get_update_area(pointerOf(self));

            return (Region) boxedFor(Region.class, result);
        }
    }

    private static native final long gdk_window_get_update_area(long self);

    static final void freezeUpdates(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_freeze_updates(pointerOf(self));
        }
    }

    private static native final void gdk_window_freeze_updates(long self);

    static final void thawUpdates(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_thaw_updates(pointerOf(self));
        }
    }

    private static native final void gdk_window_thaw_updates(long self);

    static final void processUpdates(Window self, boolean updateChildren) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_process_updates(pointerOf(self), updateChildren);
        }
    }

    private static native final void gdk_window_process_updates(long self, boolean updateChildren);

    static final void getInternalPaintInfo(Window self, Drawable[] realDrawable, int[] xOffset, int[] yOffset) {
        long[] _realDrawable;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (realDrawable == null) {
            throw new IllegalArgumentException("realDrawable can't be null");
        }

        if (xOffset == null) {
            throw new IllegalArgumentException("xOffset can't be null");
        }

        if (yOffset == null) {
            throw new IllegalArgumentException("yOffset can't be null");
        }

        _realDrawable = pointersOf(realDrawable);

        synchronized (lock) {
            gdk_window_get_internal_paint_info(pointerOf(self), _realDrawable, xOffset, yOffset);
            fillObjectArray(realDrawable, _realDrawable);
        }
    }

    private static native final void gdk_window_get_internal_paint_info(long self, long[] realDrawable, int[] xOffset, int[] yOffset);

    static final void setAcceptFocus(Window self, boolean acceptFocus) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_accept_focus(pointerOf(self), acceptFocus);
        }
    }

    private static native final void gdk_window_set_accept_focus(long self, boolean acceptFocus);

    static final void setFocusOnMap(Window self, boolean focusOnMap) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_focus_on_map(pointerOf(self), focusOnMap);
        }
    }

    private static native final void gdk_window_set_focus_on_map(long self, boolean focusOnMap);

    static final void enableSynchronizedConfigure(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_enable_synchronized_configure(pointerOf(self));
        }
    }

    private static native final void gdk_window_enable_synchronized_configure(long self);

    static final void configureFinished(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_configure_finished(pointerOf(self));
        }
    }

    private static native final void gdk_window_configure_finished(long self);

    static final void setUrgencyHint(Window self, boolean urgent) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_urgency_hint(pointerOf(self), urgent);
        }
    }

    private static native final void gdk_window_set_urgency_hint(long self, boolean urgent);

    static final void showUnraised(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_show_unraised(pointerOf(self));
        }
    }

    private static native final void gdk_window_show_unraised(long self);

    static final void moveRegion(Window self, Region region, int dx, int dy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (region == null) {
            throw new IllegalArgumentException("region can't be null");
        }

        synchronized (lock) {
            gdk_window_move_region(pointerOf(self), pointerOf(region), dx, dy);
        }
    }

    private static native final void gdk_window_move_region(long self, long region, int dx, int dy);

    static final void shapeCombineRegion(Window self, Region shapeRegion, int offsetX, int offsetY) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_shape_combine_region(pointerOf(self), pointerOf(shapeRegion), offsetX, offsetY);
        }
    }

    private static native final void gdk_window_shape_combine_region(long self, long shapeRegion, int offsetX, int offsetY);

    static final void inputShapeCombineMask(Window self, Bitmap mask, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (mask == null) {
            throw new IllegalArgumentException("mask can't be null");
        }

        synchronized (lock) {
            gdk_window_input_shape_combine_mask(pointerOf(self), pointerOf(mask), x, y);
        }
    }

    private static native final void gdk_window_input_shape_combine_mask(long self, long mask, int x, int y);

    static final void inputShapeCombineRegion(Window self, Region shapeRegion, int offsetX, int offsetY) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (shapeRegion == null) {
            throw new IllegalArgumentException("shapeRegion can't be null");
        }

        synchronized (lock) {
            gdk_window_input_shape_combine_region(pointerOf(self), pointerOf(shapeRegion), offsetX, offsetY);
        }
    }

    private static native final void gdk_window_input_shape_combine_region(long self, long shapeRegion, int offsetX, int offsetY);

    static final void setChildInputShapes(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_set_child_input_shapes(pointerOf(self));
        }
    }

    private static native final void gdk_window_set_child_input_shapes(long self);

    static final void mergeChildInputShapes(Window self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gdk_window_merge_child_input_shapes(pointerOf(self));
        }
    }

    private static native final void gdk_window_merge_child_input_shapes(long self);

    static final WindowTypeHint getTypeHint(Window self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gdk_window_get_type_hint(pointerOf(self));

            return (WindowTypeHint) enumFor(WindowTypeHint.class, result);
        }
    }

    private static native final int gdk_window_get_type_hint(long self);

    static final Window getDefaultRootWindow() {
        long result;

        synchronized (lock) {
            result = gdk_get_default_root_window();

            return (Window) objectFor(result);
        }
    }

    private static native final long gdk_get_default_root_window();
}

