/*
 * GtkAccelLabel.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gtk.AccelLabel;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkAccelLabel extends Plumbing
{
    private GtkAccelLabel() {}

    static final long createAccelLabel(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_accel_label_new(label);

            return result;
        }
    }

    private static native final long gtk_accel_label_new(String label);

    static final Widget getAccelWidget(AccelLabel self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_accel_label_get_accel_widget(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_accel_label_get_accel_widget(long self);

    static final int getAccelWidth(AccelLabel self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_accel_label_get_accel_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_accel_label_get_accel_width(long self);

    static final void setAccelWidget(AccelLabel self, Widget accelWidget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (accelWidget == null) {
            throw new IllegalArgumentException("accelWidget can't be null");
        }

        synchronized (lock) {
            gtk_accel_label_set_accel_widget(pointerOf(self), pointerOf(accelWidget));
        }
    }

    private static native final void gtk_accel_label_set_accel_widget(long self, long accelWidget);

    static final void setAccelClosure(AccelLabel self, FIXME accelClosure) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GClosure*");
    }

    static final boolean refetch(AccelLabel self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_accel_label_refetch(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_accel_label_refetch(long self);
}

