/*
 * GtkActionGroup.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.gtk.Action;
import org.gnome.gtk.ActionGroup;
import org.gnome.gtk.Plumbing;

final class GtkActionGroup extends Plumbing
{
    private GtkActionGroup() {}

    static final long createActionGroup(String name) {
        long result;

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            result = gtk_action_group_new(name);

            return result;
        }
    }

    private static native final long gtk_action_group_new(String name);

    static final String getName(ActionGroup self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_group_get_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_action_group_get_name(long self);

    static final boolean getSensitive(ActionGroup self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_group_get_sensitive(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_action_group_get_sensitive(long self);

    static final void setSensitive(ActionGroup self, boolean sensitive) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_action_group_set_sensitive(pointerOf(self), sensitive);
        }
    }

    private static native final void gtk_action_group_set_sensitive(long self, boolean sensitive);

    static final boolean getVisible(ActionGroup self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_group_get_visible(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_action_group_get_visible(long self);

    static final void setVisible(ActionGroup self, boolean visible) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_action_group_set_visible(pointerOf(self), visible);
        }
    }

    private static native final void gtk_action_group_set_visible(long self, boolean visible);

    static final Action getAction(ActionGroup self, String actionName) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (actionName == null) {
            throw new IllegalArgumentException("actionName can't be null");
        }

        synchronized (lock) {
            result = gtk_action_group_get_action(pointerOf(self), actionName);

            return (Action) objectFor(result);
        }
    }

    private static native final long gtk_action_group_get_action(long self, String actionName);

    static final Action[] listActions(ActionGroup self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_action_group_list_actions(pointerOf(self));

            return (Action[]) objectArrayFor(result, new Action[result.length]);
        }
    }

    private static native final long[] gtk_action_group_list_actions(long self);

    static final void addAction(ActionGroup self, Action action) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (action == null) {
            throw new IllegalArgumentException("action can't be null");
        }

        synchronized (lock) {
            gtk_action_group_add_action(pointerOf(self), pointerOf(action));
        }
    }

    private static native final void gtk_action_group_add_action(long self, long action);

    static final void addActionWithAccel(ActionGroup self, Action action, String accelerator) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (action == null) {
            throw new IllegalArgumentException("action can't be null");
        }

        synchronized (lock) {
            gtk_action_group_add_action_with_accel(pointerOf(self), pointerOf(action), accelerator);
        }
    }

    private static native final void gtk_action_group_add_action_with_accel(long self, long action, String accelerator);

    static final void removeAction(ActionGroup self, Action action) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (action == null) {
            throw new IllegalArgumentException("action can't be null");
        }

        synchronized (lock) {
            gtk_action_group_remove_action(pointerOf(self), pointerOf(action));
        }
    }

    private static native final void gtk_action_group_remove_action(long self, long action);

    static final void addActions(ActionGroup self, FIXME entries, int nEntries, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkActionEntry*");
    }

    static final void addToggleActions(ActionGroup self, FIXME entries, int nEntries, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkToggleActionEntry*");
    }

    static final void addRadioActions(ActionGroup self, FIXME entries, int nEntries, int value, FIXME onChange, FIXME userData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkRadioActionEntry*");
    }

    static final void addActionsFull(ActionGroup self, FIXME entries, int nEntries, FIXME userData, FIXME destroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkActionEntry*");
    }

    static final void addToggleActionsFull(ActionGroup self, FIXME entries, int nEntries, FIXME userData, FIXME destroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkToggleActionEntry*");
    }

    static final void addRadioActionsFull(ActionGroup self, FIXME entries, int nEntries, int value, FIXME onChange, FIXME userData, FIXME destroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkRadioActionEntry*");
    }

    static final void setTranslateFunc(ActionGroup self, FIXME func, FIXME data, FIXME notify) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTranslateFunc");
    }

    static final void setTranslationDomain(ActionGroup self, String domain) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (domain == null) {
            throw new IllegalArgumentException("domain can't be null");
        }

        synchronized (lock) {
            gtk_action_group_set_translation_domain(pointerOf(self), domain);
        }
    }

    private static native final void gtk_action_group_set_translation_domain(long self, String domain);

    static final String translateString(ActionGroup self, String string) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (string == null) {
            throw new IllegalArgumentException("string can't be null");
        }

        synchronized (lock) {
            result = gtk_action_group_translate_string(pointerOf(self), string);

            return result;
        }
    }

    private static native final String gtk_action_group_translate_string(long self, String string);

    interface GetActionSignal extends Signal
    {
        Action onGetAction(ActionGroup source, String actionName);
    }

    static final void connect(ActionGroup self, GtkActionGroup.GetActionSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkActionGroup.class, "get-action", after);
    }

    protected static final long receiveGetAction(Signal handler, long source, String actionName) {
        Action result;

        result = ((GtkActionGroup.GetActionSignal) handler).onGetAction((ActionGroup) objectFor(source), actionName);

        return pointerOf(result);
    }
}

