/*
 * GtkAdjustment.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Adjustment;
import org.gnome.gtk.Plumbing;

final class GtkAdjustment extends Plumbing
{
    private GtkAdjustment() {}

    static final long createAdjustment(double value, double lower, double upper, double stepIncrement, double pageIncrement, double pageSize) {
        long result;

        synchronized (lock) {
            result = gtk_adjustment_new(value, lower, upper, stepIncrement, pageIncrement, pageSize);

            return result;
        }
    }

    private static native final long gtk_adjustment_new(double value, double lower, double upper, double stepIncrement, double pageIncrement, double pageSize);

    static final void changed(Adjustment self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_adjustment_changed(pointerOf(self));
        }
    }

    private static native final void gtk_adjustment_changed(long self);

    static final void valueChanged(Adjustment self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_adjustment_value_changed(pointerOf(self));
        }
    }

    private static native final void gtk_adjustment_value_changed(long self);

    static final void clampPage(Adjustment self, double lower, double upper) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_adjustment_clamp_page(pointerOf(self), lower, upper);
        }
    }

    private static native final void gtk_adjustment_clamp_page(long self, double lower, double upper);

    static final double getValue(Adjustment self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_adjustment_get_value(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_adjustment_get_value(long self);

    static final void setValue(Adjustment self, double value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_adjustment_set_value(pointerOf(self), value);
        }
    }

    private static native final void gtk_adjustment_set_value(long self, double value);

    static final double getPageIncrement(Adjustment self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_adjustment_get_page_increment(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_adjustment_get_page_increment(long self);

    static final void setPageIncrement(Adjustment self, double value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_adjustment_set_page_increment(pointerOf(self), value);
        }
    }

    private static native final void gtk_adjustment_set_page_increment(long self, double value);

    static final double getStepIncrement(Adjustment self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_adjustment_get_step_increment(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_adjustment_get_step_increment(long self);

    static final void setStepIncrement(Adjustment self, double value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_adjustment_set_step_increment(pointerOf(self), value);
        }
    }

    private static native final void gtk_adjustment_set_step_increment(long self, double value);

    static final double getUpper(Adjustment self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_adjustment_get_upper(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_adjustment_get_upper(long self);

    static final void setUpper(Adjustment self, double value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_adjustment_set_upper(pointerOf(self), value);
        }
    }

    private static native final void gtk_adjustment_set_upper(long self, double value);

    static final double getLower(Adjustment self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_adjustment_get_lower(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_adjustment_get_lower(long self);

    static final void setLower(Adjustment self, double value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_adjustment_set_lower(pointerOf(self), value);
        }
    }

    private static native final void gtk_adjustment_set_lower(long self, double value);

    static final double getPageSize(Adjustment self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_adjustment_get_page_size(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_adjustment_get_page_size(long self);

    static final void setPageSize(Adjustment self, double value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_adjustment_set_page_size(pointerOf(self), value);
        }
    }

    private static native final void gtk_adjustment_set_page_size(long self, double value);

    interface ChangedSignal extends Signal
    {
        void onChanged(Adjustment source);
    }

    static final void connect(Adjustment self, GtkAdjustment.ChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAdjustment.class, "changed", after);
    }

    protected static final void receiveChanged(Signal handler, long source) {
        ((GtkAdjustment.ChangedSignal) handler).onChanged((Adjustment) objectFor(source));
    }

    interface ValueChangedSignal extends Signal
    {
        void onValueChanged(Adjustment source);
    }

    static final void connect(Adjustment self, GtkAdjustment.ValueChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkAdjustment.class, "value-changed", after);
    }

    protected static final void receiveValueChanged(Signal handler, long source) {
        ((GtkAdjustment.ValueChangedSignal) handler).onValueChanged((Adjustment) objectFor(source));
    }
}

