/*
 * GtkAspectFrame.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.AspectFrame;
import org.gnome.gtk.Plumbing;

final class GtkAspectFrame extends Plumbing
{
    private GtkAspectFrame() {}

    static final long createAspectFrame(String label, float xalign, float yalign, float ratio, boolean obeyChild) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_aspect_frame_new(label, xalign, yalign, ratio, obeyChild);

            return result;
        }
    }

    private static native final long gtk_aspect_frame_new(String label, float xalign, float yalign, float ratio, boolean obeyChild);

    static final void set(AspectFrame self, float xalign, float yalign, float ratio, boolean obeyChild) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_aspect_frame_set(pointerOf(self), xalign, yalign, ratio, obeyChild);
        }
    }

    private static native final void gtk_aspect_frame_set(long self, float xalign, float yalign, float ratio, boolean obeyChild);
}

