/*
 * GtkButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Button;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.PositionType;
import org.gnome.gtk.ReliefStyle;
import org.gnome.gtk.Widget;

final class GtkButton extends Plumbing
{
    private GtkButton() {}

    static final long createButton() {
        long result;

        synchronized (lock) {
            result = gtk_button_new();

            return result;
        }
    }

    private static native final long gtk_button_new();

    static final long createButtonWithLabel(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_button_new_with_label(label);

            return result;
        }
    }

    private static native final long gtk_button_new_with_label(String label);

    static final long createButtonWithMnemonic(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_button_new_with_mnemonic(label);

            return result;
        }
    }

    private static native final long gtk_button_new_with_mnemonic(String label);

    static final long createButtonFromStock(String stockId) {
        long result;

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            result = gtk_button_new_from_stock(stockId);

            return result;
        }
    }

    private static native final long gtk_button_new_from_stock(String stockId);

    static final void pressed(Button self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_button_pressed(pointerOf(self));
        }
    }

    private static native final void gtk_button_pressed(long self);

    static final void released(Button self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_button_released(pointerOf(self));
        }
    }

    private static native final void gtk_button_released(long self);

    static final void clicked(Button self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_button_clicked(pointerOf(self));
        }
    }

    private static native final void gtk_button_clicked(long self);

    static final void enter(Button self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_button_enter(pointerOf(self));
        }
    }

    private static native final void gtk_button_enter(long self);

    static final void leave(Button self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_button_leave(pointerOf(self));
        }
    }

    private static native final void gtk_button_leave(long self);

    static final void setRelief(Button self, ReliefStyle newstyle) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (newstyle == null) {
            throw new IllegalArgumentException("newstyle can't be null");
        }

        synchronized (lock) {
            gtk_button_set_relief(pointerOf(self), numOf(newstyle));
        }
    }

    private static native final void gtk_button_set_relief(long self, int newstyle);

    static final ReliefStyle getRelief(Button self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_button_get_relief(pointerOf(self));

            return (ReliefStyle) enumFor(ReliefStyle.class, result);
        }
    }

    private static native final int gtk_button_get_relief(long self);

    static final void setLabel(Button self, String label) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            gtk_button_set_label(pointerOf(self), label);
        }
    }

    private static native final void gtk_button_set_label(long self, String label);

    static final String getLabel(Button self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_button_get_label(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_button_get_label(long self);

    static final void setUseUnderline(Button self, boolean useUnderline) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_button_set_use_underline(pointerOf(self), useUnderline);
        }
    }

    private static native final void gtk_button_set_use_underline(long self, boolean useUnderline);

    static final boolean getUseUnderline(Button self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_button_get_use_underline(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_button_get_use_underline(long self);

    static final void setUseStock(Button self, boolean useStock) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_button_set_use_stock(pointerOf(self), useStock);
        }
    }

    private static native final void gtk_button_set_use_stock(long self, boolean useStock);

    static final boolean getUseStock(Button self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_button_get_use_stock(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_button_get_use_stock(long self);

    static final void setFocusOnClick(Button self, boolean focusOnClick) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_button_set_focus_on_click(pointerOf(self), focusOnClick);
        }
    }

    private static native final void gtk_button_set_focus_on_click(long self, boolean focusOnClick);

    static final boolean getFocusOnClick(Button self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_button_get_focus_on_click(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_button_get_focus_on_click(long self);

    static final void setAlignment(Button self, float xalign, float yalign) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_button_set_alignment(pointerOf(self), xalign, yalign);
        }
    }

    private static native final void gtk_button_set_alignment(long self, float xalign, float yalign);

    static final void getAlignment(Button self, float[] xalign, float[] yalign) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (xalign == null) {
            throw new IllegalArgumentException("xalign can't be null");
        }

        if (yalign == null) {
            throw new IllegalArgumentException("yalign can't be null");
        }

        synchronized (lock) {
            gtk_button_get_alignment(pointerOf(self), xalign, yalign);
        }
    }

    private static native final void gtk_button_get_alignment(long self, float[] xalign, float[] yalign);

    static final void setImage(Button self, Widget image) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_button_set_image(pointerOf(self), pointerOf(image));
        }
    }

    private static native final void gtk_button_set_image(long self, long image);

    static final Widget getImage(Button self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_button_get_image(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_button_get_image(long self);

    interface PressedSignal extends Signal
    {
        void onPressed(Button source);
    }

    static final void connect(Button self, GtkButton.PressedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkButton.class, "pressed", after);
    }

    protected static final void receivePressed(Signal handler, long source) {
        ((GtkButton.PressedSignal) handler).onPressed((Button) objectFor(source));
    }

    interface ReleasedSignal extends Signal
    {
        void onReleased(Button source);
    }

    static final void connect(Button self, GtkButton.ReleasedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkButton.class, "released", after);
    }

    protected static final void receiveReleased(Signal handler, long source) {
        ((GtkButton.ReleasedSignal) handler).onReleased((Button) objectFor(source));
    }

    interface ClickedSignal extends Signal
    {
        void onClicked(Button source);
    }

    static final void connect(Button self, GtkButton.ClickedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkButton.class, "clicked", after);
    }

    protected static final void receiveClicked(Signal handler, long source) {
        ((GtkButton.ClickedSignal) handler).onClicked((Button) objectFor(source));
    }

    interface EnterSignal extends Signal
    {
        void onEnter(Button source);
    }

    static final void connect(Button self, GtkButton.EnterSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkButton.class, "enter", after);
    }

    protected static final void receiveEnter(Signal handler, long source) {
        ((GtkButton.EnterSignal) handler).onEnter((Button) objectFor(source));
    }

    interface LeaveSignal extends Signal
    {
        void onLeave(Button source);
    }

    static final void connect(Button self, GtkButton.LeaveSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkButton.class, "leave", after);
    }

    protected static final void receiveLeave(Signal handler, long source) {
        ((GtkButton.LeaveSignal) handler).onLeave((Button) objectFor(source));
    }

    interface ActivateSignal extends Signal
    {
        void onActivate(Button source);
    }

    static final void connect(Button self, GtkButton.ActivateSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkButton.class, "activate", after);
    }

    protected static final void receiveActivate(Signal handler, long source) {
        ((GtkButton.ActivateSignal) handler).onActivate((Button) objectFor(source));
    }

    static final void setImagePosition(Button self, PositionType position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (position == null) {
            throw new IllegalArgumentException("position can't be null");
        }

        synchronized (lock) {
            gtk_button_set_image_position(pointerOf(self), numOf(position));
        }
    }

    private static native final void gtk_button_set_image_position(long self, int position);

    static final PositionType getImagePosition(Button self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_button_get_image_position(pointerOf(self));

            return (PositionType) enumFor(PositionType.class, result);
        }
    }

    private static native final int gtk_button_get_image_position(long self);
}

