/*
 * GtkButtonBox.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.ButtonBox;
import org.gnome.gtk.ButtonBoxStyle;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkButtonBox extends Plumbing
{
    private GtkButtonBox() {}

    static final ButtonBoxStyle getLayout(ButtonBox self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_button_box_get_layout(pointerOf(self));

            return (ButtonBoxStyle) enumFor(ButtonBoxStyle.class, result);
        }
    }

    private static native final int gtk_button_box_get_layout(long self);

    static final void setLayout(ButtonBox self, ButtonBoxStyle layoutStyle) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (layoutStyle == null) {
            throw new IllegalArgumentException("layoutStyle can't be null");
        }

        synchronized (lock) {
            gtk_button_box_set_layout(pointerOf(self), numOf(layoutStyle));
        }
    }

    private static native final void gtk_button_box_set_layout(long self, int layoutStyle);

    static final boolean getChildSecondary(ButtonBox self, Widget child) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            result = gtk_button_box_get_child_secondary(pointerOf(self), pointerOf(child));

            return result;
        }
    }

    private static native final boolean gtk_button_box_get_child_secondary(long self, long child);

    static final void setChildSecondary(ButtonBox self, Widget child, boolean isSecondary) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_button_box_set_child_secondary(pointerOf(self), pointerOf(child), isSecondary);
        }
    }

    private static native final void gtk_button_box_set_child_secondary(long self, long child, boolean isSecondary);
}

