/*
 * GtkCellRenderer.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Drawable;
import org.gnome.gdk.Event;
import org.gnome.gdk.Rectangle;
import org.gnome.gdk.Window;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.CellEditable;
import org.gnome.gtk.CellRenderer;
import org.gnome.gtk.CellRendererState;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkCellRenderer extends Plumbing
{
    private GtkCellRenderer() {}

    static final void getSize(CellRenderer self, Widget widget, Rectangle cellArea, int[] xOffset, int[] yOffset, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (widget == null) {
            throw new IllegalArgumentException("widget can't be null");
        }

        if (cellArea == null) {
            throw new IllegalArgumentException("cellArea can't be null");
        }

        if (xOffset == null) {
            throw new IllegalArgumentException("xOffset can't be null");
        }

        if (yOffset == null) {
            throw new IllegalArgumentException("yOffset can't be null");
        }

        if (width == null) {
            throw new IllegalArgumentException("width can't be null");
        }

        if (height == null) {
            throw new IllegalArgumentException("height can't be null");
        }

        synchronized (lock) {
            gtk_cell_renderer_get_size(pointerOf(self), pointerOf(widget), pointerOf(cellArea), xOffset, yOffset, width, height);
        }
    }

    private static native final void gtk_cell_renderer_get_size(long self, long widget, long cellArea, int[] xOffset, int[] yOffset, int[] width, int[] height);

    static final void render(CellRenderer self, Window window, Widget widget, Rectangle backgroundArea, Rectangle cellArea, Rectangle exposeArea, CellRendererState flags) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        if (widget == null) {
            throw new IllegalArgumentException("widget can't be null");
        }

        if (backgroundArea == null) {
            throw new IllegalArgumentException("backgroundArea can't be null");
        }

        if (cellArea == null) {
            throw new IllegalArgumentException("cellArea can't be null");
        }

        if (exposeArea == null) {
            throw new IllegalArgumentException("exposeArea can't be null");
        }

        if (flags == null) {
            throw new IllegalArgumentException("flags can't be null");
        }

        synchronized (lock) {
            gtk_cell_renderer_render(pointerOf(self), pointerOf(window), pointerOf(widget), pointerOf(backgroundArea), pointerOf(cellArea), pointerOf(exposeArea), numOf(flags));
        }
    }

    private static native final void gtk_cell_renderer_render(long self, long window, long widget, long backgroundArea, long cellArea, long exposeArea, int flags);

    static final boolean activate(CellRenderer self, Event event, Widget widget, String path, Rectangle backgroundArea, Rectangle cellArea, CellRendererState flags) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        if (widget == null) {
            throw new IllegalArgumentException("widget can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        if (backgroundArea == null) {
            throw new IllegalArgumentException("backgroundArea can't be null");
        }

        if (cellArea == null) {
            throw new IllegalArgumentException("cellArea can't be null");
        }

        if (flags == null) {
            throw new IllegalArgumentException("flags can't be null");
        }

        synchronized (lock) {
            result = gtk_cell_renderer_activate(pointerOf(self), pointerOf(event), pointerOf(widget), path, pointerOf(backgroundArea), pointerOf(cellArea), numOf(flags));

            return result;
        }
    }

    private static native final boolean gtk_cell_renderer_activate(long self, long event, long widget, String path, long backgroundArea, long cellArea, int flags);

    static final CellEditable startEditing(CellRenderer self, Event event, Widget widget, String path, Rectangle backgroundArea, Rectangle cellArea, CellRendererState flags) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        if (widget == null) {
            throw new IllegalArgumentException("widget can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        if (backgroundArea == null) {
            throw new IllegalArgumentException("backgroundArea can't be null");
        }

        if (cellArea == null) {
            throw new IllegalArgumentException("cellArea can't be null");
        }

        if (flags == null) {
            throw new IllegalArgumentException("flags can't be null");
        }

        synchronized (lock) {
            result = gtk_cell_renderer_start_editing(pointerOf(self), pointerOf(event), pointerOf(widget), path, pointerOf(backgroundArea), pointerOf(cellArea), numOf(flags));

            return (CellEditable) objectFor(result);
        }
    }

    private static native final long gtk_cell_renderer_start_editing(long self, long event, long widget, String path, long backgroundArea, long cellArea, int flags);

    static final void setFixedSize(CellRenderer self, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_cell_renderer_set_fixed_size(pointerOf(self), width, height);
        }
    }

    private static native final void gtk_cell_renderer_set_fixed_size(long self, int width, int height);

    static final void getFixedSize(CellRenderer self, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (width == null) {
            throw new IllegalArgumentException("width can't be null");
        }

        if (height == null) {
            throw new IllegalArgumentException("height can't be null");
        }

        synchronized (lock) {
            gtk_cell_renderer_get_fixed_size(pointerOf(self), width, height);
        }
    }

    private static native final void gtk_cell_renderer_get_fixed_size(long self, int[] width, int[] height);

    static final void stopEditing(CellRenderer self, boolean canceled) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_cell_renderer_stop_editing(pointerOf(self), canceled);
        }
    }

    private static native final void gtk_cell_renderer_stop_editing(long self, boolean canceled);

    interface GetSizeSignal extends Signal
    {
        void onGetSize(CellRenderer source, Widget widget, Rectangle cellArea, int[] xOffset, int[] yOffset, int[] width, int[] height);
    }

    static final void connect(CellRenderer self, GtkCellRenderer.GetSizeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCellRenderer.class, "get-size", after);
    }

    protected static final void receiveGetSize(Signal handler, long source, long widget, long cellArea, int[] xOffset, int[] yOffset, int[] width, int[] height) {
        ((GtkCellRenderer.GetSizeSignal) handler).onGetSize((CellRenderer) objectFor(source), (Widget) objectFor(widget), (Rectangle) boxedFor(Rectangle.class, cellArea), xOffset, yOffset, width, height);
    }

    interface RenderSignal extends Signal
    {
        void onRender(CellRenderer source, Drawable window, Widget widget, Rectangle backgroundArea, Rectangle cellArea, Rectangle exposeArea, CellRendererState flags);
    }

    static final void connect(CellRenderer self, GtkCellRenderer.RenderSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCellRenderer.class, "render", after);
    }

    protected static final void receiveRender(Signal handler, long source, long window, long widget, long backgroundArea, long cellArea, long exposeArea, int flags) {
        ((GtkCellRenderer.RenderSignal) handler).onRender((CellRenderer) objectFor(source), (Drawable) objectFor(window), (Widget) objectFor(widget), (Rectangle) boxedFor(Rectangle.class, backgroundArea), (Rectangle) boxedFor(Rectangle.class, cellArea), (Rectangle) boxedFor(Rectangle.class, exposeArea), (CellRendererState) flagFor(CellRendererState.class, flags));
    }

    interface ActivateSignal extends Signal
    {
        boolean onActivate(CellRenderer source, Event event, Widget widget, String path, Rectangle backgroundArea, Rectangle cellArea, CellRendererState flags);
    }

    static final void connect(CellRenderer self, GtkCellRenderer.ActivateSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCellRenderer.class, "activate", after);
    }

    protected static final boolean receiveActivate(Signal handler, long source, long event, long widget, String path, long backgroundArea, long cellArea, int flags) {
        boolean result;

        result = ((GtkCellRenderer.ActivateSignal) handler).onActivate((CellRenderer) objectFor(source), (Event) boxedFor(Event.class, event), (Widget) objectFor(widget), path, (Rectangle) boxedFor(Rectangle.class, backgroundArea), (Rectangle) boxedFor(Rectangle.class, cellArea), (CellRendererState) flagFor(CellRendererState.class, flags));

        return result;
    }

    interface EditingCanceledSignal extends Signal
    {
        void onEditingCanceled(CellRenderer source);
    }

    static final void connect(CellRenderer self, GtkCellRenderer.EditingCanceledSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCellRenderer.class, "editing-canceled", after);
    }

    protected static final void receiveEditingCanceled(Signal handler, long source) {
        ((GtkCellRenderer.EditingCanceledSignal) handler).onEditingCanceled((CellRenderer) objectFor(source));
    }

    interface EditingStartedSignal extends Signal
    {
        void onEditingStarted(CellRenderer source, CellEditable editable, String path);
    }

    static final void connect(CellRenderer self, GtkCellRenderer.EditingStartedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCellRenderer.class, "editing-started", after);
    }

    protected static final void receiveEditingStarted(Signal handler, long source, long editable, String path) {
        ((GtkCellRenderer.EditingStartedSignal) handler).onEditingStarted((CellRenderer) objectFor(source), (CellEditable) objectFor(editable), path);
    }

    interface StartEditingSignal extends Signal
    {
        CellEditable onStartEditing(CellRenderer source, Event event, Widget widget, String path, Rectangle backgroundArea, Rectangle cellArea, CellRendererState flags);
    }

    static final void connect(CellRenderer self, GtkCellRenderer.StartEditingSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCellRenderer.class, "start-editing", after);
    }

    protected static final long receiveStartEditing(Signal handler, long source, long event, long widget, String path, long backgroundArea, long cellArea, int flags) {
        CellEditable result;

        result = ((GtkCellRenderer.StartEditingSignal) handler).onStartEditing((CellRenderer) objectFor(source), (Event) boxedFor(Event.class, event), (Widget) objectFor(widget), path, (Rectangle) boxedFor(Rectangle.class, backgroundArea), (Rectangle) boxedFor(Rectangle.class, cellArea), (CellRendererState) flagFor(CellRendererState.class, flags));

        return pointerOf((Object) result);
    }
}

