/*
 * GtkCellRendererText.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.CellRendererText;
import org.gnome.gtk.Plumbing;

final class GtkCellRendererText extends Plumbing
{
    private GtkCellRendererText() {}

    static final long createCellRendererText() {
        long result;

        synchronized (lock) {
            result = gtk_cell_renderer_text_new();

            return result;
        }
    }

    private static native final long gtk_cell_renderer_text_new();

    static final void setFixedHeightFromFont(CellRendererText self, int numberOfRows) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_cell_renderer_text_set_fixed_height_from_font(pointerOf(self), numberOfRows);
        }
    }

    private static native final void gtk_cell_renderer_text_set_fixed_height_from_font(long self, int numberOfRows);

    interface EditedSignal extends Signal
    {
        void onEdited(CellRendererText source, String path, String newText);
    }

    static final void connect(CellRendererText self, GtkCellRendererText.EditedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCellRendererText.class, "edited", after);
    }

    protected static final void receiveEdited(Signal handler, long source, String path, String newText) {
        ((GtkCellRendererText.EditedSignal) handler).onEdited((CellRendererText) objectFor(source), path, newText);
    }
}

