/*
 * GtkCellView.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Color;
import org.gnome.gtk.CellRenderer;
import org.gnome.gtk.CellView;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Requisition;
import org.gnome.gtk.TreeModel;
import org.gnome.gtk.TreePath;

final class GtkCellView extends Plumbing
{
    private GtkCellView() {}

    static final long createCellView() {
        long result;

        synchronized (lock) {
            result = gtk_cell_view_new();

            return result;
        }
    }

    private static native final long gtk_cell_view_new();

    static final void setModel(CellView self, TreeModel model) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_cell_view_set_model(pointerOf(self), pointerOf(model));
        }
    }

    private static native final void gtk_cell_view_set_model(long self, long model);

    static final void setDisplayedRow(CellView self, TreePath path) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_cell_view_set_displayed_row(pointerOf(self), pointerOf(path));
        }
    }

    private static native final void gtk_cell_view_set_displayed_row(long self, long path);

    static final TreePath getDisplayedRow(CellView self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_cell_view_get_displayed_row(pointerOf(self));

            return (TreePath) boxedFor(TreePath.class, result);
        }
    }

    private static native final long gtk_cell_view_get_displayed_row(long self);

    static final boolean getSizeOfRow(CellView self, TreePath path, Requisition requisition) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        if (requisition == null) {
            throw new IllegalArgumentException("requisition can't be null");
        }

        synchronized (lock) {
            result = gtk_cell_view_get_size_of_row(pointerOf(self), pointerOf(path), pointerOf(requisition));

            return result;
        }
    }

    private static native final boolean gtk_cell_view_get_size_of_row(long self, long path, long requisition);

    static final void setBackgroundColor(CellView self, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gtk_cell_view_set_background_color(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gtk_cell_view_set_background_color(long self, long color);

    static final CellRenderer[] getCellRenderers(CellView self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_cell_view_get_cell_renderers(pointerOf(self));

            return (CellRenderer[]) objectArrayFor(result, new CellRenderer[result.length]);
        }
    }

    private static native final long[] gtk_cell_view_get_cell_renderers(long self);
}

