/*
 * GtkCheckMenuItem.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Rectangle;
import org.gnome.glib.Signal;
import org.gnome.gtk.CheckMenuItem;
import org.gnome.gtk.Plumbing;

final class GtkCheckMenuItem extends Plumbing
{
    private GtkCheckMenuItem() {}

    static final long createCheckMenuItem() {
        long result;

        synchronized (lock) {
            result = gtk_check_menu_item_new();

            return result;
        }
    }

    private static native final long gtk_check_menu_item_new();

    static final long createCheckMenuItemWithLabel(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_check_menu_item_new_with_label(label);

            return result;
        }
    }

    private static native final long gtk_check_menu_item_new_with_label(String label);

    static final long createCheckMenuItemWithMnemonic(String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_check_menu_item_new_with_mnemonic(label);

            return result;
        }
    }

    private static native final long gtk_check_menu_item_new_with_mnemonic(String label);

    static final void setActive(CheckMenuItem self, boolean isActive) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_check_menu_item_set_active(pointerOf(self), isActive);
        }
    }

    private static native final void gtk_check_menu_item_set_active(long self, boolean isActive);

    static final boolean getActive(CheckMenuItem self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_check_menu_item_get_active(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_check_menu_item_get_active(long self);

    static final void toggled(CheckMenuItem self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_check_menu_item_toggled(pointerOf(self));
        }
    }

    private static native final void gtk_check_menu_item_toggled(long self);

    static final void setInconsistent(CheckMenuItem self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_check_menu_item_set_inconsistent(pointerOf(self), setting);
        }
    }

    private static native final void gtk_check_menu_item_set_inconsistent(long self, boolean setting);

    static final boolean getInconsistent(CheckMenuItem self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_check_menu_item_get_inconsistent(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_check_menu_item_get_inconsistent(long self);

    static final void setDrawAsRadio(CheckMenuItem self, boolean drawAsRadio) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_check_menu_item_set_draw_as_radio(pointerOf(self), drawAsRadio);
        }
    }

    private static native final void gtk_check_menu_item_set_draw_as_radio(long self, boolean drawAsRadio);

    static final boolean getDrawAsRadio(CheckMenuItem self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_check_menu_item_get_draw_as_radio(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_check_menu_item_get_draw_as_radio(long self);

    interface ToggledSignal extends Signal
    {
        void onToggled(CheckMenuItem source);
    }

    static final void connect(CheckMenuItem self, GtkCheckMenuItem.ToggledSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCheckMenuItem.class, "toggled", after);
    }

    protected static final void receiveToggled(Signal handler, long source) {
        ((GtkCheckMenuItem.ToggledSignal) handler).onToggled((CheckMenuItem) objectFor(source));
    }

    interface DrawIndicatorSignal extends Signal
    {
        void onDrawIndicator(CheckMenuItem source, Rectangle area);
    }

    static final void connect(CheckMenuItem self, GtkCheckMenuItem.DrawIndicatorSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCheckMenuItem.class, "draw-indicator", after);
    }

    protected static final void receiveDrawIndicator(Signal handler, long source, long area) {
        ((GtkCheckMenuItem.DrawIndicatorSignal) handler).onDrawIndicator((CheckMenuItem) objectFor(source), (Rectangle) boxedFor(Rectangle.class, area));
    }
}

