/*
 * GtkColorButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Color;
import org.gnome.glib.Signal;
import org.gnome.gtk.ColorButton;
import org.gnome.gtk.Plumbing;

final class GtkColorButton extends Plumbing
{
    private GtkColorButton() {}

    static final long createColorButton() {
        long result;

        synchronized (lock) {
            result = gtk_color_button_new();

            return result;
        }
    }

    private static native final long gtk_color_button_new();

    static final long createColorButtonWithColor(Color color) {
        long result;

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            result = gtk_color_button_new_with_color(pointerOf(color));

            return result;
        }
    }

    private static native final long gtk_color_button_new_with_color(long color);

    static final void setColor(ColorButton self, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gtk_color_button_set_color(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gtk_color_button_set_color(long self, long color);

    static final void setAlpha(ColorButton self, char alpha) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_color_button_set_alpha(pointerOf(self), alpha);
        }
    }

    private static native final void gtk_color_button_set_alpha(long self, char alpha);

    static final void getColor(ColorButton self, org.gnome.gdk.Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            gtk_color_button_get_color(pointerOf(self), pointerOf(color));
        }
    }

    private static native final void gtk_color_button_get_color(long self, long color);

    static final char getAlpha(ColorButton self) {
        char result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_color_button_get_alpha(pointerOf(self));

            return result;
        }
    }

    private static native final char gtk_color_button_get_alpha(long self);

    static final void setUseAlpha(ColorButton self, boolean useAlpha) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_color_button_set_use_alpha(pointerOf(self), useAlpha);
        }
    }

    private static native final void gtk_color_button_set_use_alpha(long self, boolean useAlpha);

    static final boolean getUseAlpha(ColorButton self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_color_button_get_use_alpha(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_color_button_get_use_alpha(long self);

    static final void setTitle(ColorButton self, String title) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        synchronized (lock) {
            gtk_color_button_set_title(pointerOf(self), title);
        }
    }

    private static native final void gtk_color_button_set_title(long self, String title);

    static final String getTitle(ColorButton self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_color_button_get_title(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_color_button_get_title(long self);

    interface ColorSetSignal extends Signal
    {
        void onColorSet(ColorButton source);
    }

    static final void connect(ColorButton self, GtkColorButton.ColorSetSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkColorButton.class, "color-set", after);
    }

    protected static final void receiveColorSet(Signal handler, long source) {
        ((GtkColorButton.ColorSetSignal) handler).onColorSet((ColorButton) objectFor(source));
    }
}

