/*
 * GtkComboBox.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.atk.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.ComboBox;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.TreeIter;
import org.gnome.gtk.TreeModel;

final class GtkComboBox extends Plumbing
{
    private GtkComboBox() {}

    static final long createComboBox() {
        long result;

        synchronized (lock) {
            result = gtk_combo_box_new();

            return result;
        }
    }

    private static native final long gtk_combo_box_new();

    static final long createComboBoxText() {
        long result;

        synchronized (lock) {
            result = gtk_combo_box_new_text();

            return result;
        }
    }

    private static native final long gtk_combo_box_new_text();

    static final long createComboBoxWithModel(TreeModel model) {
        long result;

        if (model == null) {
            throw new IllegalArgumentException("model can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_new_with_model(pointerOf(model));

            return result;
        }
    }

    private static native final long gtk_combo_box_new_with_model(long model);

    static final void setWrapWidth(ComboBox self, int width) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_set_wrap_width(pointerOf(self), width);
        }
    }

    private static native final void gtk_combo_box_set_wrap_width(long self, int width);

    static final void setRowSpanColumn(ComboBox self, int rowSpan) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_set_row_span_column(pointerOf(self), rowSpan);
        }
    }

    private static native final void gtk_combo_box_set_row_span_column(long self, int rowSpan);

    static final void setColumnSpanColumn(ComboBox self, int columnSpan) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_set_column_span_column(pointerOf(self), columnSpan);
        }
    }

    private static native final void gtk_combo_box_set_column_span_column(long self, int columnSpan);

    static final int getActive(ComboBox self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_get_active(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_combo_box_get_active(long self);

    static final void setActive(ComboBox self, int index) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_set_active(pointerOf(self), index);
        }
    }

    private static native final void gtk_combo_box_set_active(long self, int index);

    static final boolean getActiveIter(ComboBox self, TreeIter iter) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_get_active_iter(pointerOf(self), pointerOf(iter));

            return result;
        }
    }

    private static native final boolean gtk_combo_box_get_active_iter(long self, long iter);

    static final void setActiveIter(ComboBox self, TreeIter iter) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_set_active_iter(pointerOf(self), pointerOf(iter));
        }
    }

    private static native final void gtk_combo_box_set_active_iter(long self, long iter);

    static final void setModel(ComboBox self, TreeModel model) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_set_model(pointerOf(self), pointerOf(model));
        }
    }

    private static native final void gtk_combo_box_set_model(long self, long model);

    static final TreeModel getModel(ComboBox self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_get_model(pointerOf(self));

            return (TreeModel) objectFor(result);
        }
    }

    private static native final long gtk_combo_box_get_model(long self);

    static final void appendText(ComboBox self, String text) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_append_text(pointerOf(self), text);
        }
    }

    private static native final void gtk_combo_box_append_text(long self, String text);

    static final void insertText(ComboBox self, int position, String text) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_insert_text(pointerOf(self), position, text);
        }
    }

    private static native final void gtk_combo_box_insert_text(long self, int position, String text);

    static final void prependText(ComboBox self, String text) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_prepend_text(pointerOf(self), text);
        }
    }

    private static native final void gtk_combo_box_prepend_text(long self, String text);

    static final void removeText(ComboBox self, int position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_remove_text(pointerOf(self), position);
        }
    }

    private static native final void gtk_combo_box_remove_text(long self, int position);

    static final void popup(ComboBox self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_popup(pointerOf(self));
        }
    }

    private static native final void gtk_combo_box_popup(long self);

    static final void popdown(ComboBox self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_popdown(pointerOf(self));
        }
    }

    private static native final void gtk_combo_box_popdown(long self);

    static final int getWrapWidth(ComboBox self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_get_wrap_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_combo_box_get_wrap_width(long self);

    static final int getRowSpanColumn(ComboBox self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_get_row_span_column(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_combo_box_get_row_span_column(long self);

    static final int getColumnSpanColumn(ComboBox self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_get_column_span_column(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_combo_box_get_column_span_column(long self);

    static final boolean getAddTearoffs(ComboBox self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_get_add_tearoffs(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_combo_box_get_add_tearoffs(long self);

    static final void setAddTearoffs(ComboBox self, boolean addTearoffs) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_set_add_tearoffs(pointerOf(self), addTearoffs);
        }
    }

    private static native final void gtk_combo_box_set_add_tearoffs(long self, boolean addTearoffs);

    static final boolean getFocusOnClick(ComboBox self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_get_focus_on_click(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_combo_box_get_focus_on_click(long self);

    static final void setFocusOnClick(ComboBox self, boolean focusOnClick) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_set_focus_on_click(pointerOf(self), focusOnClick);
        }
    }

    private static native final void gtk_combo_box_set_focus_on_click(long self, boolean focusOnClick);

    static final void setRowSeparatorFunc(ComboBox self, FIXME func, FIXME data, FIXME destroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTreeViewRowSeparatorFunc");
    }

    static final FIXME getRowSeparatorFunc(ComboBox self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTreeViewRowSeparatorFunc");
    }

    static final String getActiveText(ComboBox self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_get_active_text(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_combo_box_get_active_text(long self);

    static final Object getPopupAccessible(ComboBox self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_get_popup_accessible(pointerOf(self));

            return (Object) objectFor(result);
        }
    }

    private static native final long gtk_combo_box_get_popup_accessible(long self);

    interface ChangedSignal extends Signal
    {
        void onChanged(ComboBox source);
    }

    static final void connect(ComboBox self, GtkComboBox.ChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkComboBox.class, "changed", after);
    }

    protected static final void receiveChanged(Signal handler, long source) {
        ((GtkComboBox.ChangedSignal) handler).onChanged((ComboBox) objectFor(source));
    }

    interface GetActiveTextSignal extends Signal
    {
        String onGetActiveText(ComboBox source);
    }

    static final void connect(ComboBox self, GtkComboBox.GetActiveTextSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkComboBox.class, "get-active-text", after);
    }

    protected static final String receiveGetActiveText(Signal handler, long source) {
        String result;

        result = ((GtkComboBox.GetActiveTextSignal) handler).onGetActiveText((ComboBox) objectFor(source));

        return result;
    }

    static final String getTitle(ComboBox self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_get_title(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_combo_box_get_title(long self);

    static final void setTitle(ComboBox self, String title) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_set_title(pointerOf(self), title);
        }
    }

    private static native final void gtk_combo_box_set_title(long self, String title);
}

