/*
 * GtkComboBoxEntry.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.ComboBoxEntry;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.TreeModel;

final class GtkComboBoxEntry extends Plumbing
{
    private GtkComboBoxEntry() {}

    static final long createComboBoxEntry() {
        long result;

        synchronized (lock) {
            result = gtk_combo_box_entry_new();

            return result;
        }
    }

    private static native final long gtk_combo_box_entry_new();

    static final long createComboBoxEntryWithModel(TreeModel model, int textColumn) {
        long result;

        if (model == null) {
            throw new IllegalArgumentException("model can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_entry_new_with_model(pointerOf(model), textColumn);

            return result;
        }
    }

    private static native final long gtk_combo_box_entry_new_with_model(long model, int textColumn);

    static final long createComboBoxEntryText() {
        long result;

        synchronized (lock) {
            result = gtk_combo_box_entry_new_text();

            return result;
        }
    }

    private static native final long gtk_combo_box_entry_new_text();

    static final void setTextColumn(ComboBoxEntry self, int textColumn) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_combo_box_entry_set_text_column(pointerOf(self), textColumn);
        }
    }

    private static native final void gtk_combo_box_entry_set_text_column(long self, int textColumn);

    static final int getTextColumn(ComboBoxEntry self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_combo_box_entry_get_text_column(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_combo_box_entry_get_text_column(long self);
}

