/*
 * GtkContainer.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.EventExpose;
import org.gnome.glib.Signal;
import org.gnome.glib.Value;
import org.gnome.gtk.Adjustment;
import org.gnome.gtk.Container;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ResizeMode;
import org.gnome.gtk.Widget;

final class GtkContainer extends Plumbing
{
    private GtkContainer() {}

    static final void setBorderWidth(Container self, int borderWidth) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_container_set_border_width(pointerOf(self), borderWidth);
        }
    }

    private static native final void gtk_container_set_border_width(long self, int borderWidth);

    static final int getBorderWidth(Container self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_container_get_border_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_container_get_border_width(long self);

    static final void add(Container self, Widget widget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (widget == null) {
            throw new IllegalArgumentException("widget can't be null");
        }

        synchronized (lock) {
            gtk_container_add(pointerOf(self), pointerOf(widget));
        }
    }

    private static native final void gtk_container_add(long self, long widget);

    static final void remove(Container self, Widget widget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (widget == null) {
            throw new IllegalArgumentException("widget can't be null");
        }

        synchronized (lock) {
            gtk_container_remove(pointerOf(self), pointerOf(widget));
        }
    }

    private static native final void gtk_container_remove(long self, long widget);

    static final void setResizeMode(Container self, ResizeMode resizeMode) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (resizeMode == null) {
            throw new IllegalArgumentException("resizeMode can't be null");
        }

        synchronized (lock) {
            gtk_container_set_resize_mode(pointerOf(self), numOf(resizeMode));
        }
    }

    private static native final void gtk_container_set_resize_mode(long self, int resizeMode);

    static final ResizeMode getResizeMode(Container self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_container_get_resize_mode(pointerOf(self));

            return (ResizeMode) enumFor(ResizeMode.class, result);
        }
    }

    private static native final int gtk_container_get_resize_mode(long self);

    static final void checkResize(Container self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_container_check_resize(pointerOf(self));
        }
    }

    private static native final void gtk_container_check_resize(long self);

    static final void foreach(Container self, FIXME callback, FIXME callbackData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkCallback");
    }

    static final void foreachFull(Container self, FIXME callback, FIXME marshal, FIXME callbackData, FIXME notify) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkCallback");
    }

    static final Widget[] getChildren(Container self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_container_get_children(pointerOf(self));

            return (Widget[]) objectArrayFor(result, new Widget[result.length]);
        }
    }

    private static native final long[] gtk_container_get_children(long self);

    static final void propagateExpose(Container self, Widget child, EventExpose event) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (event == null) {
            throw new IllegalArgumentException("event can't be null");
        }

        synchronized (lock) {
            gtk_container_propagate_expose(pointerOf(self), pointerOf(child), pointerOf(event));
        }
    }

    private static native final void gtk_container_propagate_expose(long self, long child, long event);

    static final void setFocusChain(Container self, Widget[] focusableWidgets) {
        long[] _focusableWidgets;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (focusableWidgets == null) {
            throw new IllegalArgumentException("focusableWidgets can't be null");
        }

        _focusableWidgets = pointersOf(focusableWidgets);

        synchronized (lock) {
            gtk_container_set_focus_chain(pointerOf(self), _focusableWidgets);
            fillObjectArray(focusableWidgets, _focusableWidgets);
        }
    }

    private static native final void gtk_container_set_focus_chain(long self, long[] focusableWidgets);

    static final boolean getFocusChain(Container self, FIXME focusableWidgets) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GList**");
    }

    static final void unsetFocusChain(Container self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_container_unset_focus_chain(pointerOf(self));
        }
    }

    private static native final void gtk_container_unset_focus_chain(long self);

    static final void setReallocateRedraws(Container self, boolean needsRedraws) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_container_set_reallocate_redraws(pointerOf(self), needsRedraws);
        }
    }

    private static native final void gtk_container_set_reallocate_redraws(long self, boolean needsRedraws);

    static final void setFocusChild(Container self, Widget child) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_container_set_focus_child(pointerOf(self), pointerOf(child));
        }
    }

    private static native final void gtk_container_set_focus_child(long self, long child);

    static final void setFocusVadjustment(Container self, Adjustment adjustment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (adjustment == null) {
            throw new IllegalArgumentException("adjustment can't be null");
        }

        synchronized (lock) {
            gtk_container_set_focus_vadjustment(pointerOf(self), pointerOf(adjustment));
        }
    }

    private static native final void gtk_container_set_focus_vadjustment(long self, long adjustment);

    static final Adjustment getFocusVadjustment(Container self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_container_get_focus_vadjustment(pointerOf(self));

            return (Adjustment) objectFor(result);
        }
    }

    private static native final long gtk_container_get_focus_vadjustment(long self);

    static final void setFocusHadjustment(Container self, Adjustment adjustment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (adjustment == null) {
            throw new IllegalArgumentException("adjustment can't be null");
        }

        synchronized (lock) {
            gtk_container_set_focus_hadjustment(pointerOf(self), pointerOf(adjustment));
        }
    }

    private static native final void gtk_container_set_focus_hadjustment(long self, long adjustment);

    static final Adjustment getFocusHadjustment(Container self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_container_get_focus_hadjustment(pointerOf(self));

            return (Adjustment) objectFor(result);
        }
    }

    private static native final long gtk_container_get_focus_hadjustment(long self);

    static final void resizeChildren(Container self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_container_resize_children(pointerOf(self));
        }
    }

    private static native final void gtk_container_resize_children(long self);

    static final FIXME childType(Container self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GType");
    }

    static final void addWithProperties(Container self, Widget widget, String firstPropName) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (widget == null) {
            throw new IllegalArgumentException("widget can't be null");
        }

        if (firstPropName == null) {
            throw new IllegalArgumentException("firstPropName can't be null");
        }

        synchronized (lock) {
            gtk_container_add_with_properties(pointerOf(self), pointerOf(widget), firstPropName);
        }
    }

    private static native final void gtk_container_add_with_properties(long self, long widget, String firstPropName);

    static final void childSet(Container self, Widget child, String firstPropName) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (firstPropName == null) {
            throw new IllegalArgumentException("firstPropName can't be null");
        }

        synchronized (lock) {
            gtk_container_child_set(pointerOf(self), pointerOf(child), firstPropName);
        }
    }

    private static native final void gtk_container_child_set(long self, long child, String firstPropName);

    static final void childGet(Container self, Widget child, String firstPropName) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (firstPropName == null) {
            throw new IllegalArgumentException("firstPropName can't be null");
        }

        synchronized (lock) {
            gtk_container_child_get(pointerOf(self), pointerOf(child), firstPropName);
        }
    }

    private static native final void gtk_container_child_get(long self, long child, String firstPropName);

    static final void childSetValist(Container self, Widget child, String firstPropertyName, FIXME varArgs) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("va_list");
    }

    static final void childGetValist(Container self, Widget child, String firstPropertyName, FIXME varArgs) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("va_list");
    }

    static final void childSetProperty(Container self, Widget child, String propertyName, Value value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (propertyName == null) {
            throw new IllegalArgumentException("propertyName can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            gtk_container_child_set_property(pointerOf(self), pointerOf(child), propertyName, pointerOf(value));
        }
    }

    private static native final void gtk_container_child_set_property(long self, long child, String propertyName, long value);

    static final void childGetProperty(Container self, Widget child, String propertyName, org.gnome.glib.Value value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (propertyName == null) {
            throw new IllegalArgumentException("propertyName can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            gtk_container_child_get_property(pointerOf(self), pointerOf(child), propertyName, pointerOf(value));
        }
    }

    private static native final void gtk_container_child_get_property(long self, long child, String propertyName, long value);

    static final void forall(Container self, FIXME callback, FIXME callbackData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkCallback");
    }

    interface AddSignal extends Signal
    {
        void onAdd(Container source, Widget widget);
    }

    static final void connect(Container self, GtkContainer.AddSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkContainer.class, "add", after);
    }

    protected static final void receiveAdd(Signal handler, long source, long widget) {
        ((GtkContainer.AddSignal) handler).onAdd((Container) objectFor(source), (Widget) objectFor(widget));
    }

    interface RemoveSignal extends Signal
    {
        void onRemove(Container source, Widget widget);
    }

    static final void connect(Container self, GtkContainer.RemoveSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkContainer.class, "remove", after);
    }

    protected static final void receiveRemove(Signal handler, long source, long widget) {
        ((GtkContainer.RemoveSignal) handler).onRemove((Container) objectFor(source), (Widget) objectFor(widget));
    }

    interface CheckResizeSignal extends Signal
    {
        void onCheckResize(Container source);
    }

    static final void connect(Container self, GtkContainer.CheckResizeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkContainer.class, "check-resize", after);
    }

    protected static final void receiveCheckResize(Signal handler, long source) {
        ((GtkContainer.CheckResizeSignal) handler).onCheckResize((Container) objectFor(source));
    }

    interface ForallSignal extends Signal
    {
        void onForall(Container source, boolean includeInternals, FIXME callback, FIXME callbackData);
    }

    static final void connect(Container self, GtkContainer.ForallSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkContainer.class, "forall", after);
    }

    protected static final void receiveForall(Signal handler, long source, boolean includeInternals, java.lang.Object callback, java.lang.Object callbackData) {
        ((GtkContainer.ForallSignal) handler).onForall((Container) objectFor(source), includeInternals, (FIXME) callback, (FIXME) callbackData);
    }

    interface SetFocusChildSignal extends Signal
    {
        void onSetFocusChild(Container source, Widget widget);
    }

    static final void connect(Container self, GtkContainer.SetFocusChildSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkContainer.class, "set-focus-child", after);
    }

    protected static final void receiveSetFocusChild(Signal handler, long source, long widget) {
        ((GtkContainer.SetFocusChildSignal) handler).onSetFocusChild((Container) objectFor(source), (Widget) objectFor(widget));
    }

    interface ChildTypeSignal extends Signal
    {
        FIXME onChildType(Container source);
    }

    static final void connect(Container self, GtkContainer.ChildTypeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkContainer.class, "child-type", after);
    }

    protected static final java.lang.Object receiveChildType(Signal handler, long source) {
        FIXME result;

        result = ((GtkContainer.ChildTypeSignal) handler).onChildType((Container) objectFor(source));

        return result;
    }

    interface CompositeNameSignal extends Signal
    {
        String onCompositeName(Container source, Widget child);
    }

    static final void connect(Container self, GtkContainer.CompositeNameSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkContainer.class, "composite-name", after);
    }

    protected static final String receiveCompositeName(Signal handler, long source, long child) {
        String result;

        result = ((GtkContainer.CompositeNameSignal) handler).onCompositeName((Container) objectFor(source), (Widget) objectFor(child));

        return result;
    }

    interface SetChildPropertySignal extends Signal
    {
        void onSetChildProperty(Container source, Widget child, int propertyId, Value value, FIXME pspec);
    }

    static final void connect(Container self, GtkContainer.SetChildPropertySignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkContainer.class, "set-child-property", after);
    }

    protected static final void receiveSetChildProperty(Signal handler, long source, long child, int propertyId, long value, java.lang.Object pspec) {
        ((GtkContainer.SetChildPropertySignal) handler).onSetChildProperty((Container) objectFor(source), (Widget) objectFor(child), propertyId, valueFor(value), (FIXME) pspec);
    }

    interface GetChildPropertySignal extends Signal
    {
        void onGetChildProperty(Container source, Widget child, int propertyId, org.gnome.glib.Value value, FIXME pspec);
    }

    static final void connect(Container self, GtkContainer.GetChildPropertySignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkContainer.class, "get-child-property", after);
    }

    protected static final void receiveGetChildProperty(Signal handler, long source, long child, int propertyId, long value, java.lang.Object pspec) {
        ((GtkContainer.GetChildPropertySignal) handler).onGetChildProperty((Container) objectFor(source), (Widget) objectFor(child), propertyId, valueFor(value), (FIXME) pspec);
    }
}

