/*
 * GtkCurve.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Curve;
import org.gnome.gtk.CurveType;
import org.gnome.gtk.Plumbing;

final class GtkCurve extends Plumbing
{
    private GtkCurve() {}

    static final long createCurve() {
        long result;

        synchronized (lock) {
            result = gtk_curve_new();

            return result;
        }
    }

    private static native final long gtk_curve_new();

    static final void reset(Curve self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_curve_reset(pointerOf(self));
        }
    }

    private static native final void gtk_curve_reset(long self);

    static final void setGamma(Curve self, float gamma) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_curve_set_gamma(pointerOf(self), gamma);
        }
    }

    private static native final void gtk_curve_set_gamma(long self, float gamma);

    static final void setRange(Curve self, float minX, float maxX, float minY, float maxY) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_curve_set_range(pointerOf(self), minX, maxX, minY, maxY);
        }
    }

    private static native final void gtk_curve_set_range(long self, float minX, float maxX, float minY, float maxY);

    static final void getVector(Curve self, int veclen, float[] vector) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (vector == null) {
            throw new IllegalArgumentException("vector can't be null");
        }

        synchronized (lock) {
            gtk_curve_get_vector(pointerOf(self), veclen, vector);
        }
    }

    private static native final void gtk_curve_get_vector(long self, int veclen, float[] vector);

    static final void setVector(Curve self, int veclen, float[] vector) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (vector == null) {
            throw new IllegalArgumentException("vector can't be null");
        }

        synchronized (lock) {
            gtk_curve_set_vector(pointerOf(self), veclen, vector);
        }
    }

    private static native final void gtk_curve_set_vector(long self, int veclen, float[] vector);

    static final void setCurveType(Curve self, CurveType type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gtk_curve_set_curve_type(pointerOf(self), numOf(type));
        }
    }

    private static native final void gtk_curve_set_curve_type(long self, int type);

    interface CurveTypeChangedSignal extends Signal
    {
        void onCurveTypeChanged(Curve source);
    }

    static final void connect(Curve self, GtkCurve.CurveTypeChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkCurve.class, "curve-type-changed", after);
    }

    protected static final void receiveCurveTypeChanged(Signal handler, long source) {
        ((GtkCurve.CurveTypeChangedSignal) handler).onCurveTypeChanged((Curve) objectFor(source));
    }
}

