/*
 * GtkHScale.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Adjustment;
import org.gnome.gtk.Plumbing;

final class GtkHScale extends Plumbing
{
    private GtkHScale() {}

    static final long createHScale(Adjustment adjustment) {
        long result;

        if (adjustment == null) {
            throw new IllegalArgumentException("adjustment can't be null");
        }

        synchronized (lock) {
            result = gtk_hscale_new(pointerOf(adjustment));

            return result;
        }
    }

    private static native final long gtk_hscale_new(long adjustment);

    static final long createHScaleWithRange(double min, double max, double step) {
        long result;

        synchronized (lock) {
            result = gtk_hscale_new_with_range(min, max, step);

            return result;
        }
    }

    private static native final long gtk_hscale_new_with_range(double min, double max, double step);
}

