/*
 * GtkHandleBox.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.HandleBox;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.PositionType;
import org.gnome.gtk.ShadowType;
import org.gnome.gtk.Widget;

final class GtkHandleBox extends Plumbing
{
    private GtkHandleBox() {}

    static final long createHandleBox() {
        long result;

        synchronized (lock) {
            result = gtk_handle_box_new();

            return result;
        }
    }

    private static native final long gtk_handle_box_new();

    static final void setShadowType(HandleBox self, ShadowType type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gtk_handle_box_set_shadow_type(pointerOf(self), numOf(type));
        }
    }

    private static native final void gtk_handle_box_set_shadow_type(long self, int type);

    static final ShadowType getShadowType(HandleBox self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_handle_box_get_shadow_type(pointerOf(self));

            return (ShadowType) enumFor(ShadowType.class, result);
        }
    }

    private static native final int gtk_handle_box_get_shadow_type(long self);

    static final void setHandlePosition(HandleBox self, PositionType position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (position == null) {
            throw new IllegalArgumentException("position can't be null");
        }

        synchronized (lock) {
            gtk_handle_box_set_handle_position(pointerOf(self), numOf(position));
        }
    }

    private static native final void gtk_handle_box_set_handle_position(long self, int position);

    static final PositionType getHandlePosition(HandleBox self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_handle_box_get_handle_position(pointerOf(self));

            return (PositionType) enumFor(PositionType.class, result);
        }
    }

    private static native final int gtk_handle_box_get_handle_position(long self);

    static final void setSnapEdge(HandleBox self, PositionType edge) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (edge == null) {
            throw new IllegalArgumentException("edge can't be null");
        }

        synchronized (lock) {
            gtk_handle_box_set_snap_edge(pointerOf(self), numOf(edge));
        }
    }

    private static native final void gtk_handle_box_set_snap_edge(long self, int edge);

    static final PositionType getSnapEdge(HandleBox self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_handle_box_get_snap_edge(pointerOf(self));

            return (PositionType) enumFor(PositionType.class, result);
        }
    }

    private static native final int gtk_handle_box_get_snap_edge(long self);

    interface ChildAttachedSignal extends Signal
    {
        void onChildAttached(HandleBox source, Widget child);
    }

    static final void connect(HandleBox self, GtkHandleBox.ChildAttachedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkHandleBox.class, "child-attached", after);
    }

    protected static final void receiveChildAttached(Signal handler, long source, long child) {
        ((GtkHandleBox.ChildAttachedSignal) handler).onChildAttached((HandleBox) objectFor(source), (Widget) objectFor(child));
    }

    interface ChildDetachedSignal extends Signal
    {
        void onChildDetached(HandleBox source, Widget child);
    }

    static final void connect(HandleBox self, GtkHandleBox.ChildDetachedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkHandleBox.class, "child-detached", after);
    }

    protected static final void receiveChildDetached(Signal handler, long source, long child) {
        ((GtkHandleBox.ChildDetachedSignal) handler).onChildDetached((HandleBox) objectFor(source), (Widget) objectFor(child));
    }
}

