/*
 * GtkIMMulticontext.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.IMMulticontext;
import org.gnome.gtk.MenuShell;
import org.gnome.gtk.Plumbing;

final class GtkIMMulticontext extends Plumbing
{
    private GtkIMMulticontext() {}

    static final long createIMMulticontext() {
        long result;

        synchronized (lock) {
            result = gtk_im_multicontext_new();

            return result;
        }
    }

    private static native final long gtk_im_multicontext_new();

    static final void appendMenuitems(IMMulticontext self, MenuShell menushell) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (menushell == null) {
            throw new IllegalArgumentException("menushell can't be null");
        }

        synchronized (lock) {
            gtk_im_multicontext_append_menuitems(pointerOf(self), pointerOf(menushell));
        }
    }

    private static native final void gtk_im_multicontext_append_menuitems(long self, long menushell);
}

