/*
 * GtkIconFactory.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.IconFactory;
import org.gnome.gtk.IconSet;
import org.gnome.gtk.Plumbing;

final class GtkIconFactory extends Plumbing
{
    private GtkIconFactory() {}

    static final long createIconFactory() {
        long result;

        synchronized (lock) {
            result = gtk_icon_factory_new();

            return result;
        }
    }

    private static native final long gtk_icon_factory_new();

    static final void add(IconFactory self, String stockId, IconSet iconSet) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        if (iconSet == null) {
            throw new IllegalArgumentException("iconSet can't be null");
        }

        synchronized (lock) {
            gtk_icon_factory_add(pointerOf(self), stockId, pointerOf(iconSet));
        }
    }

    private static native final void gtk_icon_factory_add(long self, String stockId, long iconSet);

    static final IconSet lookup(IconFactory self, String stockId) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_factory_lookup(pointerOf(self), stockId);

            return (IconSet) boxedFor(IconSet.class, result);
        }
    }

    private static native final long gtk_icon_factory_lookup(long self, String stockId);

    static final void addDefault(IconFactory self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_icon_factory_add_default(pointerOf(self));
        }
    }

    private static native final void gtk_icon_factory_add_default(long self);

    static final void removeDefault(IconFactory self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_icon_factory_remove_default(pointerOf(self));
        }
    }

    private static native final void gtk_icon_factory_remove_default(long self);
}

