/*
 * GtkIconInfo.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.Point;
import org.gnome.gdk.Rectangle;
import org.gnome.glib.GlibException;
import org.gnome.gtk.IconInfo;
import org.gnome.gtk.Plumbing;

final class GtkIconInfo extends Plumbing
{
    private GtkIconInfo() {}

    static final IconInfo copy(IconInfo self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_info_copy(pointerOf(self));

            return (IconInfo) boxedFor(IconInfo.class, result);
        }
    }

    private static native final long gtk_icon_info_copy(long self);

    static final void free(IconInfo self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_icon_info_free(pointerOf(self));
        }
    }

    private static native final void gtk_icon_info_free(long self);

    static final int getBaseSize(IconInfo self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_info_get_base_size(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_icon_info_get_base_size(long self);

    static final String getFilename(IconInfo self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_info_get_filename(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_icon_info_get_filename(long self);

    static final Pixbuf getBuiltinPixbuf(IconInfo self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_info_get_builtin_pixbuf(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_icon_info_get_builtin_pixbuf(long self);

    static final Pixbuf loadIcon(IconInfo self) throws GlibException {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_info_load_icon(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_icon_info_load_icon(long self) throws GlibException;

    static final void setRawCoordinates(IconInfo self, boolean rawCoordinates) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_icon_info_set_raw_coordinates(pointerOf(self), rawCoordinates);
        }
    }

    private static native final void gtk_icon_info_set_raw_coordinates(long self, boolean rawCoordinates);

    static final boolean getEmbeddedRect(IconInfo self, Rectangle rectangle) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rectangle == null) {
            throw new IllegalArgumentException("rectangle can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_info_get_embedded_rect(pointerOf(self), pointerOf(rectangle));

            return result;
        }
    }

    private static native final boolean gtk_icon_info_get_embedded_rect(long self, long rectangle);

    static final boolean getAttachPoints(IconInfo self, Point[] points, int[] nPoints) {
        boolean result;
        long[] _points;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (points == null) {
            throw new IllegalArgumentException("points can't be null");
        }

        if (nPoints == null) {
            throw new IllegalArgumentException("nPoints can't be null");
        }

        _points = pointersOf(points);

        synchronized (lock) {
            result = gtk_icon_info_get_attach_points(pointerOf(self), _points, nPoints);
            fillBoxedArray(Point.class, points, _points);

            return result;
        }
    }

    private static native final boolean gtk_icon_info_get_attach_points(long self, long[] points, int[] nPoints);

    static final String getDisplayName(IconInfo self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_info_get_display_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_icon_info_get_display_name(long self);
}

