/*
 * GtkIconTheme.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.Screen;
import org.gnome.glib.GlibException;
import org.gnome.glib.Signal;
import org.gnome.gtk.IconInfo;
import org.gnome.gtk.IconLookupFlags;
import org.gnome.gtk.IconTheme;
import org.gnome.gtk.Plumbing;

final class GtkIconTheme extends Plumbing
{
    private GtkIconTheme() {}

    static final long createIconTheme() {
        long result;

        synchronized (lock) {
            result = gtk_icon_theme_new();

            return result;
        }
    }

    private static native final long gtk_icon_theme_new();

    static final void setScreen(IconTheme self, Screen screen) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (screen == null) {
            throw new IllegalArgumentException("screen can't be null");
        }

        synchronized (lock) {
            gtk_icon_theme_set_screen(pointerOf(self), pointerOf(screen));
        }
    }

    private static native final void gtk_icon_theme_set_screen(long self, long screen);

    static final void setSearchPath(IconTheme self, FIXME path, int nElements) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("const-gchar*[]");
    }

    static final void getSearchPath(IconTheme self, FIXME path, int[] nElements) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("gchar**[]");
    }

    static final void appendSearchPath(IconTheme self, String path) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            gtk_icon_theme_append_search_path(pointerOf(self), path);
        }
    }

    private static native final void gtk_icon_theme_append_search_path(long self, String path);

    static final void prependSearchPath(IconTheme self, String path) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            gtk_icon_theme_prepend_search_path(pointerOf(self), path);
        }
    }

    private static native final void gtk_icon_theme_prepend_search_path(long self, String path);

    static final void setCustomTheme(IconTheme self, String themeName) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (themeName == null) {
            throw new IllegalArgumentException("themeName can't be null");
        }

        synchronized (lock) {
            gtk_icon_theme_set_custom_theme(pointerOf(self), themeName);
        }
    }

    private static native final void gtk_icon_theme_set_custom_theme(long self, String themeName);

    static final boolean hasIcon(IconTheme self, String iconName) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconName == null) {
            throw new IllegalArgumentException("iconName can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_theme_has_icon(pointerOf(self), iconName);

            return result;
        }
    }

    private static native final boolean gtk_icon_theme_has_icon(long self, String iconName);

    static final IconInfo lookupIcon(IconTheme self, String iconName, int size, IconLookupFlags flags) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconName == null) {
            throw new IllegalArgumentException("iconName can't be null");
        }

        if (flags == null) {
            throw new IllegalArgumentException("flags can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_theme_lookup_icon(pointerOf(self), iconName, size, numOf(flags));

            return (IconInfo) boxedFor(IconInfo.class, result);
        }
    }

    private static native final long gtk_icon_theme_lookup_icon(long self, String iconName, int size, int flags);

    static final Pixbuf loadIcon(IconTheme self, String iconName, int size, IconLookupFlags flags) throws GlibException {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconName == null) {
            throw new IllegalArgumentException("iconName can't be null");
        }

        if (flags == null) {
            throw new IllegalArgumentException("flags can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_theme_load_icon(pointerOf(self), iconName, size, numOf(flags));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_icon_theme_load_icon(long self, String iconName, int size, int flags) throws GlibException;

    static final FIXME listIcons(IconTheme self, String context) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GList*");
    }

    static final String getExampleIconName(IconTheme self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_theme_get_example_icon_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_icon_theme_get_example_icon_name(long self);

    static final boolean rescanIfNeeded(IconTheme self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_theme_rescan_if_needed(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_icon_theme_rescan_if_needed(long self);

    static final int[] getIconSizes(IconTheme self, String iconName) {
        int[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iconName == null) {
            throw new IllegalArgumentException("iconName can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_theme_get_icon_sizes(pointerOf(self), iconName);

            return result;
        }
    }

    private static native final int[] gtk_icon_theme_get_icon_sizes(long self, String iconName);

    interface ChangedSignal extends Signal
    {
        void onChanged(IconTheme source);
    }

    static final void connect(IconTheme self, GtkIconTheme.ChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkIconTheme.class, "changed", after);
    }

    protected static final void receiveChanged(Signal handler, long source) {
        ((GtkIconTheme.ChangedSignal) handler).onChanged((IconTheme) objectFor(source));
    }

    static final IconTheme getDefault() {
        long result;

        synchronized (lock) {
            result = gtk_icon_theme_get_default();

            return (IconTheme) objectFor(result);
        }
    }

    private static native final long gtk_icon_theme_get_default();

    static final IconTheme getForScreen(Screen screen) {
        long result;

        if (screen == null) {
            throw new IllegalArgumentException("screen can't be null");
        }

        synchronized (lock) {
            result = gtk_icon_theme_get_for_screen(pointerOf(screen));

            return (IconTheme) objectFor(result);
        }
    }

    private static native final long gtk_icon_theme_get_for_screen(long screen);

    static final void addBuiltinIcon(String iconName, int size, Pixbuf pixbuf) {
        if (iconName == null) {
            throw new IllegalArgumentException("iconName can't be null");
        }

        if (pixbuf == null) {
            throw new IllegalArgumentException("pixbuf can't be null");
        }

        synchronized (lock) {
            gtk_icon_theme_add_builtin_icon(iconName, size, pointerOf(pixbuf));
        }
    }

    private static native final void gtk_icon_theme_add_builtin_icon(String iconName, int size, long pixbuf);
}

