/*
 * GtkInputDialog.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Device;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;

final class GtkInputDialog extends Plumbing
{
    private GtkInputDialog() {}

    static final long createInputDialog() {
        long result;

        synchronized (lock) {
            result = gtk_input_dialog_new();

            return result;
        }
    }

    private static native final long gtk_input_dialog_new();

    interface EnableDeviceSignal extends Signal
    {
        void onEnableDevice(InputDialog source, Device device);
    }

    static final void connect(InputDialog self, GtkInputDialog.EnableDeviceSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkInputDialog.class, "enable-device", after);
    }

    protected static final void receiveEnableDevice(Signal handler, long source, long device) {
        ((GtkInputDialog.EnableDeviceSignal) handler).onEnableDevice((InputDialog) objectFor(source), (Device) objectFor(device));
    }

    interface DisableDeviceSignal extends Signal
    {
        void onDisableDevice(InputDialog source, Device device);
    }

    static final void connect(InputDialog self, GtkInputDialog.DisableDeviceSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkInputDialog.class, "disable-device", after);
    }

    protected static final void receiveDisableDevice(Signal handler, long source, long device) {
        ((GtkInputDialog.DisableDeviceSignal) handler).onDisableDevice((InputDialog) objectFor(source), (Device) objectFor(device));
    }
}

