/*
 * GtkMenu.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Screen;
import org.gnome.gtk.AccelGroup;
import org.gnome.gtk.Menu;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;

final class GtkMenu extends Plumbing
{
    private GtkMenu() {}

    static final long createMenu() {
        long result;

        synchronized (lock) {
            result = gtk_menu_new();

            return result;
        }
    }

    private static native final long gtk_menu_new();

    static final void popup(Menu self, Widget parentMenuShell, Widget parentMenuItem, FIXME func, FIXME data, int button, int activateTime) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkMenuPositionFunc");
    }

    static final void reposition(Menu self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_menu_reposition(pointerOf(self));
        }
    }

    private static native final void gtk_menu_reposition(long self);

    static final void popdown(Menu self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_menu_popdown(pointerOf(self));
        }
    }

    private static native final void gtk_menu_popdown(long self);

    static final Widget getActive(Menu self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_menu_get_active(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_menu_get_active(long self);

    static final void setActive(Menu self, int index) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_menu_set_active(pointerOf(self), index);
        }
    }

    private static native final void gtk_menu_set_active(long self, int index);

    static final void setAccelGroup(Menu self, AccelGroup accelGroup) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_menu_set_accel_group(pointerOf(self), pointerOf(accelGroup));
        }
    }

    private static native final void gtk_menu_set_accel_group(long self, long accelGroup);

    static final AccelGroup getAccelGroup(Menu self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_menu_get_accel_group(pointerOf(self));

            return (AccelGroup) objectFor(result);
        }
    }

    private static native final long gtk_menu_get_accel_group(long self);

    static final void setAccelPath(Menu self, String accelPath) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_menu_set_accel_path(pointerOf(self), accelPath);
        }
    }

    private static native final void gtk_menu_set_accel_path(long self, String accelPath);

    static final void attachToWidget(Menu self, Widget attachWidget, FIXME detacher) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkMenuDetachFunc");
    }

    static final void detach(Menu self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_menu_detach(pointerOf(self));
        }
    }

    private static native final void gtk_menu_detach(long self);

    static final Widget getAttachWidget(Menu self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_menu_get_attach_widget(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_menu_get_attach_widget(long self);

    static final void setTearoffState(Menu self, boolean tornOff) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_menu_set_tearoff_state(pointerOf(self), tornOff);
        }
    }

    private static native final void gtk_menu_set_tearoff_state(long self, boolean tornOff);

    static final boolean getTearoffState(Menu self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_menu_get_tearoff_state(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_menu_get_tearoff_state(long self);

    static final void setTitle(Menu self, String title) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        synchronized (lock) {
            gtk_menu_set_title(pointerOf(self), title);
        }
    }

    private static native final void gtk_menu_set_title(long self, String title);

    static final String getTitle(Menu self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_menu_get_title(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_menu_get_title(long self);

    static final void reorderChild(Menu self, Widget child, int position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_menu_reorder_child(pointerOf(self), pointerOf(child), position);
        }
    }

    private static native final void gtk_menu_reorder_child(long self, long child, int position);

    static final void setScreen(Menu self, Screen screen) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_menu_set_screen(pointerOf(self), pointerOf(screen));
        }
    }

    private static native final void gtk_menu_set_screen(long self, long screen);

    static final void attach(Menu self, Widget child, int leftAttach, int rightAttach, int topAttach, int bottomAttach) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_menu_attach(pointerOf(self), pointerOf(child), leftAttach, rightAttach, topAttach, bottomAttach);
        }
    }

    private static native final void gtk_menu_attach(long self, long child, int leftAttach, int rightAttach, int topAttach, int bottomAttach);

    static final void setMonitor(Menu self, int monitorNum) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_menu_set_monitor(pointerOf(self), monitorNum);
        }
    }

    private static native final void gtk_menu_set_monitor(long self, int monitorNum);
}

