/*
 * GtkMessageDialog.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gtk.ButtonsType;
import org.gnome.gtk.DialogFlags;
import org.gnome.gtk.MessageDialog;
import org.gnome.gtk.MessageType;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Widget;
import org.gnome.gtk.Window;

final class GtkMessageDialog extends Plumbing
{
    private GtkMessageDialog() {}

    static final long createMessageDialog(Window parent, DialogFlags flags, MessageType type, ButtonsType buttons, String messageFormat) {
        long result;

        if (flags == null) {
            throw new IllegalArgumentException("flags can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        if (buttons == null) {
            throw new IllegalArgumentException("buttons can't be null");
        }

        synchronized (lock) {
            result = gtk_message_dialog_new(pointerOf(parent), numOf(flags), numOf(type), numOf(buttons), messageFormat);

            return result;
        }
    }

    private static native final long gtk_message_dialog_new(long parent, int flags, int type, int buttons, String messageFormat);

    static final long createMessageDialogWithMarkup(Window parent, DialogFlags flags, MessageType type, ButtonsType buttons, String messageFormat) {
        long result;

        if (parent == null) {
            throw new IllegalArgumentException("parent can't be null");
        }

        if (flags == null) {
            throw new IllegalArgumentException("flags can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        if (buttons == null) {
            throw new IllegalArgumentException("buttons can't be null");
        }

        if (messageFormat == null) {
            throw new IllegalArgumentException("messageFormat can't be null");
        }

        synchronized (lock) {
            result = gtk_message_dialog_new_with_markup(pointerOf(parent), numOf(flags), numOf(type), numOf(buttons), messageFormat);

            return result;
        }
    }

    private static native final long gtk_message_dialog_new_with_markup(long parent, int flags, int type, int buttons, String messageFormat);

    static final void setMarkup(MessageDialog self, String str) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (str == null) {
            throw new IllegalArgumentException("str can't be null");
        }

        synchronized (lock) {
            gtk_message_dialog_set_markup(pointerOf(self), str);
        }
    }

    private static native final void gtk_message_dialog_set_markup(long self, String str);

    static final void formatSecondaryText(MessageDialog self, String messageFormat) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (messageFormat == null) {
            throw new IllegalArgumentException("messageFormat can't be null");
        }

        synchronized (lock) {
            gtk_message_dialog_format_secondary_text(pointerOf(self), messageFormat);
        }
    }

    private static native final void gtk_message_dialog_format_secondary_text(long self, String messageFormat);

    static final void formatSecondaryMarkup(MessageDialog self, String messageFormat) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (messageFormat == null) {
            throw new IllegalArgumentException("messageFormat can't be null");
        }

        synchronized (lock) {
            gtk_message_dialog_format_secondary_markup(pointerOf(self), messageFormat);
        }
    }

    private static native final void gtk_message_dialog_format_secondary_markup(long self, String messageFormat);

    static final void setImage(MessageDialog self, Widget image) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (image == null) {
            throw new IllegalArgumentException("image can't be null");
        }

        synchronized (lock) {
            gtk_message_dialog_set_image(pointerOf(self), pointerOf(image));
        }
    }

    private static native final void gtk_message_dialog_set_image(long self, long image);
}

