/*
 * GtkPaned.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Paned;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ScrollType;
import org.gnome.gtk.Widget;

final class GtkPaned extends Plumbing
{
    private GtkPaned() {}

    static final void add1(Paned self, Widget child) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_paned_add1(pointerOf(self), pointerOf(child));
        }
    }

    private static native final void gtk_paned_add1(long self, long child);

    static final void add2(Paned self, Widget child) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_paned_add2(pointerOf(self), pointerOf(child));
        }
    }

    private static native final void gtk_paned_add2(long self, long child);

    static final void pack1(Paned self, Widget child, boolean resize, boolean shrink) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_paned_pack1(pointerOf(self), pointerOf(child), resize, shrink);
        }
    }

    private static native final void gtk_paned_pack1(long self, long child, boolean resize, boolean shrink);

    static final void pack2(Paned self, Widget child, boolean resize, boolean shrink) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        synchronized (lock) {
            gtk_paned_pack2(pointerOf(self), pointerOf(child), resize, shrink);
        }
    }

    private static native final void gtk_paned_pack2(long self, long child, boolean resize, boolean shrink);

    static final int getPosition(Paned self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_paned_get_position(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_paned_get_position(long self);

    static final void setPosition(Paned self, int position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_paned_set_position(pointerOf(self), position);
        }
    }

    private static native final void gtk_paned_set_position(long self, int position);

    static final Widget getChild1(Paned self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_paned_get_child1(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_paned_get_child1(long self);

    static final Widget getChild2(Paned self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_paned_get_child2(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_paned_get_child2(long self);

    interface CycleChildFocusSignal extends Signal
    {
        boolean onCycleChildFocus(Paned source, boolean reverse);
    }

    static final void connect(Paned self, GtkPaned.CycleChildFocusSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPaned.class, "cycle-child-focus", after);
    }

    protected static final boolean receiveCycleChildFocus(Signal handler, long source, boolean reverse) {
        boolean result;

        result = ((GtkPaned.CycleChildFocusSignal) handler).onCycleChildFocus((Paned) objectFor(source), reverse);

        return result;
    }

    interface ToggleHandleFocusSignal extends Signal
    {
        boolean onToggleHandleFocus(Paned source);
    }

    static final void connect(Paned self, GtkPaned.ToggleHandleFocusSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPaned.class, "toggle-handle-focus", after);
    }

    protected static final boolean receiveToggleHandleFocus(Signal handler, long source) {
        boolean result;

        result = ((GtkPaned.ToggleHandleFocusSignal) handler).onToggleHandleFocus((Paned) objectFor(source));

        return result;
    }

    interface MoveHandleSignal extends Signal
    {
        boolean onMoveHandle(Paned source, ScrollType scroll);
    }

    static final void connect(Paned self, GtkPaned.MoveHandleSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPaned.class, "move-handle", after);
    }

    protected static final boolean receiveMoveHandle(Signal handler, long source, int scroll) {
        boolean result;

        result = ((GtkPaned.MoveHandleSignal) handler).onMoveHandle((Paned) objectFor(source), (ScrollType) enumFor(ScrollType.class, scroll));

        return result;
    }

    interface CycleHandleFocusSignal extends Signal
    {
        boolean onCycleHandleFocus(Paned source, boolean reverse);
    }

    static final void connect(Paned self, GtkPaned.CycleHandleFocusSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPaned.class, "cycle-handle-focus", after);
    }

    protected static final boolean receiveCycleHandleFocus(Signal handler, long source, boolean reverse) {
        boolean result;

        result = ((GtkPaned.CycleHandleFocusSignal) handler).onCycleHandleFocus((Paned) objectFor(source), reverse);

        return result;
    }

    interface AcceptPositionSignal extends Signal
    {
        boolean onAcceptPosition(Paned source);
    }

    static final void connect(Paned self, GtkPaned.AcceptPositionSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPaned.class, "accept-position", after);
    }

    protected static final boolean receiveAcceptPosition(Signal handler, long source) {
        boolean result;

        result = ((GtkPaned.AcceptPositionSignal) handler).onAcceptPosition((Paned) objectFor(source));

        return result;
    }

    interface CancelPositionSignal extends Signal
    {
        boolean onCancelPosition(Paned source);
    }

    static final void connect(Paned self, GtkPaned.CancelPositionSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPaned.class, "cancel-position", after);
    }

    protected static final boolean receiveCancelPosition(Signal handler, long source) {
        boolean result;

        result = ((GtkPaned.CancelPositionSignal) handler).onCancelPosition((Paned) objectFor(source));

        return result;
    }
}

