/*
 * GtkPaperSize.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.PaperSize;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Unit;

final class GtkPaperSize extends Plumbing
{
    private GtkPaperSize() {}

    static final long createPaperSize(String name) {
        long result;

        synchronized (lock) {
            result = gtk_paper_size_new(name);

            return result;
        }
    }

    private static native final long gtk_paper_size_new(String name);

    static final PaperSize copy(PaperSize self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_copy(pointerOf(self));

            return (PaperSize) boxedFor(PaperSize.class, result);
        }
    }

    private static native final long gtk_paper_size_copy(long self);

    static final void free(PaperSize self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_paper_size_free(pointerOf(self));
        }
    }

    private static native final void gtk_paper_size_free(long self);

    static final boolean isEqual(PaperSize self, PaperSize size2) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (size2 == null) {
            throw new IllegalArgumentException("size2 can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_is_equal(pointerOf(self), pointerOf(size2));

            return result;
        }
    }

    private static native final boolean gtk_paper_size_is_equal(long self, long size2);

    static final String getName(PaperSize self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_get_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_paper_size_get_name(long self);

    static final String getDisplayName(PaperSize self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_get_display_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_paper_size_get_display_name(long self);

    static final String getPpdName(PaperSize self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_get_ppd_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_paper_size_get_ppd_name(long self);

    static final double getWidth(PaperSize self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_get_width(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_paper_size_get_width(long self, int unit);

    static final double getHeight(PaperSize self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_get_height(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_paper_size_get_height(long self, int unit);

    static final boolean isCustom(PaperSize self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_is_custom(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_paper_size_is_custom(long self);

    static final void setSize(PaperSize self, double width, double height, Unit unit) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            gtk_paper_size_set_size(pointerOf(self), width, height, numOf(unit));
        }
    }

    private static native final void gtk_paper_size_set_size(long self, double width, double height, int unit);

    static final double getDefaultTopMargin(PaperSize self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_get_default_top_margin(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_paper_size_get_default_top_margin(long self, int unit);

    static final double getDefaultBottomMargin(PaperSize self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_get_default_bottom_margin(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_paper_size_get_default_bottom_margin(long self, int unit);

    static final double getDefaultLeftMargin(PaperSize self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_get_default_left_margin(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_paper_size_get_default_left_margin(long self, int unit);

    static final double getDefaultRightMargin(PaperSize self, Unit unit) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            result = gtk_paper_size_get_default_right_margin(pointerOf(self), numOf(unit));

            return result;
        }
    }

    private static native final double gtk_paper_size_get_default_right_margin(long self, int unit);
}

