/*
 * GtkPlug.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Display;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plug;
import org.gnome.gtk.Plumbing;

final class GtkPlug extends Plumbing
{
    private GtkPlug() {}

    static final void construct(Plug self, long socketId) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_plug_construct(pointerOf(self), socketId);
        }
    }

    private static native final void gtk_plug_construct(long self, long socketId);

    static final long createPlug(long socketId) {
        long result;

        synchronized (lock) {
            result = gtk_plug_new(socketId);

            return result;
        }
    }

    private static native final long gtk_plug_new(long socketId);

    static final void constructForDisplay(Plug self, Display display, long socketId) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (display == null) {
            throw new IllegalArgumentException("display can't be null");
        }

        synchronized (lock) {
            gtk_plug_construct_for_display(pointerOf(self), pointerOf(display), socketId);
        }
    }

    private static native final void gtk_plug_construct_for_display(long self, long display, long socketId);

    static final long getId(Plug self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_plug_get_id(pointerOf(self));

            return result;
        }
    }

    private static native final long gtk_plug_get_id(long self);

    interface EmbeddedSignal extends Signal
    {
        void onEmbedded(Plug source);
    }

    static final void connect(Plug self, GtkPlug.EmbeddedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPlug.class, "embedded", after);
    }

    protected static final void receiveEmbedded(Signal handler, long source) {
        ((GtkPlug.EmbeddedSignal) handler).onEmbedded((Plug) objectFor(source));
    }
}

