/*
 * GtkPrintContext.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.cairo.Context;
import org.gnome.gtk.PageSetup;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.PrintContext;
import org.gnome.pango.FontMap;
import org.gnome.pango.Layout;

final class GtkPrintContext extends Plumbing
{
    private GtkPrintContext() {}

    static final Context getCairoContext(PrintContext self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_context_get_cairo_context(pointerOf(self));

            return (Context) entityFor(Context.class,  result);
        }
    }

    private static native final long gtk_print_context_get_cairo_context(long self);

    static final PageSetup getPageSetup(PrintContext self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_context_get_page_setup(pointerOf(self));

            return (PageSetup) objectFor(result);
        }
    }

    private static native final long gtk_print_context_get_page_setup(long self);

    static final double getWidth(PrintContext self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_context_get_width(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_print_context_get_width(long self);

    static final double getHeight(PrintContext self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_context_get_height(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_print_context_get_height(long self);

    static final double getDpiX(PrintContext self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_context_get_dpi_x(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_print_context_get_dpi_x(long self);

    static final double getDpiY(PrintContext self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_context_get_dpi_y(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_print_context_get_dpi_y(long self);

    static final FontMap getPangoFontmap(PrintContext self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_context_get_pango_fontmap(pointerOf(self));

            return (FontMap) objectFor(result);
        }
    }

    private static native final long gtk_print_context_get_pango_fontmap(long self);

    static final org.gnome.pango.Context createPangoContext(PrintContext self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_context_create_pango_context(pointerOf(self));

            return (org.gnome.pango.Context) objectFor(result);
        }
    }

    private static native final long gtk_print_context_create_pango_context(long self);

    static final Layout createPangoLayout(PrintContext self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_context_create_pango_layout(pointerOf(self));

            return (Layout) objectFor(result);
        }
    }

    private static native final long gtk_print_context_create_pango_layout(long self);

    static final void setCairoContext(PrintContext self, Context cr, double dpiX, double dpiY) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (cr == null) {
            throw new IllegalArgumentException("cr can't be null");
        }

        synchronized (lock) {
            gtk_print_context_set_cairo_context(pointerOf(self), pointerOf(cr), dpiX, dpiY);
        }
    }

    private static native final void gtk_print_context_set_cairo_context(long self, long cr, double dpiX, double dpiY);
}

