/*
 * GtkPrintOperation.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.GlibException;
import org.gnome.glib.Object;
import org.gnome.glib.Signal;
import org.gnome.gtk.PageSetup;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.PrintContext;
import org.gnome.gtk.PrintOperation;
import org.gnome.gtk.PrintOperationAction;
import org.gnome.gtk.PrintOperationPreview;
import org.gnome.gtk.PrintOperationResult;
import org.gnome.gtk.PrintSettings;
import org.gnome.gtk.PrintStatus;
import org.gnome.gtk.Unit;
import org.gnome.gtk.Widget;
import org.gnome.gtk.Window;

final class GtkPrintOperation extends Plumbing
{
    private GtkPrintOperation() {}

    static final long createPrintOperation() {
        long result;

        synchronized (lock) {
            result = gtk_print_operation_new();

            return result;
        }
    }

    private static native final long gtk_print_operation_new();

    static final void setDefaultPageSetup(PrintOperation self, PageSetup defaultPageSetup) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_default_page_setup(pointerOf(self), pointerOf(defaultPageSetup));
        }
    }

    private static native final void gtk_print_operation_set_default_page_setup(long self, long defaultPageSetup);

    static final PageSetup getDefaultPageSetup(PrintOperation self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_operation_get_default_page_setup(pointerOf(self));

            return (PageSetup) objectFor(result);
        }
    }

    private static native final long gtk_print_operation_get_default_page_setup(long self);

    static final void setPrintSettings(PrintOperation self, PrintSettings printSettings) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_print_settings(pointerOf(self), pointerOf(printSettings));
        }
    }

    private static native final void gtk_print_operation_set_print_settings(long self, long printSettings);

    static final PrintSettings getPrintSettings(PrintOperation self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_operation_get_print_settings(pointerOf(self));

            return (PrintSettings) objectFor(result);
        }
    }

    private static native final long gtk_print_operation_get_print_settings(long self);

    static final void setJobName(PrintOperation self, String jobName) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (jobName == null) {
            throw new IllegalArgumentException("jobName can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_job_name(pointerOf(self), jobName);
        }
    }

    private static native final void gtk_print_operation_set_job_name(long self, String jobName);

    static final void setNPages(PrintOperation self, int nPages) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_n_pages(pointerOf(self), nPages);
        }
    }

    private static native final void gtk_print_operation_set_n_pages(long self, int nPages);

    static final void setCurrentPage(PrintOperation self, int currentPage) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_current_page(pointerOf(self), currentPage);
        }
    }

    private static native final void gtk_print_operation_set_current_page(long self, int currentPage);

    static final void setUseFullPage(PrintOperation self, boolean fullPage) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_use_full_page(pointerOf(self), fullPage);
        }
    }

    private static native final void gtk_print_operation_set_use_full_page(long self, boolean fullPage);

    static final void setUnit(PrintOperation self, Unit unit) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (unit == null) {
            throw new IllegalArgumentException("unit can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_unit(pointerOf(self), numOf(unit));
        }
    }

    private static native final void gtk_print_operation_set_unit(long self, int unit);

    static final void setExportFilename(PrintOperation self, String filename) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (filename == null) {
            throw new IllegalArgumentException("filename can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_export_filename(pointerOf(self), filename);
        }
    }

    private static native final void gtk_print_operation_set_export_filename(long self, String filename);

    static final void setTrackPrintStatus(PrintOperation self, boolean trackStatus) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_track_print_status(pointerOf(self), trackStatus);
        }
    }

    private static native final void gtk_print_operation_set_track_print_status(long self, boolean trackStatus);

    static final void setShowProgress(PrintOperation self, boolean showProgress) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_show_progress(pointerOf(self), showProgress);
        }
    }

    private static native final void gtk_print_operation_set_show_progress(long self, boolean showProgress);

    static final void setAllowAsync(PrintOperation self, boolean allowAsync) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_allow_async(pointerOf(self), allowAsync);
        }
    }

    private static native final void gtk_print_operation_set_allow_async(long self, boolean allowAsync);

    static final void setCustomTabLabel(PrintOperation self, String label) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_set_custom_tab_label(pointerOf(self), label);
        }
    }

    private static native final void gtk_print_operation_set_custom_tab_label(long self, String label);

    static final PrintOperationResult run(PrintOperation self, PrintOperationAction action, Window parent) throws GlibException {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (action == null) {
            throw new IllegalArgumentException("action can't be null");
        }

        synchronized (lock) {
            result = gtk_print_operation_run(pointerOf(self), numOf(action), pointerOf(parent));

            return (PrintOperationResult) enumFor(PrintOperationResult.class, result);
        }
    }

    private static native final int gtk_print_operation_run(long self, int action, long parent) throws GlibException;

    static final void getError(PrintOperation self) throws GlibException {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_get_error(pointerOf(self));
        }
    }

    private static native final void gtk_print_operation_get_error(long self) throws GlibException;

    static final PrintStatus getStatus(PrintOperation self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_operation_get_status(pointerOf(self));

            return (PrintStatus) enumFor(PrintStatus.class, result);
        }
    }

    private static native final int gtk_print_operation_get_status(long self);

    static final String getStatusString(PrintOperation self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_operation_get_status_string(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_print_operation_get_status_string(long self);

    static final boolean isFinished(PrintOperation self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_operation_is_finished(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_print_operation_is_finished(long self);

    static final void cancel(PrintOperation self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_operation_cancel(pointerOf(self));
        }
    }

    private static native final void gtk_print_operation_cancel(long self);

    interface DoneSignal extends Signal
    {
        void onDone(PrintOperation source, PrintOperationResult result);
    }

    static final void connect(PrintOperation self, GtkPrintOperation.DoneSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrintOperation.class, "done", after);
    }

    protected static final void receiveDone(Signal handler, long source, int result) {
        ((GtkPrintOperation.DoneSignal) handler).onDone((PrintOperation) objectFor(source), (PrintOperationResult) enumFor(PrintOperationResult.class, result));
    }

    interface BeginPrintSignal extends Signal
    {
        void onBeginPrint(PrintOperation source, PrintContext context);
    }

    static final void connect(PrintOperation self, GtkPrintOperation.BeginPrintSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrintOperation.class, "begin-print", after);
    }

    protected static final void receiveBeginPrint(Signal handler, long source, long context) {
        ((GtkPrintOperation.BeginPrintSignal) handler).onBeginPrint((PrintOperation) objectFor(source), (PrintContext) objectFor(context));
    }

    interface PaginateSignal extends Signal
    {
        boolean onPaginate(PrintOperation source, PrintContext context);
    }

    static final void connect(PrintOperation self, GtkPrintOperation.PaginateSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrintOperation.class, "paginate", after);
    }

    protected static final boolean receivePaginate(Signal handler, long source, long context) {
        boolean result;

        result = ((GtkPrintOperation.PaginateSignal) handler).onPaginate((PrintOperation) objectFor(source), (PrintContext) objectFor(context));

        return result;
    }

    interface RequestPageSetupSignal extends Signal
    {
        void onRequestPageSetup(PrintOperation source, PrintContext context, int pageNr, PageSetup setup);
    }

    static final void connect(PrintOperation self, GtkPrintOperation.RequestPageSetupSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrintOperation.class, "request-page-setup", after);
    }

    protected static final void receiveRequestPageSetup(Signal handler, long source, long context, int pageNr, long setup) {
        ((GtkPrintOperation.RequestPageSetupSignal) handler).onRequestPageSetup((PrintOperation) objectFor(source), (PrintContext) objectFor(context), pageNr, (PageSetup) objectFor(setup));
    }

    interface DrawPageSignal extends Signal
    {
        void onDrawPage(PrintOperation source, PrintContext context, int pageNr);
    }

    static final void connect(PrintOperation self, GtkPrintOperation.DrawPageSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrintOperation.class, "draw-page", after);
    }

    protected static final void receiveDrawPage(Signal handler, long source, long context, int pageNr) {
        ((GtkPrintOperation.DrawPageSignal) handler).onDrawPage((PrintOperation) objectFor(source), (PrintContext) objectFor(context), pageNr);
    }

    interface EndPrintSignal extends Signal
    {
        void onEndPrint(PrintOperation source, PrintContext context);
    }

    static final void connect(PrintOperation self, GtkPrintOperation.EndPrintSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrintOperation.class, "end-print", after);
    }

    protected static final void receiveEndPrint(Signal handler, long source, long context) {
        ((GtkPrintOperation.EndPrintSignal) handler).onEndPrint((PrintOperation) objectFor(source), (PrintContext) objectFor(context));
    }

    interface StatusChangedSignal extends Signal
    {
        void onStatusChanged(PrintOperation source);
    }

    static final void connect(PrintOperation self, GtkPrintOperation.StatusChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrintOperation.class, "status-changed", after);
    }

    protected static final void receiveStatusChanged(Signal handler, long source) {
        ((GtkPrintOperation.StatusChangedSignal) handler).onStatusChanged((PrintOperation) objectFor(source));
    }

    interface CreateCustomWidgetSignal extends Signal
    {
        Widget onCreateCustomWidget(PrintOperation source);
    }

    static final void connect(PrintOperation self, GtkPrintOperation.CreateCustomWidgetSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrintOperation.class, "create-custom-widget", after);
    }

    protected static final long receiveCreateCustomWidget(Signal handler, long source) {
        Widget result;

        result = ((GtkPrintOperation.CreateCustomWidgetSignal) handler).onCreateCustomWidget((PrintOperation) objectFor(source));

        return pointerOf(result);
    }

    interface CustomWidgetApplySignal extends Signal
    {
        void onCustomWidgetApply(PrintOperation source, Widget widget);
    }

    static final void connect(PrintOperation self, GtkPrintOperation.CustomWidgetApplySignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrintOperation.class, "custom-widget-apply", after);
    }

    protected static final void receiveCustomWidgetApply(Signal handler, long source, long widget) {
        ((GtkPrintOperation.CustomWidgetApplySignal) handler).onCustomWidgetApply((PrintOperation) objectFor(source), (Widget) objectFor(widget));
    }

    interface PreviewSignal extends Signal
    {
        boolean onPreview(PrintOperation source, PrintOperationPreview preview, PrintContext context, Window parent);
    }

    static final void connect(PrintOperation self, GtkPrintOperation.PreviewSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkPrintOperation.class, "preview", after);
    }

    protected static final boolean receivePreview(Signal handler, long source, long preview, long context, long parent) {
        boolean result;

        result = ((GtkPrintOperation.PreviewSignal) handler).onPreview((PrintOperation) objectFor(source), (PrintOperationPreview) objectFor(preview), (PrintContext) objectFor(context), (Window) objectFor(parent));

        return result;
    }
}

