/*
 * GtkRadioButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.RadioButton;

final class GtkRadioButton extends Plumbing
{
    private GtkRadioButton() {}

    static final long createRadioButton(RadioButton[] group) {
        long result;
        long[] _group;

        _group = pointersOf(group);

        synchronized (lock) {
            result = gtk_radio_button_new(_group);
            fillObjectArray(group, _group);

            return result;
        }
    }

    private static native final long gtk_radio_button_new(long[] group);

    static final long createRadioButtonFromWidget(RadioButton radioGroupMember) {
        long result;

        synchronized (lock) {
            result = gtk_radio_button_new_from_widget(pointerOf(radioGroupMember));

            return result;
        }
    }

    private static native final long gtk_radio_button_new_from_widget(long radioGroupMember);

    static final long createRadioButtonWithLabel(RadioButton[] group, String label) {
        long result;
        long[] _group;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        _group = pointersOf(group);

        synchronized (lock) {
            result = gtk_radio_button_new_with_label(_group, label);
            fillObjectArray(group, _group);

            return result;
        }
    }

    private static native final long gtk_radio_button_new_with_label(long[] group, String label);

    static final long createRadioButtonWithLabelFromWidget(RadioButton radioGroupMember, String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_button_new_with_label_from_widget(pointerOf(radioGroupMember), label);

            return result;
        }
    }

    private static native final long gtk_radio_button_new_with_label_from_widget(long radioGroupMember, String label);

    static final long createRadioButtonWithMnemonic(RadioButton[] group, String label) {
        long result;
        long[] _group;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        _group = pointersOf(group);

        synchronized (lock) {
            result = gtk_radio_button_new_with_mnemonic(_group, label);
            fillObjectArray(group, _group);

            return result;
        }
    }

    private static native final long gtk_radio_button_new_with_mnemonic(long[] group, String label);

    static final long createRadioButtonWithMnemonicFromWidget(RadioButton group, String label) {
        long result;

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_button_new_with_mnemonic_from_widget(pointerOf(group), label);

            return result;
        }
    }

    private static native final long gtk_radio_button_new_with_mnemonic_from_widget(long group, String label);

    static final RadioButton[] getGroup(RadioButton self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_button_get_group(pointerOf(self));

            return (RadioButton[]) objectArrayFor(result, new RadioButton[result.length]);
        }
    }

    private static native final long[] gtk_radio_button_get_group(long self);

    static final void setGroup(RadioButton self, RadioButton[] group) {
        long[] _group;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (group == null) {
            throw new IllegalArgumentException("group can't be null");
        }

        _group = pointersOf(group);

        synchronized (lock) {
            gtk_radio_button_set_group(pointerOf(self), _group);
            fillObjectArray(group, _group);
        }
    }

    private static native final void gtk_radio_button_set_group(long self, long[] group);

    interface GroupChangedSignal extends Signal
    {
        void onGroupChanged(RadioButton source);
    }

    static final void connect(RadioButton self, GtkRadioButton.GroupChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRadioButton.class, "group-changed", after);
    }

    protected static final void receiveGroupChanged(Signal handler, long source) {
        ((GtkRadioButton.GroupChangedSignal) handler).onGroupChanged((RadioButton) objectFor(source));
    }
}

