/*
 * GtkRadioMenuItem.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.RadioMenuItem;
import org.gnome.gtk.Widget;

final class GtkRadioMenuItem extends Plumbing
{
    private GtkRadioMenuItem() {}

    static final long createRadioMenuItem(RadioMenuItem[] group) {
        long result;
        long[] _group;

        if (group == null) {
            throw new IllegalArgumentException("group can't be null");
        }

        _group = pointersOf(group);

        synchronized (lock) {
            result = gtk_radio_menu_item_new(_group);
            fillObjectArray(group, _group);

            return result;
        }
    }

    private static native final long gtk_radio_menu_item_new(long[] group);

    static final long createRadioMenuItemWithLabel(RadioMenuItem[] group, String label) {
        long result;
        long[] _group;

        if (group == null) {
            throw new IllegalArgumentException("group can't be null");
        }

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        _group = pointersOf(group);

        synchronized (lock) {
            result = gtk_radio_menu_item_new_with_label(_group, label);
            fillObjectArray(group, _group);

            return result;
        }
    }

    private static native final long gtk_radio_menu_item_new_with_label(long[] group, String label);

    static final long createRadioMenuItemWithMnemonic(RadioMenuItem[] group, String label) {
        long result;
        long[] _group;

        if (group == null) {
            throw new IllegalArgumentException("group can't be null");
        }

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        _group = pointersOf(group);

        synchronized (lock) {
            result = gtk_radio_menu_item_new_with_mnemonic(_group, label);
            fillObjectArray(group, _group);

            return result;
        }
    }

    private static native final long gtk_radio_menu_item_new_with_mnemonic(long[] group, String label);

    static final Widget newFromWidget(RadioMenuItem self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_menu_item_new_from_widget(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_radio_menu_item_new_from_widget(long self);

    static final Widget newWithMnemonicFromWidget(RadioMenuItem self, String label) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_menu_item_new_with_mnemonic_from_widget(pointerOf(self), label);

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_radio_menu_item_new_with_mnemonic_from_widget(long self, String label);

    static final Widget newWithLabelFromWidget(RadioMenuItem self, String label) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (label == null) {
            throw new IllegalArgumentException("label can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_menu_item_new_with_label_from_widget(pointerOf(self), label);

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_radio_menu_item_new_with_label_from_widget(long self, String label);

    static final RadioMenuItem[] getGroup(RadioMenuItem self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_menu_item_get_group(pointerOf(self));

            return (RadioMenuItem[]) objectArrayFor(result, new RadioMenuItem[result.length]);
        }
    }

    private static native final long[] gtk_radio_menu_item_get_group(long self);

    static final void setGroup(RadioMenuItem self, RadioMenuItem[] group) {
        long[] _group;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (group == null) {
            throw new IllegalArgumentException("group can't be null");
        }

        _group = pointersOf(group);

        synchronized (lock) {
            gtk_radio_menu_item_set_group(pointerOf(self), _group);
            fillObjectArray(group, _group);
        }
    }

    private static native final void gtk_radio_menu_item_set_group(long self, long[] group);

    interface GroupChangedSignal extends Signal
    {
        void onGroupChanged(RadioMenuItem source);
    }

    static final void connect(RadioMenuItem self, GtkRadioMenuItem.GroupChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRadioMenuItem.class, "group-changed", after);
    }

    protected static final void receiveGroupChanged(Signal handler, long source) {
        ((GtkRadioMenuItem.GroupChangedSignal) handler).onGroupChanged((RadioMenuItem) objectFor(source));
    }
}

