/*
 * GtkRadioToolButton.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Plumbing;
import org.gnome.gtk.RadioToolButton;

final class GtkRadioToolButton extends Plumbing
{
    private GtkRadioToolButton() {}

    static final long createRadioToolButton(RadioToolButton[] group) {
        long result;
        long[] _group;

        if (group == null) {
            throw new IllegalArgumentException("group can't be null");
        }

        _group = pointersOf(group);

        synchronized (lock) {
            result = gtk_radio_tool_button_new(_group);
            fillObjectArray(group, _group);

            return result;
        }
    }

    private static native final long gtk_radio_tool_button_new(long[] group);

    static final long createRadioToolButtonFromStock(RadioToolButton[] group, String stockId) {
        long result;
        long[] _group;

        if (group == null) {
            throw new IllegalArgumentException("group can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        _group = pointersOf(group);

        synchronized (lock) {
            result = gtk_radio_tool_button_new_from_stock(_group, stockId);
            fillObjectArray(group, _group);

            return result;
        }
    }

    private static native final long gtk_radio_tool_button_new_from_stock(long[] group, String stockId);

    static final long createRadioToolButtonFromWidget(RadioToolButton group) {
        long result;

        if (group == null) {
            throw new IllegalArgumentException("group can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_tool_button_new_from_widget(pointerOf(group));

            return result;
        }
    }

    private static native final long gtk_radio_tool_button_new_from_widget(long group);

    static final long createRadioToolButtonWithStockFromWidget(RadioToolButton group, String stockId) {
        long result;

        if (group == null) {
            throw new IllegalArgumentException("group can't be null");
        }

        if (stockId == null) {
            throw new IllegalArgumentException("stockId can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_tool_button_new_with_stock_from_widget(pointerOf(group), stockId);

            return result;
        }
    }

    private static native final long gtk_radio_tool_button_new_with_stock_from_widget(long group, String stockId);

    static final void setGroup(RadioToolButton self, RadioToolButton[] group) {
        long[] _group;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (group == null) {
            throw new IllegalArgumentException("group can't be null");
        }

        _group = pointersOf(group);

        synchronized (lock) {
            gtk_radio_tool_button_set_group(pointerOf(self), _group);
            fillObjectArray(group, _group);
        }
    }

    private static native final void gtk_radio_tool_button_set_group(long self, long[] group);

    static final RadioToolButton[] getGroup(RadioToolButton self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_radio_tool_button_get_group(pointerOf(self));

            return (RadioToolButton[]) objectArrayFor(result, new RadioToolButton[result.length]);
        }
    }

    private static native final long[] gtk_radio_tool_button_get_group(long self);
}

