/*
 * GtkRange.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Adjustment;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Range;
import org.gnome.gtk.ScrollType;
import org.gnome.gtk.SensitivityType;
import org.gnome.gtk.UpdateType;

final class GtkRange extends Plumbing
{
    private GtkRange() {}

    static final void setUpdatePolicy(Range self, UpdateType policy) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (policy == null) {
            throw new IllegalArgumentException("policy can't be null");
        }

        synchronized (lock) {
            gtk_range_set_update_policy(pointerOf(self), numOf(policy));
        }
    }

    private static native final void gtk_range_set_update_policy(long self, int policy);

    static final UpdateType getUpdatePolicy(Range self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_range_get_update_policy(pointerOf(self));

            return (UpdateType) enumFor(UpdateType.class, result);
        }
    }

    private static native final int gtk_range_get_update_policy(long self);

    static final void setAdjustment(Range self, Adjustment adjustment) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (adjustment == null) {
            throw new IllegalArgumentException("adjustment can't be null");
        }

        synchronized (lock) {
            gtk_range_set_adjustment(pointerOf(self), pointerOf(adjustment));
        }
    }

    private static native final void gtk_range_set_adjustment(long self, long adjustment);

    static final Adjustment getAdjustment(Range self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_range_get_adjustment(pointerOf(self));

            return (Adjustment) objectFor(result);
        }
    }

    private static native final long gtk_range_get_adjustment(long self);

    static final void setInverted(Range self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_range_set_inverted(pointerOf(self), setting);
        }
    }

    private static native final void gtk_range_set_inverted(long self, boolean setting);

    static final boolean getInverted(Range self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_range_get_inverted(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_range_get_inverted(long self);

    static final void setIncrements(Range self, double step, double page) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_range_set_increments(pointerOf(self), step, page);
        }
    }

    private static native final void gtk_range_set_increments(long self, double step, double page);

    static final void setRange(Range self, double min, double max) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_range_set_range(pointerOf(self), min, max);
        }
    }

    private static native final void gtk_range_set_range(long self, double min, double max);

    static final void setValue(Range self, double value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_range_set_value(pointerOf(self), value);
        }
    }

    private static native final void gtk_range_set_value(long self, double value);

    static final double getValue(Range self) {
        double result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_range_get_value(pointerOf(self));

            return result;
        }
    }

    private static native final double gtk_range_get_value(long self);

    interface ValueChangedSignal extends Signal
    {
        void onValueChanged(Range source);
    }

    static final void connect(Range self, GtkRange.ValueChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRange.class, "value-changed", after);
    }

    protected static final void receiveValueChanged(Signal handler, long source) {
        ((GtkRange.ValueChangedSignal) handler).onValueChanged((Range) objectFor(source));
    }

    interface AdjustBoundsSignal extends Signal
    {
        void onAdjustBounds(Range source, double newValue);
    }

    static final void connect(Range self, GtkRange.AdjustBoundsSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRange.class, "adjust-bounds", after);
    }

    protected static final void receiveAdjustBounds(Signal handler, long source, double newValue) {
        ((GtkRange.AdjustBoundsSignal) handler).onAdjustBounds((Range) objectFor(source), newValue);
    }

    interface MoveSliderSignal extends Signal
    {
        void onMoveSlider(Range source, ScrollType scroll);
    }

    static final void connect(Range self, GtkRange.MoveSliderSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRange.class, "move-slider", after);
    }

    protected static final void receiveMoveSlider(Signal handler, long source, int scroll) {
        ((GtkRange.MoveSliderSignal) handler).onMoveSlider((Range) objectFor(source), (ScrollType) enumFor(ScrollType.class, scroll));
    }

    interface ChangeValueSignal extends Signal
    {
        boolean onChangeValue(Range source, ScrollType scroll, double newValue);
    }

    static final void connect(Range self, GtkRange.ChangeValueSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRange.class, "change-value", after);
    }

    protected static final boolean receiveChangeValue(Signal handler, long source, int scroll, double newValue) {
        boolean result;

        result = ((GtkRange.ChangeValueSignal) handler).onChangeValue((Range) objectFor(source), (ScrollType) enumFor(ScrollType.class, scroll), newValue);

        return result;
    }

    static final void setLowerStepperSensitivity(Range self, SensitivityType sensitivity) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (sensitivity == null) {
            throw new IllegalArgumentException("sensitivity can't be null");
        }

        synchronized (lock) {
            gtk_range_set_lower_stepper_sensitivity(pointerOf(self), numOf(sensitivity));
        }
    }

    private static native final void gtk_range_set_lower_stepper_sensitivity(long self, int sensitivity);

    static final SensitivityType getLowerStepperSensitivity(Range self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_range_get_lower_stepper_sensitivity(pointerOf(self));

            return (SensitivityType) enumFor(SensitivityType.class, result);
        }
    }

    private static native final int gtk_range_get_lower_stepper_sensitivity(long self);

    static final void setUpperStepperSensitivity(Range self, SensitivityType sensitivity) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (sensitivity == null) {
            throw new IllegalArgumentException("sensitivity can't be null");
        }

        synchronized (lock) {
            gtk_range_set_upper_stepper_sensitivity(pointerOf(self), numOf(sensitivity));
        }
    }

    private static native final void gtk_range_set_upper_stepper_sensitivity(long self, int sensitivity);

    static final SensitivityType getUpperStepperSensitivity(Range self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_range_get_upper_stepper_sensitivity(pointerOf(self));

            return (SensitivityType) enumFor(SensitivityType.class, result);
        }
    }

    private static native final int gtk_range_get_upper_stepper_sensitivity(long self);
}

