/*
 * GtkRecentAction.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Plumbing;
import org.gnome.gtk.RecentAction;
import org.gnome.gtk.RecentManager;

final class GtkRecentAction extends Plumbing
{
    private GtkRecentAction() {}

    static final long createRecentAction(String name, String label, String tooltip, String stockId) {
        long result;

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_action_new(name, label, tooltip, stockId);

            return result;
        }
    }

    private static native final long gtk_recent_action_new(String name, String label, String tooltip, String stockId);

    static final long createRecentActionForManager(String name, String label, String tooltip, String stockId, RecentManager manager) {
        long result;

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_action_new_for_manager(name, label, tooltip, stockId, pointerOf(manager));

            return result;
        }
    }

    private static native final long gtk_recent_action_new_for_manager(String name, String label, String tooltip, String stockId, long manager);

    static final boolean getShowNumbers(RecentAction self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_action_get_show_numbers(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_recent_action_get_show_numbers(long self);

    static final void setShowNumbers(RecentAction self, boolean showNumbers) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_recent_action_set_show_numbers(pointerOf(self), showNumbers);
        }
    }

    private static native final void gtk_recent_action_set_show_numbers(long self, boolean showNumbers);
}

