/*
 * GtkRecentChooserMenu.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Plumbing;
import org.gnome.gtk.RecentChooserMenu;
import org.gnome.gtk.RecentManager;

final class GtkRecentChooserMenu extends Plumbing
{
    private GtkRecentChooserMenu() {}

    static final long createRecentChooserMenuForManager(RecentManager manager) {
        long result;

        if (manager == null) {
            throw new IllegalArgumentException("manager can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_chooser_menu_new_for_manager(pointerOf(manager));

            return result;
        }
    }

    private static native final long gtk_recent_chooser_menu_new_for_manager(long manager);

    static final boolean getShowNumbers(RecentChooserMenu self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_chooser_menu_get_show_numbers(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_recent_chooser_menu_get_show_numbers(long self);

    static final void setShowNumbers(RecentChooserMenu self, boolean showNumbers) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_recent_chooser_menu_set_show_numbers(pointerOf(self), showNumbers);
        }
    }

    private static native final void gtk_recent_chooser_menu_set_show_numbers(long self, boolean showNumbers);
}

