/*
 * GtkRecentManager.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.GlibException;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.RecentInfo;
import org.gnome.gtk.RecentManager;

final class GtkRecentManager extends Plumbing
{
    private GtkRecentManager() {}

    static final long createRecentManager() {
        long result;

        synchronized (lock) {
            result = gtk_recent_manager_new();

            return result;
        }
    }

    private static native final long gtk_recent_manager_new();

    static final boolean addItem(RecentManager self, String uri) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (uri == null) {
            throw new IllegalArgumentException("uri can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_manager_add_item(pointerOf(self), uri);

            return result;
        }
    }

    private static native final boolean gtk_recent_manager_add_item(long self, String uri);

    static final boolean addFull(RecentManager self, String uri, FIXME recentData) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("const-GtkRecentData*");
    }

    static final boolean removeItem(RecentManager self, String uri) throws GlibException {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (uri == null) {
            throw new IllegalArgumentException("uri can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_manager_remove_item(pointerOf(self), uri);

            return result;
        }
    }

    private static native final boolean gtk_recent_manager_remove_item(long self, String uri) throws GlibException;

    static final RecentInfo lookupItem(RecentManager self, String uri) throws GlibException {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (uri == null) {
            throw new IllegalArgumentException("uri can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_manager_lookup_item(pointerOf(self), uri);

            return (RecentInfo) boxedFor(RecentInfo.class, result);
        }
    }

    private static native final long gtk_recent_manager_lookup_item(long self, String uri) throws GlibException;

    static final boolean hasItem(RecentManager self, String uri) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (uri == null) {
            throw new IllegalArgumentException("uri can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_manager_has_item(pointerOf(self), uri);

            return result;
        }
    }

    private static native final boolean gtk_recent_manager_has_item(long self, String uri);

    static final boolean moveItem(RecentManager self, String uri, String newUri) throws GlibException {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (uri == null) {
            throw new IllegalArgumentException("uri can't be null");
        }

        if (newUri == null) {
            throw new IllegalArgumentException("newUri can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_manager_move_item(pointerOf(self), uri, newUri);

            return result;
        }
    }

    private static native final boolean gtk_recent_manager_move_item(long self, String uri, String newUri) throws GlibException;

    static final void setLimit(RecentManager self, int limit) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_recent_manager_set_limit(pointerOf(self), limit);
        }
    }

    private static native final void gtk_recent_manager_set_limit(long self, int limit);

    static final int getLimit(RecentManager self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_manager_get_limit(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_recent_manager_get_limit(long self);

    static final FIXME getItems(RecentManager self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GList*");
    }

    static final int purgeItems(RecentManager self) throws GlibException {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_recent_manager_purge_items(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_recent_manager_purge_items(long self) throws GlibException;

    interface ChangedSignal extends Signal
    {
        void onChanged(RecentManager source);
    }

    static final void connect(RecentManager self, GtkRecentManager.ChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkRecentManager.class, "changed", after);
    }

    protected static final void receiveChanged(Signal handler, long source) {
        ((GtkRecentManager.ChangedSignal) handler).onChanged((RecentManager) objectFor(source));
    }
}

