/*
 * GtkSelectionData.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Pixbuf;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.SelectionData;
import org.gnome.gtk.TextBuffer;
import org.gnome.gtk.TreeModel;
import org.gnome.gtk.TreePath;

final class GtkSelectionData extends Plumbing
{
    private GtkSelectionData() {}

    static final FIXME getSelection(SelectionData self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void setSelection(SelectionData self, FIXME selection) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final FIXME getTarget(SelectionData self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void setTarget(SelectionData self, FIXME target) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final FIXME getType(SelectionData self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final void setType(SelectionData self, FIXME type) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final int getFormat(SelectionData self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_selection_data_get_format(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_selection_data_get_format(long self);

    static final void setFormat(SelectionData self, int format) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_selection_data_set_format(pointerOf(self), format);
        }
    }

    private static native final void gtk_selection_data_set_format(long self, int format);

    static final FIXME getData(SelectionData self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guchar*");
    }

    static final void setData(SelectionData self, FIXME data) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guchar*");
    }

    static final void set(SelectionData self, FIXME type, int format, FIXME data, int length) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom");
    }

    static final boolean setText(SelectionData self, String str, int len) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (str == null) {
            throw new IllegalArgumentException("str can't be null");
        }

        synchronized (lock) {
            result = gtk_selection_data_set_text(pointerOf(self), str, len);

            return result;
        }
    }

    private static native final boolean gtk_selection_data_set_text(long self, String str, int len);

    static final FIXME getText(SelectionData self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("guchar*");
    }

    static final boolean getTargets(SelectionData self, FIXME targets, int[] nAtoms) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkAtom**");
    }

    static final boolean targetsIncludeText(SelectionData self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_selection_data_targets_include_text(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_selection_data_targets_include_text(long self);

    static final SelectionData copy(SelectionData self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_selection_data_copy(pointerOf(self));

            return (SelectionData) boxedFor(SelectionData.class, result);
        }
    }

    private static native final long gtk_selection_data_copy(long self);

    static final void free(SelectionData self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_selection_data_free(pointerOf(self));
        }
    }

    private static native final void gtk_selection_data_free(long self);

    static final boolean setPixbuf(SelectionData self, Pixbuf pixbuf) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pixbuf == null) {
            throw new IllegalArgumentException("pixbuf can't be null");
        }

        synchronized (lock) {
            result = gtk_selection_data_set_pixbuf(pointerOf(self), pointerOf(pixbuf));

            return result;
        }
    }

    private static native final boolean gtk_selection_data_set_pixbuf(long self, long pixbuf);

    static final Pixbuf getPixbuf(SelectionData self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_selection_data_get_pixbuf(pointerOf(self));

            return (Pixbuf) objectFor(result);
        }
    }

    private static native final long gtk_selection_data_get_pixbuf(long self);

    static final boolean setUris(SelectionData self, String[] uris) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (uris == null) {
            throw new IllegalArgumentException("uris can't be null");
        }

        synchronized (lock) {
            result = gtk_selection_data_set_uris(pointerOf(self), uris);

            return result;
        }
    }

    private static native final boolean gtk_selection_data_set_uris(long self, String[] uris);

    static final String[] getUris(SelectionData self) {
        String[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_selection_data_get_uris(pointerOf(self));

            return result;
        }
    }

    private static native final String[] gtk_selection_data_get_uris(long self);

    static final boolean targetsIncludeImage(SelectionData self, boolean writable) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_selection_data_targets_include_image(pointerOf(self), writable);

            return result;
        }
    }

    private static native final boolean gtk_selection_data_targets_include_image(long self, boolean writable);

    static final boolean treeSetRowDragData(SelectionData self, TreeModel treeModel, TreePath path) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (treeModel == null) {
            throw new IllegalArgumentException("treeModel can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_set_row_drag_data(pointerOf(self), pointerOf(treeModel), pointerOf(path));

            return result;
        }
    }

    private static native final boolean gtk_tree_set_row_drag_data(long self, long treeModel, long path);

    static final boolean treeGetRowDragData(SelectionData self, TreeModel[] treeModel, TreePath[] path) {
        boolean result;
        long[] _treeModel;
        long[] _path;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (treeModel == null) {
            throw new IllegalArgumentException("treeModel can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        _treeModel = pointersOf(treeModel);

        _path = pointersOf(path);

        synchronized (lock) {
            result = gtk_tree_get_row_drag_data(pointerOf(self), _treeModel, _path);
            fillObjectArray(treeModel, _treeModel);
            fillBoxedArray(TreePath.class, path, _path);

            return result;
        }
    }

    private static native final boolean gtk_tree_get_row_drag_data(long self, long[] treeModel, long[] path);

    static final boolean targetsIncludeRichText(SelectionData self, TextBuffer buffer) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (buffer == null) {
            throw new IllegalArgumentException("buffer can't be null");
        }

        synchronized (lock) {
            result = gtk_selection_data_targets_include_rich_text(pointerOf(self), pointerOf(buffer));

            return result;
        }
    }

    private static native final boolean gtk_selection_data_targets_include_rich_text(long self, long buffer);

    static final boolean targetsIncludeUri(SelectionData self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_selection_data_targets_include_uri(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_selection_data_targets_include_uri(long self);
}

