/*
 * GtkSettings.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Settings;

final class GtkSettings extends Plumbing
{
    private GtkSettings() {}

    static final void setPropertyValue(Settings self, String name, FIXME svalue) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("const-GtkSettingsValue*");
    }

    static final void setStringProperty(Settings self, String name, String vString, String origin) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        if (vString == null) {
            throw new IllegalArgumentException("vString can't be null");
        }

        if (origin == null) {
            throw new IllegalArgumentException("origin can't be null");
        }

        synchronized (lock) {
            gtk_settings_set_string_property(pointerOf(self), name, vString, origin);
        }
    }

    private static native final void gtk_settings_set_string_property(long self, String name, String vString, String origin);

    static final void setLongProperty(Settings self, String name, long vLong, String origin) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        if (origin == null) {
            throw new IllegalArgumentException("origin can't be null");
        }

        synchronized (lock) {
            gtk_settings_set_long_property(pointerOf(self), name, vLong, origin);
        }
    }

    private static native final void gtk_settings_set_long_property(long self, String name, long vLong, String origin);

    static final void setDoubleProperty(Settings self, String name, double vDouble, String origin) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        if (origin == null) {
            throw new IllegalArgumentException("origin can't be null");
        }

        synchronized (lock) {
            gtk_settings_set_double_property(pointerOf(self), name, vDouble, origin);
        }
    }

    private static native final void gtk_settings_set_double_property(long self, String name, double vDouble, String origin);
}

