/*
 * GtkSocket.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Socket;

final class GtkSocket extends Plumbing
{
    private GtkSocket() {}

    static final long createSocket() {
        long result;

        synchronized (lock) {
            result = gtk_socket_new();

            return result;
        }
    }

    private static native final long gtk_socket_new();

    static final void addId(Socket self, long windowId) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_socket_add_id(pointerOf(self), windowId);
        }
    }

    private static native final void gtk_socket_add_id(long self, long windowId);

    static final long getId(Socket self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_socket_get_id(pointerOf(self));

            return result;
        }
    }

    private static native final long gtk_socket_get_id(long self);

    interface PlugAddedSignal extends Signal
    {
        void onPlugAdded(Socket source);
    }

    static final void connect(Socket self, GtkSocket.PlugAddedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkSocket.class, "plug-added", after);
    }

    protected static final void receivePlugAdded(Signal handler, long source) {
        ((GtkSocket.PlugAddedSignal) handler).onPlugAdded((Socket) objectFor(source));
    }

    interface PlugRemovedSignal extends Signal
    {
        boolean onPlugRemoved(Socket source);
    }

    static final void connect(Socket self, GtkSocket.PlugRemovedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkSocket.class, "plug-removed", after);
    }

    protected static final boolean receivePlugRemoved(Signal handler, long source) {
        boolean result;

        result = ((GtkSocket.PlugRemovedSignal) handler).onPlugRemoved((Socket) objectFor(source));

        return result;
    }
}

