/*
 * GtkTextAppearance.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Bitmap;
import org.gnome.gtk.Plumbing;

final class GtkTextAppearance extends Plumbing
{
    private GtkTextAppearance() {}

    static final FIXME getBgColor(TextAppearance self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkColor");
    }

    static final void setBgColor(TextAppearance self, FIXME bgColor) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkColor");
    }

    static final FIXME getFgColor(TextAppearance self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkColor");
    }

    static final void setFgColor(TextAppearance self, FIXME fgColor) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GdkColor");
    }

    static final Bitmap getBgStipple(TextAppearance self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_appearance_get_bg_stipple(pointerOf(self));

            return (Bitmap) objectFor(result);
        }
    }

    private static native final long gtk_text_appearance_get_bg_stipple(long self);

    static final void setBgStipple(TextAppearance self, Bitmap bgStipple) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (bgStipple == null) {
            throw new IllegalArgumentException("bgStipple can't be null");
        }

        synchronized (lock) {
            gtk_text_appearance_set_bg_stipple(pointerOf(self), pointerOf(bgStipple));
        }
    }

    private static native final void gtk_text_appearance_set_bg_stipple(long self, long bgStipple);

    static final Bitmap getFgStipple(TextAppearance self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_appearance_get_fg_stipple(pointerOf(self));

            return (Bitmap) objectFor(result);
        }
    }

    private static native final long gtk_text_appearance_get_fg_stipple(long self);

    static final void setFgStipple(TextAppearance self, Bitmap fgStipple) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (fgStipple == null) {
            throw new IllegalArgumentException("fgStipple can't be null");
        }

        synchronized (lock) {
            gtk_text_appearance_set_fg_stipple(pointerOf(self), pointerOf(fgStipple));
        }
    }

    private static native final void gtk_text_appearance_set_fg_stipple(long self, long fgStipple);

    static final int getRise(TextAppearance self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_appearance_get_rise(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_text_appearance_get_rise(long self);

    static final void setRise(TextAppearance self, int rise) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_text_appearance_set_rise(pointerOf(self), rise);
        }
    }

    private static native final void gtk_text_appearance_set_rise(long self, int rise);

    static final int getUnderline(TextAppearance self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_appearance_get_underline(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_text_appearance_get_underline(long self);

    static final void setUnderline(TextAppearance self, int underline) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_text_appearance_set_underline(pointerOf(self), underline);
        }
    }

    private static native final void gtk_text_appearance_set_underline(long self, int underline);

    static final int getStrikethrough(TextAppearance self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_appearance_get_strikethrough(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_text_appearance_get_strikethrough(long self);

    static final void setStrikethrough(TextAppearance self, int strikethrough) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_text_appearance_set_strikethrough(pointerOf(self), strikethrough);
        }
    }

    private static native final void gtk_text_appearance_set_strikethrough(long self, int strikethrough);

    static final int getDrawBg(TextAppearance self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_appearance_get_draw_bg(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_text_appearance_get_draw_bg(long self);

    static final void setDrawBg(TextAppearance self, int drawBg) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_text_appearance_set_draw_bg(pointerOf(self), drawBg);
        }
    }

    private static native final void gtk_text_appearance_set_draw_bg(long self, int drawBg);

    static final int getInsideSelection(TextAppearance self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_appearance_get_inside_selection(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_text_appearance_get_inside_selection(long self);

    static final void setInsideSelection(TextAppearance self, int insideSelection) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_text_appearance_set_inside_selection(pointerOf(self), insideSelection);
        }
    }

    private static native final void gtk_text_appearance_set_inside_selection(long self, int insideSelection);

    static final int getIsText(TextAppearance self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_text_appearance_get_is_text(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_text_appearance_get_is_text(long self);

    static final void setIsText(TextAppearance self, int isText) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_text_appearance_set_is_text(pointerOf(self), isText);
        }
    }

    private static native final void gtk_text_appearance_set_is_text(long self, int isText);
}

