/*
 * GtkToolItem.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.glib.Signal;
import org.gnome.gtk.IconSize;
import org.gnome.gtk.Orientation;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.ReliefStyle;
import org.gnome.gtk.ToolItem;
import org.gnome.gtk.ToolbarStyle;
import org.gnome.gtk.Widget;

final class GtkToolItem extends Plumbing
{
    private GtkToolItem() {}

    static final long createToolItem() {
        long result;

        synchronized (lock) {
            result = gtk_tool_item_new();

            return result;
        }
    }

    private static native final long gtk_tool_item_new();

    static final void setHomogeneous(ToolItem self, boolean homogeneous) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_item_set_homogeneous(pointerOf(self), homogeneous);
        }
    }

    private static native final void gtk_tool_item_set_homogeneous(long self, boolean homogeneous);

    static final boolean getHomogeneous(ToolItem self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_get_homogeneous(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tool_item_get_homogeneous(long self);

    static final void setExpand(ToolItem self, boolean expand) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_item_set_expand(pointerOf(self), expand);
        }
    }

    private static native final void gtk_tool_item_set_expand(long self, boolean expand);

    static final boolean getExpand(ToolItem self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_get_expand(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tool_item_get_expand(long self);

    static final void setTooltipText(ToolItem self, String text) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (text == null) {
            throw new IllegalArgumentException("text can't be null");
        }

        synchronized (lock) {
            gtk_tool_item_set_tooltip_text(pointerOf(self), text);
        }
    }

    private static native final void gtk_tool_item_set_tooltip_text(long self, String text);

    static final void setTooltipMarkup(ToolItem self, String markup) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (markup == null) {
            throw new IllegalArgumentException("markup can't be null");
        }

        synchronized (lock) {
            gtk_tool_item_set_tooltip_markup(pointerOf(self), markup);
        }
    }

    private static native final void gtk_tool_item_set_tooltip_markup(long self, String markup);

    static final void setUseDragWindow(ToolItem self, boolean useDragWindow) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_item_set_use_drag_window(pointerOf(self), useDragWindow);
        }
    }

    private static native final void gtk_tool_item_set_use_drag_window(long self, boolean useDragWindow);

    static final boolean getUseDragWindow(ToolItem self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_get_use_drag_window(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tool_item_get_use_drag_window(long self);

    static final void setVisibleHorizontal(ToolItem self, boolean visibleHorizontal) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_item_set_visible_horizontal(pointerOf(self), visibleHorizontal);
        }
    }

    private static native final void gtk_tool_item_set_visible_horizontal(long self, boolean visibleHorizontal);

    static final boolean getVisibleHorizontal(ToolItem self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_get_visible_horizontal(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tool_item_get_visible_horizontal(long self);

    static final void setVisibleVertical(ToolItem self, boolean visibleVertical) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_item_set_visible_vertical(pointerOf(self), visibleVertical);
        }
    }

    private static native final void gtk_tool_item_set_visible_vertical(long self, boolean visibleVertical);

    static final boolean getVisibleVertical(ToolItem self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_get_visible_vertical(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tool_item_get_visible_vertical(long self);

    static final void setIsImportant(ToolItem self, boolean isImportant) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_item_set_is_important(pointerOf(self), isImportant);
        }
    }

    private static native final void gtk_tool_item_set_is_important(long self, boolean isImportant);

    static final boolean getIsImportant(ToolItem self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_get_is_important(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tool_item_get_is_important(long self);

    static final IconSize getIconSize(ToolItem self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_get_icon_size(pointerOf(self));

            return (IconSize) enumFor(IconSize.class, result);
        }
    }

    private static native final int gtk_tool_item_get_icon_size(long self);

    static final Orientation getOrientation(ToolItem self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_get_orientation(pointerOf(self));

            return (Orientation) enumFor(Orientation.class, result);
        }
    }

    private static native final int gtk_tool_item_get_orientation(long self);

    static final ToolbarStyle getToolbarStyle(ToolItem self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_get_toolbar_style(pointerOf(self));

            return (ToolbarStyle) enumFor(ToolbarStyle.class, result);
        }
    }

    private static native final int gtk_tool_item_get_toolbar_style(long self);

    static final ReliefStyle getReliefStyle(ToolItem self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_get_relief_style(pointerOf(self));

            return (ReliefStyle) enumFor(ReliefStyle.class, result);
        }
    }

    private static native final int gtk_tool_item_get_relief_style(long self);

    static final Widget retrieveProxyMenuItem(ToolItem self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_retrieve_proxy_menu_item(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_tool_item_retrieve_proxy_menu_item(long self);

    static final void setProxyMenuItem(ToolItem self, String menuItemId, Widget menuItem) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (menuItemId == null) {
            throw new IllegalArgumentException("menuItemId can't be null");
        }

        synchronized (lock) {
            gtk_tool_item_set_proxy_menu_item(pointerOf(self), menuItemId, pointerOf(menuItem));
        }
    }

    private static native final void gtk_tool_item_set_proxy_menu_item(long self, String menuItemId, long menuItem);

    static final Widget getProxyMenuItem(ToolItem self, String menuItemId) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (menuItemId == null) {
            throw new IllegalArgumentException("menuItemId can't be null");
        }

        synchronized (lock) {
            result = gtk_tool_item_get_proxy_menu_item(pointerOf(self), menuItemId);

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_tool_item_get_proxy_menu_item(long self, String menuItemId);

    static final void rebuildMenu(ToolItem self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tool_item_rebuild_menu(pointerOf(self));
        }
    }

    private static native final void gtk_tool_item_rebuild_menu(long self);

    interface CreateMenuProxySignal extends Signal
    {
        boolean onCreateMenuProxy(ToolItem source);
    }

    static final void connect(ToolItem self, GtkToolItem.CreateMenuProxySignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkToolItem.class, "create-menu-proxy", after);
    }

    protected static final boolean receiveCreateMenuProxy(Signal handler, long source) {
        boolean result;

        result = ((GtkToolItem.CreateMenuProxySignal) handler).onCreateMenuProxy((ToolItem) objectFor(source));

        return result;
    }

    interface ToolbarReconfiguredSignal extends Signal
    {
        void onToolbarReconfigured(ToolItem source);
    }

    static final void connect(ToolItem self, GtkToolItem.ToolbarReconfiguredSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkToolItem.class, "toolbar-reconfigured", after);
    }

    protected static final void receiveToolbarReconfigured(Signal handler, long source) {
        ((GtkToolItem.ToolbarReconfiguredSignal) handler).onToolbarReconfigured((ToolItem) objectFor(source));
    }
}

