/*
 * GtkTooltip.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gdk.Display;
import org.gnome.gdk.Pixbuf;
import org.gnome.gdk.Rectangle;
import org.gnome.gtk.IconSize;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Tooltip;
import org.gnome.gtk.Widget;

final class GtkTooltip extends Plumbing
{
    private GtkTooltip() {}

    static final void setMarkup(Tooltip self, String markup) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tooltip_set_markup(pointerOf(self), markup);
        }
    }

    private static native final void gtk_tooltip_set_markup(long self, String markup);

    static final void setText(Tooltip self, String text) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tooltip_set_text(pointerOf(self), text);
        }
    }

    private static native final void gtk_tooltip_set_text(long self, String text);

    static final void setIcon(Tooltip self, Pixbuf pixbuf) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tooltip_set_icon(pointerOf(self), pointerOf(pixbuf));
        }
    }

    private static native final void gtk_tooltip_set_icon(long self, long pixbuf);

    static final void setIcon(Tooltip self, String stockId, IconSize size) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (size == null) {
            throw new IllegalArgumentException("size can't be null");
        }

        synchronized (lock) {
            gtk_tooltip_set_icon_from_stock(pointerOf(self), stockId, numOf(size));
        }
    }

    private static native final void gtk_tooltip_set_icon_from_stock(long self, String stockId, int size);

    static final void setCustom(Tooltip self, Widget customWidget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (customWidget == null) {
            throw new IllegalArgumentException("customWidget can't be null");
        }

        synchronized (lock) {
            gtk_tooltip_set_custom(pointerOf(self), pointerOf(customWidget));
        }
    }

    private static native final void gtk_tooltip_set_custom(long self, long customWidget);

    static final void triggerTooltipQuery(Display display) {
        if (display == null) {
            throw new IllegalArgumentException("display can't be null");
        }

        synchronized (lock) {
            gtk_tooltip_trigger_tooltip_query(pointerOf(display));
        }
    }

    private static native final void gtk_tooltip_trigger_tooltip_query(long display);

    static final void setTipArea(Tooltip self, Rectangle rect) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rect == null) {
            throw new IllegalArgumentException("rect can't be null");
        }

        synchronized (lock) {
            gtk_tooltip_set_tip_area(pointerOf(self), pointerOf(rect));
        }
    }

    private static native final void gtk_tooltip_set_tip_area(long self, long rect);
}

