/*
 * GtkTreeModelFilter.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.TreeIter;
import org.gnome.gtk.TreeModel;
import org.gnome.gtk.TreeModelFilter;
import org.gnome.gtk.TreePath;

final class GtkTreeModelFilter extends Plumbing
{
    private GtkTreeModelFilter() {}

    static final long createTreeModelFilter(TreeModel childModel, TreePath root) {
        long result;

        if (childModel == null) {
            throw new IllegalArgumentException("childModel can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_model_filter_new(pointerOf(childModel), pointerOf(root));

            return result;
        }
    }

    private static native final long gtk_tree_model_filter_new(long childModel, long root);

    static final void setVisibleFunc(TreeModelFilter self, FIXME func, FIXME data, FIXME destroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTreeModelFilterVisibleFunc");
    }

    static final void setModifyFunc(TreeModelFilter self, int nColumns, FIXME types, FIXME func, FIXME data, FIXME destroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GType*");
    }

    static final void setVisibleColumn(TreeModelFilter self, int column) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_model_filter_set_visible_column(pointerOf(self), column);
        }
    }

    private static native final void gtk_tree_model_filter_set_visible_column(long self, int column);

    static final TreeModel getModel(TreeModelFilter self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_model_filter_get_model(pointerOf(self));

            return (TreeModel) objectFor(result);
        }
    }

    private static native final long gtk_tree_model_filter_get_model(long self);

    static final boolean convertChildIterToIter(TreeModelFilter self, TreeIter filterIter, TreeIter childIter) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (filterIter == null) {
            throw new IllegalArgumentException("filterIter can't be null");
        }

        if (childIter == null) {
            throw new IllegalArgumentException("childIter can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_model_filter_convert_child_iter_to_iter(pointerOf(self), pointerOf(filterIter), pointerOf(childIter));

            return result;
        }
    }

    private static native final boolean gtk_tree_model_filter_convert_child_iter_to_iter(long self, long filterIter, long childIter);

    static final void convertIterToChildIter(TreeModelFilter self, TreeIter childIter, TreeIter filterIter) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (childIter == null) {
            throw new IllegalArgumentException("childIter can't be null");
        }

        if (filterIter == null) {
            throw new IllegalArgumentException("filterIter can't be null");
        }

        synchronized (lock) {
            gtk_tree_model_filter_convert_iter_to_child_iter(pointerOf(self), pointerOf(childIter), pointerOf(filterIter));
        }
    }

    private static native final void gtk_tree_model_filter_convert_iter_to_child_iter(long self, long childIter, long filterIter);

    static final TreePath convertChildPathToPath(TreeModelFilter self, TreePath childPath) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (childPath == null) {
            throw new IllegalArgumentException("childPath can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_model_filter_convert_child_path_to_path(pointerOf(self), pointerOf(childPath));

            return (TreePath) boxedFor(TreePath.class, result);
        }
    }

    private static native final long gtk_tree_model_filter_convert_child_path_to_path(long self, long childPath);

    static final TreePath convertPathToChildPath(TreeModelFilter self, TreePath filterPath) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (filterPath == null) {
            throw new IllegalArgumentException("filterPath can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_model_filter_convert_path_to_child_path(pointerOf(self), pointerOf(filterPath));

            return (TreePath) boxedFor(TreePath.class, result);
        }
    }

    private static native final long gtk_tree_model_filter_convert_path_to_child_path(long self, long filterPath);

    static final void refilter(TreeModelFilter self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_model_filter_refilter(pointerOf(self));
        }
    }

    private static native final void gtk_tree_model_filter_refilter(long self);

    static final void clearCache(TreeModelFilter self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_model_filter_clear_cache(pointerOf(self));
        }
    }

    private static native final void gtk_tree_model_filter_clear_cache(long self);

    interface VisibleSignal extends Signal
    {
        boolean onVisible(TreeModelFilter source, TreeModel child, TreeIter iter);
    }

    static final void connect(TreeModelFilter self, GtkTreeModelFilter.VisibleSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTreeModelFilter.class, "visible", after);
    }

    protected static final boolean receiveVisible(Signal handler, long source, long child, long iter) {
        boolean result;

        result = ((GtkTreeModelFilter.VisibleSignal) handler).onVisible((TreeModelFilter) objectFor(source), (TreeModel) objectFor(child), (TreeIter) boxedFor(TreeIter.class, iter));

        return result;
    }
}

