/*
 * GtkTreeModelSort.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Plumbing;
import org.gnome.gtk.TreeIter;
import org.gnome.gtk.TreeModel;
import org.gnome.gtk.TreeModelSort;
import org.gnome.gtk.TreePath;

final class GtkTreeModelSort extends Plumbing
{
    private GtkTreeModelSort() {}

    static final long createTreeModelSortWithModel(TreeModel model) {
        long result;

        if (model == null) {
            throw new IllegalArgumentException("model can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_model_sort_new_with_model(pointerOf(model));

            return result;
        }
    }

    private static native final long gtk_tree_model_sort_new_with_model(long model);

    static final TreeModel getModel(TreeModelSort self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_model_sort_get_model(pointerOf(self));

            return (TreeModel) objectFor(result);
        }
    }

    private static native final long gtk_tree_model_sort_get_model(long self);

    static final TreePath convertChildPathToPath(TreeModelSort self, TreePath childPath) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (childPath == null) {
            throw new IllegalArgumentException("childPath can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_model_sort_convert_child_path_to_path(pointerOf(self), pointerOf(childPath));

            return (TreePath) boxedFor(TreePath.class, result);
        }
    }

    private static native final long gtk_tree_model_sort_convert_child_path_to_path(long self, long childPath);

    static final void convertChildIterToIter(TreeModelSort self, TreeIter sortIter, TreeIter childIter) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (childIter == null) {
            throw new IllegalArgumentException("childIter can't be null");
        }

        synchronized (lock) {
            gtk_tree_model_sort_convert_child_iter_to_iter(pointerOf(self), pointerOf(sortIter), pointerOf(childIter));
        }
    }

    private static native final void gtk_tree_model_sort_convert_child_iter_to_iter(long self, long sortIter, long childIter);

    static final TreePath convertPathToChildPath(TreeModelSort self, TreePath sortedPath) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (sortedPath == null) {
            throw new IllegalArgumentException("sortedPath can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_model_sort_convert_path_to_child_path(pointerOf(self), pointerOf(sortedPath));

            return (TreePath) boxedFor(TreePath.class, result);
        }
    }

    private static native final long gtk_tree_model_sort_convert_path_to_child_path(long self, long sortedPath);

    static final void convertIterToChildIter(TreeModelSort self, TreeIter childIter, TreeIter sortedIter) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (sortedIter == null) {
            throw new IllegalArgumentException("sortedIter can't be null");
        }

        synchronized (lock) {
            gtk_tree_model_sort_convert_iter_to_child_iter(pointerOf(self), pointerOf(childIter), pointerOf(sortedIter));
        }
    }

    private static native final void gtk_tree_model_sort_convert_iter_to_child_iter(long self, long childIter, long sortedIter);

    static final void resetDefaultSortFunc(TreeModelSort self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_model_sort_reset_default_sort_func(pointerOf(self));
        }
    }

    private static native final void gtk_tree_model_sort_reset_default_sort_func(long self);

    static final boolean iterIsValid(TreeModelSort self, TreeIter iter) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_model_sort_iter_is_valid(pointerOf(self), pointerOf(iter));

            return result;
        }
    }

    private static native final boolean gtk_tree_model_sort_iter_is_valid(long self, long iter);
}

