/*
 * GtkTreeSelection.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.SelectionMode;
import org.gnome.gtk.TreeIter;
import org.gnome.gtk.TreeModel;
import org.gnome.gtk.TreePath;
import org.gnome.gtk.TreeSelection;
import org.gnome.gtk.TreeView;

final class GtkTreeSelection extends Plumbing
{
    private GtkTreeSelection() {}

    static final void setMode(TreeSelection self, SelectionMode type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gtk_tree_selection_set_mode(pointerOf(self), numOf(type));
        }
    }

    private static native final void gtk_tree_selection_set_mode(long self, int type);

    static final SelectionMode getMode(TreeSelection self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_selection_get_mode(pointerOf(self));

            return (SelectionMode) enumFor(SelectionMode.class, result);
        }
    }

    private static native final int gtk_tree_selection_get_mode(long self);

    static final void setSelectFunction(TreeSelection self, FIXME func, FIXME data, FIXME destroy) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTreeSelectionFunc");
    }

    static final FIXME getUserData(TreeSelection self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("gpointer");
    }

    static final TreeView getTreeView(TreeSelection self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_selection_get_tree_view(pointerOf(self));

            return (TreeView) objectFor(result);
        }
    }

    private static native final long gtk_tree_selection_get_tree_view(long self);

    static final boolean getSelected(TreeSelection self, TreeModel[] model, TreeIter iter) {
        boolean result;
        long[] _model;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        _model = pointersOf(model);

        synchronized (lock) {
            result = gtk_tree_selection_get_selected(pointerOf(self), _model, pointerOf(iter));
            fillObjectArray(model, _model);

            return result;
        }
    }

    private static native final boolean gtk_tree_selection_get_selected(long self, long[] model, long iter);

    static final TreePath[] getSelectedRows(TreeSelection self, TreeModel[] model) {
        long[] result;
        long[] _model;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        _model = pointersOf(model);

        synchronized (lock) {
            result = gtk_tree_selection_get_selected_rows(pointerOf(self), _model);
            fillObjectArray(model, _model);

            return (TreePath[]) boxedArrayFor(TreePath.class, result, new TreePath[result.length]);
        }
    }

    private static native final long[] gtk_tree_selection_get_selected_rows(long self, long[] model);

    static final int countSelectedRows(TreeSelection self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_selection_count_selected_rows(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_tree_selection_count_selected_rows(long self);

    static final void selectedForeach(TreeSelection self, FIXME func, FIXME data) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GtkTreeSelectionForeachFunc");
    }

    static final void selectPath(TreeSelection self, TreePath path) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            gtk_tree_selection_select_path(pointerOf(self), pointerOf(path));
        }
    }

    private static native final void gtk_tree_selection_select_path(long self, long path);

    static final void unselectPath(TreeSelection self, TreePath path) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            gtk_tree_selection_unselect_path(pointerOf(self), pointerOf(path));
        }
    }

    private static native final void gtk_tree_selection_unselect_path(long self, long path);

    static final void selectIter(TreeSelection self, TreeIter iter) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_tree_selection_select_iter(pointerOf(self), pointerOf(iter));
        }
    }

    private static native final void gtk_tree_selection_select_iter(long self, long iter);

    static final void unselectIter(TreeSelection self, TreeIter iter) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_tree_selection_unselect_iter(pointerOf(self), pointerOf(iter));
        }
    }

    private static native final void gtk_tree_selection_unselect_iter(long self, long iter);

    static final boolean pathIsSelected(TreeSelection self, TreePath path) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_selection_path_is_selected(pointerOf(self), pointerOf(path));

            return result;
        }
    }

    private static native final boolean gtk_tree_selection_path_is_selected(long self, long path);

    static final boolean iterIsSelected(TreeSelection self, TreeIter iter) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_selection_iter_is_selected(pointerOf(self), pointerOf(iter));

            return result;
        }
    }

    private static native final boolean gtk_tree_selection_iter_is_selected(long self, long iter);

    static final void selectAll(TreeSelection self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_selection_select_all(pointerOf(self));
        }
    }

    private static native final void gtk_tree_selection_select_all(long self);

    static final void unselectAll(TreeSelection self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_selection_unselect_all(pointerOf(self));
        }
    }

    private static native final void gtk_tree_selection_unselect_all(long self);

    static final void selectRange(TreeSelection self, TreePath startPath, TreePath endPath) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (startPath == null) {
            throw new IllegalArgumentException("startPath can't be null");
        }

        if (endPath == null) {
            throw new IllegalArgumentException("endPath can't be null");
        }

        synchronized (lock) {
            gtk_tree_selection_select_range(pointerOf(self), pointerOf(startPath), pointerOf(endPath));
        }
    }

    private static native final void gtk_tree_selection_select_range(long self, long startPath, long endPath);

    static final void unselectRange(TreeSelection self, TreePath startPath, TreePath endPath) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (startPath == null) {
            throw new IllegalArgumentException("startPath can't be null");
        }

        if (endPath == null) {
            throw new IllegalArgumentException("endPath can't be null");
        }

        synchronized (lock) {
            gtk_tree_selection_unselect_range(pointerOf(self), pointerOf(startPath), pointerOf(endPath));
        }
    }

    private static native final void gtk_tree_selection_unselect_range(long self, long startPath, long endPath);

    interface ChangedSignal extends Signal
    {
        void onChanged(TreeSelection source);
    }

    static final void connect(TreeSelection self, GtkTreeSelection.ChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTreeSelection.class, "changed", after);
    }

    protected static final void receiveChanged(Signal handler, long source) {
        ((GtkTreeSelection.ChangedSignal) handler).onChanged((TreeSelection) objectFor(source));
    }
}

