/*
 * GtkTreeStore.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Value;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.TreeIter;
import org.gnome.gtk.TreeStore;

final class GtkTreeStore extends Plumbing
{
    private GtkTreeStore() {}

    static final void setColumnTypes(TreeStore self, int nColumns, FIXME types) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GType*");
    }

    static final void setValue(TreeStore self, TreeIter iter, int column, Value value) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (value == null) {
            throw new IllegalArgumentException("value can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_set_value(pointerOf(self), pointerOf(iter), column, pointerOf(value));
        }
    }

    private static native final void gtk_tree_store_set_value(long self, long iter, int column, long value);

    static final boolean remove(TreeStore self, TreeIter iter) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_store_remove(pointerOf(self), pointerOf(iter));

            return result;
        }
    }

    private static native final boolean gtk_tree_store_remove(long self, long iter);

    static final void insert(TreeStore self, TreeIter iter, TreeIter parent, int position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_insert(pointerOf(self), pointerOf(iter), pointerOf(parent), position);
        }
    }

    private static native final void gtk_tree_store_insert(long self, long iter, long parent, int position);

    static final void insertBefore(TreeStore self, TreeIter iter, TreeIter parent, TreeIter sibling) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (sibling == null) {
            throw new IllegalArgumentException("sibling can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_insert_before(pointerOf(self), pointerOf(iter), pointerOf(parent), pointerOf(sibling));
        }
    }

    private static native final void gtk_tree_store_insert_before(long self, long iter, long parent, long sibling);

    static final void insertAfter(TreeStore self, TreeIter iter, TreeIter parent, TreeIter sibling) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (parent == null) {
            throw new IllegalArgumentException("parent can't be null");
        }

        if (sibling == null) {
            throw new IllegalArgumentException("sibling can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_insert_after(pointerOf(self), pointerOf(iter), pointerOf(parent), pointerOf(sibling));
        }
    }

    private static native final void gtk_tree_store_insert_after(long self, long iter, long parent, long sibling);

    static final void prepend(TreeStore self, TreeIter iter, TreeIter parent) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (parent == null) {
            throw new IllegalArgumentException("parent can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_prepend(pointerOf(self), pointerOf(iter), pointerOf(parent));
        }
    }

    private static native final void gtk_tree_store_prepend(long self, long iter, long parent);

    static final void append(TreeStore self, TreeIter iter, TreeIter parent) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_append(pointerOf(self), pointerOf(iter), pointerOf(parent));
        }
    }

    private static native final void gtk_tree_store_append(long self, long iter, long parent);

    static final boolean isAncestor(TreeStore self, TreeIter iter, TreeIter descendant) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (descendant == null) {
            throw new IllegalArgumentException("descendant can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_store_is_ancestor(pointerOf(self), pointerOf(iter), pointerOf(descendant));

            return result;
        }
    }

    private static native final boolean gtk_tree_store_is_ancestor(long self, long iter, long descendant);

    static final int iterDepth(TreeStore self, TreeIter iter) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_store_iter_depth(pointerOf(self), pointerOf(iter));

            return result;
        }
    }

    private static native final int gtk_tree_store_iter_depth(long self, long iter);

    static final void clear(TreeStore self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_clear(pointerOf(self));
        }
    }

    private static native final void gtk_tree_store_clear(long self);

    static final boolean iterIsValid(TreeStore self, TreeIter iter) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_store_iter_is_valid(pointerOf(self), pointerOf(iter));

            return result;
        }
    }

    private static native final boolean gtk_tree_store_iter_is_valid(long self, long iter);

    static final void reorder(TreeStore self, TreeIter parent, int[] newOrder) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (parent == null) {
            throw new IllegalArgumentException("parent can't be null");
        }

        if (newOrder == null) {
            throw new IllegalArgumentException("newOrder can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_reorder(pointerOf(self), pointerOf(parent), newOrder);
        }
    }

    private static native final void gtk_tree_store_reorder(long self, long parent, int[] newOrder);

    static final void swap(TreeStore self, TreeIter a, TreeIter b) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (a == null) {
            throw new IllegalArgumentException("a can't be null");
        }

        if (b == null) {
            throw new IllegalArgumentException("b can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_swap(pointerOf(self), pointerOf(a), pointerOf(b));
        }
    }

    private static native final void gtk_tree_store_swap(long self, long a, long b);

    static final void moveAfter(TreeStore self, TreeIter iter, TreeIter position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_move_after(pointerOf(self), pointerOf(iter), pointerOf(position));
        }
    }

    private static native final void gtk_tree_store_move_after(long self, long iter, long position);

    static final void moveBefore(TreeStore self, TreeIter iter, TreeIter position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_move_before(pointerOf(self), pointerOf(iter), pointerOf(position));
        }
    }

    private static native final void gtk_tree_store_move_before(long self, long iter, long position);

    static final void insertWithValues(TreeStore self, TreeIter iter, TreeIter parent, int position) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (parent == null) {
            throw new IllegalArgumentException("parent can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_insert_with_values(pointerOf(self), pointerOf(iter), pointerOf(parent), position);
        }
    }

    private static native final void gtk_tree_store_insert_with_values(long self, long iter, long parent, int position);

    static final void insertWithValuesv(TreeStore self, TreeIter iter, TreeIter parent, int position, int[] columns, Value values, int nValues) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        if (parent == null) {
            throw new IllegalArgumentException("parent can't be null");
        }

        if (columns == null) {
            throw new IllegalArgumentException("columns can't be null");
        }

        if (values == null) {
            throw new IllegalArgumentException("values can't be null");
        }

        synchronized (lock) {
            gtk_tree_store_insert_with_valuesv(pointerOf(self), pointerOf(iter), pointerOf(parent), position, columns, pointerOf(values), nValues);
        }
    }

    private static native final void gtk_tree_store_insert_with_valuesv(long self, long iter, long parent, int position, int[] columns, long values, int nValues);
}

