/*
 * GtkTreeViewColumn.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gdk.Rectangle;
import org.gnome.glib.Signal;
import org.gnome.gtk.CellRenderer;
import org.gnome.gtk.Plumbing;
import org.gnome.gtk.SortType;
import org.gnome.gtk.TreeIter;
import org.gnome.gtk.TreeModel;
import org.gnome.gtk.TreeViewColumn;
import org.gnome.gtk.TreeViewColumnSizing;
import org.gnome.gtk.Widget;

final class GtkTreeViewColumn extends Plumbing
{
    private GtkTreeViewColumn() {}

    static final void queueResize(TreeViewColumn self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_queue_resize(pointerOf(self));
        }
    }

    private static native final void gtk_tree_view_column_queue_resize(long self);

    static final long createTreeViewColumn() {
        long result;

        synchronized (lock) {
            result = gtk_tree_view_column_new();

            return result;
        }
    }

    private static native final long gtk_tree_view_column_new();

    static final long createTreeViewColumnWithAttributes(String title, CellRenderer cell) {
        long result;

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        if (cell == null) {
            throw new IllegalArgumentException("cell can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_new_with_attributes(title, pointerOf(cell));

            return result;
        }
    }

    private static native final long gtk_tree_view_column_new_with_attributes(String title, long cell);

    static final void clear(TreeViewColumn self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_clear(pointerOf(self));
        }
    }

    private static native final void gtk_tree_view_column_clear(long self);

    static final FIXME getCellRenderers(TreeViewColumn self) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GList-GtkCellRenderers*");
    }

    static final void setSpacing(TreeViewColumn self, int spacing) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_spacing(pointerOf(self), spacing);
        }
    }

    private static native final void gtk_tree_view_column_set_spacing(long self, int spacing);

    static final int getSpacing(TreeViewColumn self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_spacing(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_tree_view_column_get_spacing(long self);

    static final void setVisible(TreeViewColumn self, boolean visible) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_visible(pointerOf(self), visible);
        }
    }

    private static native final void gtk_tree_view_column_set_visible(long self, boolean visible);

    static final boolean getVisible(TreeViewColumn self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_visible(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tree_view_column_get_visible(long self);

    static final void setResizable(TreeViewColumn self, boolean resizable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_resizable(pointerOf(self), resizable);
        }
    }

    private static native final void gtk_tree_view_column_set_resizable(long self, boolean resizable);

    static final boolean getResizable(TreeViewColumn self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_resizable(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tree_view_column_get_resizable(long self);

    static final void setSizing(TreeViewColumn self, TreeViewColumnSizing type) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_sizing(pointerOf(self), numOf(type));
        }
    }

    private static native final void gtk_tree_view_column_set_sizing(long self, int type);

    static final int getSizing(TreeViewColumn self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_sizing(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_tree_view_column_get_sizing(long self);

    static final int getWidth(TreeViewColumn self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_tree_view_column_get_width(long self);

    static final int getFixedWidth(TreeViewColumn self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_fixed_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_tree_view_column_get_fixed_width(long self);

    static final void setFixedWidth(TreeViewColumn self, int fixedWidth) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_fixed_width(pointerOf(self), fixedWidth);
        }
    }

    private static native final void gtk_tree_view_column_set_fixed_width(long self, int fixedWidth);

    static final void setMinWidth(TreeViewColumn self, int minWidth) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_min_width(pointerOf(self), minWidth);
        }
    }

    private static native final void gtk_tree_view_column_set_min_width(long self, int minWidth);

    static final int getMinWidth(TreeViewColumn self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_min_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_tree_view_column_get_min_width(long self);

    static final void setMaxWidth(TreeViewColumn self, int maxWidth) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_max_width(pointerOf(self), maxWidth);
        }
    }

    private static native final void gtk_tree_view_column_set_max_width(long self, int maxWidth);

    static final int getMaxWidth(TreeViewColumn self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_max_width(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_tree_view_column_get_max_width(long self);

    static final void clicked(TreeViewColumn self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_clicked(pointerOf(self));
        }
    }

    private static native final void gtk_tree_view_column_clicked(long self);

    static final void setTitle(TreeViewColumn self, String title) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (title == null) {
            throw new IllegalArgumentException("title can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_title(pointerOf(self), title);
        }
    }

    private static native final void gtk_tree_view_column_set_title(long self, String title);

    static final String getTitle(TreeViewColumn self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_title(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_tree_view_column_get_title(long self);

    static final void setExpand(TreeViewColumn self, boolean expand) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_expand(pointerOf(self), expand);
        }
    }

    private static native final void gtk_tree_view_column_set_expand(long self, boolean expand);

    static final boolean getExpand(TreeViewColumn self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_expand(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tree_view_column_get_expand(long self);

    static final void setClickable(TreeViewColumn self, boolean active) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_clickable(pointerOf(self), active);
        }
    }

    private static native final void gtk_tree_view_column_set_clickable(long self, boolean active);

    static final boolean getClickable(TreeViewColumn self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_clickable(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tree_view_column_get_clickable(long self);

    static final void setWidget(TreeViewColumn self, Widget widget) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_widget(pointerOf(self), pointerOf(widget));
        }
    }

    private static native final void gtk_tree_view_column_set_widget(long self, long widget);

    static final Widget getWidget(TreeViewColumn self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_widget(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_tree_view_column_get_widget(long self);

    static final void setAlignment(TreeViewColumn self, float xalign) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_alignment(pointerOf(self), xalign);
        }
    }

    private static native final void gtk_tree_view_column_set_alignment(long self, float xalign);

    static final float getAlignment(TreeViewColumn self) {
        float result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_alignment(pointerOf(self));

            return result;
        }
    }

    private static native final float gtk_tree_view_column_get_alignment(long self);

    static final void setReorderable(TreeViewColumn self, boolean reorderable) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_reorderable(pointerOf(self), reorderable);
        }
    }

    private static native final void gtk_tree_view_column_set_reorderable(long self, boolean reorderable);

    static final boolean getReorderable(TreeViewColumn self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_reorderable(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tree_view_column_get_reorderable(long self);

    static final void setSortColumnId(TreeViewColumn self, int sortColumnId) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_sort_column_id(pointerOf(self), sortColumnId);
        }
    }

    private static native final void gtk_tree_view_column_set_sort_column_id(long self, int sortColumnId);

    static final int getSortColumnId(TreeViewColumn self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_sort_column_id(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_tree_view_column_get_sort_column_id(long self);

    static final void setSortIndicator(TreeViewColumn self, boolean setting) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_sort_indicator(pointerOf(self), setting);
        }
    }

    private static native final void gtk_tree_view_column_set_sort_indicator(long self, boolean setting);

    static final boolean getSortIndicator(TreeViewColumn self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_sort_indicator(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tree_view_column_get_sort_indicator(long self);

    static final void setSortOrder(TreeViewColumn self, SortType order) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (order == null) {
            throw new IllegalArgumentException("order can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_set_sort_order(pointerOf(self), numOf(order));
        }
    }

    private static native final void gtk_tree_view_column_set_sort_order(long self, int order);

    static final SortType getSortOrder(TreeViewColumn self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_sort_order(pointerOf(self));

            return (SortType) enumFor(SortType.class, result);
        }
    }

    private static native final int gtk_tree_view_column_get_sort_order(long self);

    static final void cellSetCellData(TreeViewColumn self, TreeModel treeModel, TreeIter iter, boolean isExpander, boolean isExpanded) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (treeModel == null) {
            throw new IllegalArgumentException("treeModel can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_cell_set_cell_data(pointerOf(self), pointerOf(treeModel), pointerOf(iter), isExpander, isExpanded);
        }
    }

    private static native final void gtk_tree_view_column_cell_set_cell_data(long self, long treeModel, long iter, boolean isExpander, boolean isExpanded);

    static final void cellGetSize(TreeViewColumn self, Rectangle cellArea, int[] xOffset, int[] yOffset, int[] width, int[] height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (cellArea == null) {
            throw new IllegalArgumentException("cellArea can't be null");
        }

        if (xOffset == null) {
            throw new IllegalArgumentException("xOffset can't be null");
        }

        if (yOffset == null) {
            throw new IllegalArgumentException("yOffset can't be null");
        }

        if (width == null) {
            throw new IllegalArgumentException("width can't be null");
        }

        if (height == null) {
            throw new IllegalArgumentException("height can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_cell_get_size(pointerOf(self), pointerOf(cellArea), xOffset, yOffset, width, height);
        }
    }

    private static native final void gtk_tree_view_column_cell_get_size(long self, long cellArea, int[] xOffset, int[] yOffset, int[] width, int[] height);

    static final boolean cellIsVisible(TreeViewColumn self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_cell_is_visible(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_tree_view_column_cell_is_visible(long self);

    static final void focusCell(TreeViewColumn self, CellRenderer cell) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (cell == null) {
            throw new IllegalArgumentException("cell can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_focus_cell(pointerOf(self), pointerOf(cell));
        }
    }

    private static native final void gtk_tree_view_column_focus_cell(long self, long cell);

    static final void cellGetPosition(TreeViewColumn self, CellRenderer cellRenderer, int[] startPos, int[] width) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (cellRenderer == null) {
            throw new IllegalArgumentException("cellRenderer can't be null");
        }

        if (startPos == null) {
            throw new IllegalArgumentException("startPos can't be null");
        }

        if (width == null) {
            throw new IllegalArgumentException("width can't be null");
        }

        synchronized (lock) {
            gtk_tree_view_column_cell_get_position(pointerOf(self), pointerOf(cellRenderer), startPos, width);
        }
    }

    private static native final void gtk_tree_view_column_cell_get_position(long self, long cellRenderer, int[] startPos, int[] width);

    interface ClickedSignal extends Signal
    {
        void onClicked(TreeViewColumn source);
    }

    static final void connect(TreeViewColumn self, GtkTreeViewColumn.ClickedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, GtkTreeViewColumn.class, "clicked", after);
    }

    protected static final void receiveClicked(Signal handler, long source) {
        ((GtkTreeViewColumn.ClickedSignal) handler).onClicked((TreeViewColumn) objectFor(source));
    }

    static final Widget getTreeView(TreeViewColumn self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_tree_view_column_get_tree_view(pointerOf(self));

            return (Widget) objectFor(result);
        }
    }

    private static native final long gtk_tree_view_column_get_tree_view(long self);
}

