/*
 * GtkWindowGroup.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.gtk;

import org.gnome.gtk.Plumbing;
import org.gnome.gtk.Window;
import org.gnome.gtk.WindowGroup;

final class GtkWindowGroup extends Plumbing
{
    private GtkWindowGroup() {}

    static final long createWindowGroup() {
        long result;

        synchronized (lock) {
            result = gtk_window_group_new();

            return result;
        }
    }

    private static native final long gtk_window_group_new();

    static final void addWindow(WindowGroup self, Window window) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        synchronized (lock) {
            gtk_window_group_add_window(pointerOf(self), pointerOf(window));
        }
    }

    private static native final void gtk_window_group_add_window(long self, long window);

    static final void removeWindow(WindowGroup self, Window window) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (window == null) {
            throw new IllegalArgumentException("window can't be null");
        }

        synchronized (lock) {
            gtk_window_group_remove_window(pointerOf(self), pointerOf(window));
        }
    }

    private static native final void gtk_window_group_remove_window(long self, long window);
}

