/*
 * NotifyMain.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <libnotify/notify.h>
#include "bindings_java.h"
#include "org_gnome_notify_NotifyMain.h"

JNIEXPORT jboolean JNICALL
Java_org_gnome_notify_NotifyMain_notify_1init
(
	JNIEnv* env,
	jclass cls,
	jstring _appName
)
{
	gboolean result;
	jboolean _result;
	const char* appName;

	// convert parameter appName
	appName = (const char*) (*env)->GetStringUTFChars(env, _appName, NULL);
	if (appName == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// call function
	result = notify_init(appName);

	// cleanup parameter appName
	(*env)->ReleaseStringUTFChars(env, _appName, appName);

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_notify_NotifyMain_notify_1uninit
(
	JNIEnv* env,
	jclass cls
)
{

	// call function
	notify_uninit();
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_notify_NotifyMain_notify_1is_1initted
(
	JNIEnv* env,
	jclass cls
)
{
	gboolean result;
	jboolean _result;

	// call function
	result = notify_is_initted();

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_notify_NotifyMain_notify_1get_1app_1name
(
	JNIEnv* env,
	jclass cls
)
{
	const gchar* result;
	jstring _result;

	// call function
	result = notify_get_app_name();

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}
