/*
 * NotifyMain.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.notify;

import org.gnome.notify.Plumbing;

final class NotifyMain extends Plumbing
{
    private NotifyMain() {}

    static final boolean notifyInit(String appName) {
        boolean result;

        if (appName == null) {
            throw new IllegalArgumentException("appName can't be null");
        }

        synchronized (lock) {
            result = notify_init(appName);

            return result;
        }
    }

    private static native final boolean notify_init(String appName);

    static final void notifyUninit() {
        synchronized (lock) {
            notify_uninit();
        }
    }

    private static native final void notify_uninit();

    static final boolean notifyIsInitted() {
        boolean result;

        synchronized (lock) {
            result = notify_is_initted();

            return result;
        }
    }

    private static native final boolean notify_is_initted();

    static final String notifyGetAppName() {
        String result;

        synchronized (lock) {
            result = notify_get_app_name();

            return result;
        }
    }

    private static native final String notify_get_app_name();
}

