/*
 * PangoAttrIterator.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.pango.AttrIterator;
import org.gnome.pango.AttrType;
import org.gnome.pango.Attribute;
import org.gnome.pango.FontDescription;
import org.gnome.pango.Language;
import org.gnome.pango.Plumbing;

final class PangoAttrIterator extends Plumbing
{
    private PangoAttrIterator() {}

    static final void range(AttrIterator self, int[] start, int[] end) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            pango_attr_iterator_range(pointerOf(self), start, end);
        }
    }

    private static native final void pango_attr_iterator_range(long self, int[] start, int[] end);

    static final boolean next(AttrIterator self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_attr_iterator_next(pointerOf(self));

            return result;
        }
    }

    private static native final boolean pango_attr_iterator_next(long self);

    static final AttrIterator copy(AttrIterator self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_attr_iterator_copy(pointerOf(self));

            return (AttrIterator) boxedFor(AttrIterator.class, result);
        }
    }

    private static native final long pango_attr_iterator_copy(long self);

    static final void destroy(AttrIterator self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_attr_iterator_destroy(pointerOf(self));
        }
    }

    private static native final void pango_attr_iterator_destroy(long self);

    static final Attribute get(AttrIterator self, AttrType type) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (type == null) {
            throw new IllegalArgumentException("type can't be null");
        }

        synchronized (lock) {
            result = pango_attr_iterator_get(pointerOf(self), numOf(type));

            return (Attribute) boxedFor(Attribute.class, result);
        }
    }

    private static native final long pango_attr_iterator_get(long self, int type);

    static final void getFont(AttrIterator self, FontDescription desc, Language[] language, FIXME extraAttrs) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GSList**");
    }

    static final Attribute[] getAttrs(AttrIterator self) {
        long[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_attr_iterator_get_attrs(pointerOf(self));

            return (Attribute[]) boxedArrayFor(Attribute.class, result, new Attribute[result.length]);
        }
    }

    private static native final long[] pango_attr_iterator_get_attrs(long self);
}

