/*
 * PangoContext.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.freedesktop.cairo.FontOptions;
import org.gnome.pango.Context;
import org.gnome.pango.Direction;
import org.gnome.pango.Font;
import org.gnome.pango.FontDescription;
import org.gnome.pango.FontMap;
import org.gnome.pango.FontMetrics;
import org.gnome.pango.Fontset;
import org.gnome.pango.Gravity;
import org.gnome.pango.GravityHint;
import org.gnome.pango.Language;
import org.gnome.pango.Matrix;
import org.gnome.pango.Plumbing;

final class PangoContext extends Plumbing
{
    private PangoContext() {}

    static final FontMap getFontMap(Context self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_context_get_font_map(pointerOf(self));

            return (FontMap) objectFor(result);
        }
    }

    private static native final long pango_context_get_font_map(long self);

    static final void listFamilies(Context self, FIXME families, int[] nFamilies) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoFontFamily***");
    }

    static final Font loadFont(Context self, FontDescription desc) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (desc == null) {
            throw new IllegalArgumentException("desc can't be null");
        }

        synchronized (lock) {
            result = pango_context_load_font(pointerOf(self), pointerOf(desc));

            return (Font) objectFor(result);
        }
    }

    private static native final long pango_context_load_font(long self, long desc);

    static final Fontset loadFontset(Context self, FontDescription desc, Language language) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (desc == null) {
            throw new IllegalArgumentException("desc can't be null");
        }

        if (language == null) {
            throw new IllegalArgumentException("language can't be null");
        }

        synchronized (lock) {
            result = pango_context_load_fontset(pointerOf(self), pointerOf(desc), pointerOf(language));

            return (Fontset) objectFor(result);
        }
    }

    private static native final long pango_context_load_fontset(long self, long desc, long language);

    static final FontMetrics getMetrics(Context self, FontDescription desc, Language language) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (desc == null) {
            throw new IllegalArgumentException("desc can't be null");
        }

        synchronized (lock) {
            result = pango_context_get_metrics(pointerOf(self), pointerOf(desc), pointerOf(language));

            return (FontMetrics) boxedFor(FontMetrics.class, result);
        }
    }

    private static native final long pango_context_get_metrics(long self, long desc, long language);

    static final void setFontDescription(Context self, FontDescription desc) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (desc == null) {
            throw new IllegalArgumentException("desc can't be null");
        }

        synchronized (lock) {
            pango_context_set_font_description(pointerOf(self), pointerOf(desc));
        }
    }

    private static native final void pango_context_set_font_description(long self, long desc);

    static final org.gnome.pango.FontDescription getFontDescription(Context self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_context_get_font_description(pointerOf(self));

            return (org.gnome.pango.FontDescription) boxedFor(org.gnome.pango.FontDescription.class, result);
        }
    }

    private static native final long pango_context_get_font_description(long self);

    static final Language getLanguage(Context self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_context_get_language(pointerOf(self));

            return (Language) boxedFor(Language.class, result);
        }
    }

    private static native final long pango_context_get_language(long self);

    static final void setLanguage(Context self, Language language) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (language == null) {
            throw new IllegalArgumentException("language can't be null");
        }

        synchronized (lock) {
            pango_context_set_language(pointerOf(self), pointerOf(language));
        }
    }

    private static native final void pango_context_set_language(long self, long language);

    static final void setBaseDir(Context self, Direction direction) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (direction == null) {
            throw new IllegalArgumentException("direction can't be null");
        }

        synchronized (lock) {
            pango_context_set_base_dir(pointerOf(self), numOf(direction));
        }
    }

    private static native final void pango_context_set_base_dir(long self, int direction);

    static final Direction getBaseDir(Context self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_context_get_base_dir(pointerOf(self));

            return (Direction) enumFor(Direction.class, result);
        }
    }

    private static native final int pango_context_get_base_dir(long self);

    static final void setMatrix(Context self, Matrix matrix) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (matrix == null) {
            throw new IllegalArgumentException("matrix can't be null");
        }

        synchronized (lock) {
            pango_context_set_matrix(pointerOf(self), pointerOf(matrix));
        }
    }

    private static native final void pango_context_set_matrix(long self, long matrix);

    static final Matrix getMatrix(Context self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_context_get_matrix(pointerOf(self));

            return (Matrix) boxedFor(Matrix.class, result);
        }
    }

    private static native final long pango_context_get_matrix(long self);

    static final void setBaseGravity(Context self, Gravity gravity) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (gravity == null) {
            throw new IllegalArgumentException("gravity can't be null");
        }

        synchronized (lock) {
            pango_context_set_base_gravity(pointerOf(self), numOf(gravity));
        }
    }

    private static native final void pango_context_set_base_gravity(long self, int gravity);

    static final Gravity getBaseGravity(Context self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_context_get_base_gravity(pointerOf(self));

            return (Gravity) enumFor(Gravity.class, result);
        }
    }

    private static native final int pango_context_get_base_gravity(long self);

    static final Gravity getGravity(Context self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_context_get_gravity(pointerOf(self));

            return (Gravity) enumFor(Gravity.class, result);
        }
    }

    private static native final int pango_context_get_gravity(long self);

    static final void setGravityHint(Context self, GravityHint hint) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (hint == null) {
            throw new IllegalArgumentException("hint can't be null");
        }

        synchronized (lock) {
            pango_context_set_gravity_hint(pointerOf(self), numOf(hint));
        }
    }

    private static native final void pango_context_set_gravity_hint(long self, int hint);

    static final GravityHint getGravityHint(Context self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_context_get_gravity_hint(pointerOf(self));

            return (GravityHint) enumFor(GravityHint.class, result);
        }
    }

    private static native final int pango_context_get_gravity_hint(long self);

    static final void setFontOptions(Context self, FontOptions options) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (options == null) {
            throw new IllegalArgumentException("options can't be null");
        }

        synchronized (lock) {
            pango_cairo_context_set_font_options(pointerOf(self), pointerOf(options));
        }
    }

    private static native final void pango_cairo_context_set_font_options(long self, long options);
}

