/*
 * PangoFont.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.pango.EngineShape;
import org.gnome.pango.Font;
import org.gnome.pango.FontDescription;
import org.gnome.pango.FontMap;
import org.gnome.pango.FontMetrics;
import org.gnome.pango.Language;
import org.gnome.pango.Plumbing;
import org.gnome.pango.Rectangle;

final class PangoFont extends Plumbing
{
    private PangoFont() {}

    static final FontDescription describe(Font self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_describe(pointerOf(self));

            return (FontDescription) boxedFor(FontDescription.class, result);
        }
    }

    private static native final long pango_font_describe(long self);

    static final FIXME getCoverage(Font self, Language language) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoCoverage*");
    }

    static final EngineShape findShaper(Font self, Language language, int ch) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (language == null) {
            throw new IllegalArgumentException("language can't be null");
        }

        synchronized (lock) {
            result = pango_font_find_shaper(pointerOf(self), pointerOf(language), ch);

            return (EngineShape) objectFor(result);
        }
    }

    private static native final long pango_font_find_shaper(long self, long language, int ch);

    static final FontMetrics getMetrics(Font self, Language language) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_get_metrics(pointerOf(self), pointerOf(language));

            return (FontMetrics) boxedFor(FontMetrics.class, result);
        }
    }

    private static native final long pango_font_get_metrics(long self, long language);

    static final void getGlyphExtents(Font self, FIXME glyph, Rectangle inkRect, Rectangle logicalRect) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoGlyph");
    }

    static final FontMap getFontMap(Font self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_font_get_font_map(pointerOf(self));

            return (FontMap) objectFor(result);
        }
    }

    private static native final long pango_font_get_font_map(long self);

    interface DescribeSignal extends Signal
    {
        FontDescription onDescribe(Font source);
    }

    static final void connect(Font self, PangoFont.DescribeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFont.class, "describe", after);
    }

    protected static final long receiveDescribe(Signal handler, long source) {
        FontDescription result;

        result = ((PangoFont.DescribeSignal) handler).onDescribe((Font) objectFor(source));

        return pointerOf(result);
    }

    interface GetCoverageSignal extends Signal
    {
        FIXME onGetCoverage(Font source, Language lang);
    }

    static final void connect(Font self, PangoFont.GetCoverageSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFont.class, "get-coverage", after);
    }

    protected static final java.lang.Object receiveGetCoverage(Signal handler, long source, long lang) {
        FIXME result;

        result = ((PangoFont.GetCoverageSignal) handler).onGetCoverage((Font) objectFor(source), (Language) boxedFor(Language.class, lang));

        return result;
    }

    interface FindShaperSignal extends Signal
    {
        EngineShape onFindShaper(Font source, Language lang, int ch);
    }

    static final void connect(Font self, PangoFont.FindShaperSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFont.class, "find-shaper", after);
    }

    protected static final long receiveFindShaper(Signal handler, long source, long lang, int ch) {
        EngineShape result;

        result = ((PangoFont.FindShaperSignal) handler).onFindShaper((Font) objectFor(source), (Language) boxedFor(Language.class, lang), ch);

        return pointerOf(result);
    }

    interface GetGlyphExtentsSignal extends Signal
    {
        void onGetGlyphExtents(Font source, FIXME glyph, Rectangle inkRect, Rectangle logicalRect);
    }

    static final void connect(Font self, PangoFont.GetGlyphExtentsSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFont.class, "get-glyph-extents", after);
    }

    protected static final void receiveGetGlyphExtents(Signal handler, long source, java.lang.Object glyph, long inkRect, long logicalRect) {
        ((PangoFont.GetGlyphExtentsSignal) handler).onGetGlyphExtents((Font) objectFor(source), (FIXME) glyph, (Rectangle) boxedFor(Rectangle.class, inkRect), (Rectangle) boxedFor(Rectangle.class, logicalRect));
    }

    interface GetMetricsSignal extends Signal
    {
        FontMetrics onGetMetrics(Font source, Language language);
    }

    static final void connect(Font self, PangoFont.GetMetricsSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFont.class, "get-metrics", after);
    }

    protected static final long receiveGetMetrics(Signal handler, long source, long language) {
        FontMetrics result;

        result = ((PangoFont.GetMetricsSignal) handler).onGetMetrics((Font) objectFor(source), (Language) boxedFor(Language.class, language));

        return pointerOf(result);
    }

    interface GetFontMapSignal extends Signal
    {
        FontMap onGetFontMap(Font source);
    }

    static final void connect(Font self, PangoFont.GetFontMapSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFont.class, "get-font-map", after);
    }

    protected static final long receiveGetFontMap(Signal handler, long source) {
        FontMap result;

        result = ((PangoFont.GetFontMapSignal) handler).onGetFontMap((Font) objectFor(source));

        return pointerOf(result);
    }
}

