/*
 * PangoFontset.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.pango.Font;
import org.gnome.pango.FontMetrics;
import org.gnome.pango.Fontset;
import org.gnome.pango.Language;
import org.gnome.pango.Plumbing;

final class PangoFontset extends Plumbing
{
    private PangoFontset() {}

    static final Font getFont(Fontset self, int wc) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_fontset_get_font(pointerOf(self), wc);

            return (Font) objectFor(result);
        }
    }

    private static native final long pango_fontset_get_font(long self, int wc);

    static final FontMetrics getMetrics(Fontset self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_fontset_get_metrics(pointerOf(self));

            return (FontMetrics) boxedFor(FontMetrics.class, result);
        }
    }

    private static native final long pango_fontset_get_metrics(long self);

    static final void foreach(Fontset self, FIXME func, FIXME data) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoFontsetForeachFunc");
    }

    interface GetFontSignal extends Signal
    {
        Font onGetFont(Fontset source, int wc);
    }

    static final void connect(Fontset self, PangoFontset.GetFontSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontset.class, "get-font", after);
    }

    protected static final long receiveGetFont(Signal handler, long source, int wc) {
        Font result;

        result = ((PangoFontset.GetFontSignal) handler).onGetFont((Fontset) objectFor(source), wc);

        return pointerOf(result);
    }

    interface GetMetricsSignal extends Signal
    {
        FontMetrics onGetMetrics(Fontset source);
    }

    static final void connect(Fontset self, PangoFontset.GetMetricsSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontset.class, "get-metrics", after);
    }

    protected static final long receiveGetMetrics(Signal handler, long source) {
        FontMetrics result;

        result = ((PangoFontset.GetMetricsSignal) handler).onGetMetrics((Fontset) objectFor(source));

        return pointerOf(result);
    }

    interface GetLanguageSignal extends Signal
    {
        Language onGetLanguage(Fontset source);
    }

    static final void connect(Fontset self, PangoFontset.GetLanguageSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontset.class, "get-language", after);
    }

    protected static final long receiveGetLanguage(Signal handler, long source) {
        Language result;

        result = ((PangoFontset.GetLanguageSignal) handler).onGetLanguage((Fontset) objectFor(source));

        return pointerOf(result);
    }

    interface ForeachSignal extends Signal
    {
        void onForeach(Fontset source, FIXME func, FIXME data);
    }

    static final void connect(Fontset self, PangoFontset.ForeachSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoFontset.class, "foreach", after);
    }

    protected static final void receiveForeach(Signal handler, long source, java.lang.Object func, java.lang.Object data) {
        ((PangoFontset.ForeachSignal) handler).onForeach((Fontset) objectFor(source), (FIXME) func, (FIXME) data);
    }
}

