/*
 * PangoLanguage.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.gnome.pango.Language;
import org.gnome.pango.Plumbing;
import org.gnome.pango.Script;

final class PangoLanguage extends Plumbing
{
    private PangoLanguage() {}

    static final boolean includesScript(Language self, Script script) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (script == null) {
            throw new IllegalArgumentException("script can't be null");
        }

        synchronized (lock) {
            result = pango_language_includes_script(pointerOf(self), numOf(script));

            return result;
        }
    }

    private static native final boolean pango_language_includes_script(long self, int script);

    static final long createLanguagegoLanguageFromString(String language) {
        long result;

        if (language == null) {
            throw new IllegalArgumentException("language can't be null");
        }

        synchronized (lock) {
            result = pango_language_from_string(language);

            return result;
        }
    }

    private static native final long pango_language_from_string(String language);

    static final boolean matches(Language self, String rangeList) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (rangeList == null) {
            throw new IllegalArgumentException("rangeList can't be null");
        }

        synchronized (lock) {
            result = pango_language_matches(pointerOf(self), rangeList);

            return result;
        }
    }

    private static native final boolean pango_language_matches(long self, String rangeList);

    static final String toString(Language self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_language_to_string(pointerOf(self));

            return result;
        }
    }

    private static native final String pango_language_to_string(long self);
}

