/*
 * PangoRenderer.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.pango;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.glib.Signal;
import org.gnome.pango.Color;
import org.gnome.pango.Font;
import org.gnome.pango.GlyphString;
import org.gnome.pango.Layout;
import org.gnome.pango.LayoutLine;
import org.gnome.pango.Matrix;
import org.gnome.pango.Plumbing;
import org.gnome.pango.RenderPart;
import org.gnome.pango.Renderer;

final class PangoRenderer extends Plumbing
{
    private PangoRenderer() {}

    static final void drawLayout(Renderer self, Layout layout, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (layout == null) {
            throw new IllegalArgumentException("layout can't be null");
        }

        synchronized (lock) {
            pango_renderer_draw_layout(pointerOf(self), pointerOf(layout), x, y);
        }
    }

    private static native final void pango_renderer_draw_layout(long self, long layout, int x, int y);

    static final void drawLayoutLine(Renderer self, LayoutLine line, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (line == null) {
            throw new IllegalArgumentException("line can't be null");
        }

        synchronized (lock) {
            pango_renderer_draw_layout_line(pointerOf(self), pointerOf(line), x, y);
        }
    }

    private static native final void pango_renderer_draw_layout_line(long self, long line, int x, int y);

    static final void drawGlyphs(Renderer self, Font font, GlyphString glyphs, int x, int y) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (font == null) {
            throw new IllegalArgumentException("font can't be null");
        }

        if (glyphs == null) {
            throw new IllegalArgumentException("glyphs can't be null");
        }

        synchronized (lock) {
            pango_renderer_draw_glyphs(pointerOf(self), pointerOf(font), pointerOf(glyphs), x, y);
        }
    }

    private static native final void pango_renderer_draw_glyphs(long self, long font, long glyphs, int x, int y);

    static final void drawRectangle(Renderer self, RenderPart part, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (part == null) {
            throw new IllegalArgumentException("part can't be null");
        }

        synchronized (lock) {
            pango_renderer_draw_rectangle(pointerOf(self), numOf(part), x, y, width, height);
        }
    }

    private static native final void pango_renderer_draw_rectangle(long self, int part, int x, int y, int width, int height);

    static final void drawErrorUnderline(Renderer self, int x, int y, int width, int height) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_renderer_draw_error_underline(pointerOf(self), x, y, width, height);
        }
    }

    private static native final void pango_renderer_draw_error_underline(long self, int x, int y, int width, int height);

    static final void drawTrapezoid(Renderer self, RenderPart part, double y1, double x11, double x21, double y2, double x12, double x22) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (part == null) {
            throw new IllegalArgumentException("part can't be null");
        }

        synchronized (lock) {
            pango_renderer_draw_trapezoid(pointerOf(self), numOf(part), y1, x11, x21, y2, x12, x22);
        }
    }

    private static native final void pango_renderer_draw_trapezoid(long self, int part, double y1, double x11, double x21, double y2, double x12, double x22);

    static final void drawGlyph(Renderer self, Font font, FIXME glyph, double x, double y) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("PangoGlyph");
    }

    static final void activate(Renderer self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_renderer_activate(pointerOf(self));
        }
    }

    private static native final void pango_renderer_activate(long self);

    static final void deactivate(Renderer self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            pango_renderer_deactivate(pointerOf(self));
        }
    }

    private static native final void pango_renderer_deactivate(long self);

    static final void partChanged(Renderer self, RenderPart part) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (part == null) {
            throw new IllegalArgumentException("part can't be null");
        }

        synchronized (lock) {
            pango_renderer_part_changed(pointerOf(self), numOf(part));
        }
    }

    private static native final void pango_renderer_part_changed(long self, int part);

    static final void setColor(Renderer self, RenderPart part, Color color) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (part == null) {
            throw new IllegalArgumentException("part can't be null");
        }

        if (color == null) {
            throw new IllegalArgumentException("color can't be null");
        }

        synchronized (lock) {
            pango_renderer_set_color(pointerOf(self), numOf(part), pointerOf(color));
        }
    }

    private static native final void pango_renderer_set_color(long self, int part, long color);

    static final org.gnome.pango.Color getColor(Renderer self, RenderPart part) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (part == null) {
            throw new IllegalArgumentException("part can't be null");
        }

        synchronized (lock) {
            result = pango_renderer_get_color(pointerOf(self), numOf(part));

            return (org.gnome.pango.Color) boxedFor(org.gnome.pango.Color.class, result);
        }
    }

    private static native final long pango_renderer_get_color(long self, int part);

    static final void setMatrix(Renderer self, Matrix matrix) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (matrix == null) {
            throw new IllegalArgumentException("matrix can't be null");
        }

        synchronized (lock) {
            pango_renderer_set_matrix(pointerOf(self), pointerOf(matrix));
        }
    }

    private static native final void pango_renderer_set_matrix(long self, long matrix);

    static final Matrix getMatrix(Renderer self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = pango_renderer_get_matrix(pointerOf(self));

            return (Matrix) boxedFor(Matrix.class, result);
        }
    }

    private static native final long pango_renderer_get_matrix(long self);

    interface DrawGlyphsSignal extends Signal
    {
        void onDrawGlyphs(Renderer source, Font font, GlyphString glyphs, int x, int y);
    }

    static final void connect(Renderer self, PangoRenderer.DrawGlyphsSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoRenderer.class, "draw-glyphs", after);
    }

    protected static final void receiveDrawGlyphs(Signal handler, long source, long font, long glyphs, int x, int y) {
        ((PangoRenderer.DrawGlyphsSignal) handler).onDrawGlyphs((Renderer) objectFor(source), (Font) objectFor(font), (GlyphString) boxedFor(GlyphString.class, glyphs), x, y);
    }

    interface DrawRectangleSignal extends Signal
    {
        void onDrawRectangle(Renderer source, RenderPart part, int x, int y, int width, int height);
    }

    static final void connect(Renderer self, PangoRenderer.DrawRectangleSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoRenderer.class, "draw-rectangle", after);
    }

    protected static final void receiveDrawRectangle(Signal handler, long source, int part, int x, int y, int width, int height) {
        ((PangoRenderer.DrawRectangleSignal) handler).onDrawRectangle((Renderer) objectFor(source), (RenderPart) enumFor(RenderPart.class, part), x, y, width, height);
    }

    interface DrawErrorUnderlineSignal extends Signal
    {
        void onDrawErrorUnderline(Renderer source, int x, int y, int width, int height);
    }

    static final void connect(Renderer self, PangoRenderer.DrawErrorUnderlineSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoRenderer.class, "draw-error-underline", after);
    }

    protected static final void receiveDrawErrorUnderline(Signal handler, long source, int x, int y, int width, int height) {
        ((PangoRenderer.DrawErrorUnderlineSignal) handler).onDrawErrorUnderline((Renderer) objectFor(source), x, y, width, height);
    }

    interface DrawShapeSignal extends Signal
    {
        void onDrawShape(Renderer source, FIXME attr, int x, int y);
    }

    static final void connect(Renderer self, PangoRenderer.DrawShapeSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoRenderer.class, "draw-shape", after);
    }

    protected static final void receiveDrawShape(Signal handler, long source, java.lang.Object attr, int x, int y) {
        ((PangoRenderer.DrawShapeSignal) handler).onDrawShape((Renderer) objectFor(source), (FIXME) attr, x, y);
    }

    interface DrawTrapezoidSignal extends Signal
    {
        void onDrawTrapezoid(Renderer source, RenderPart part, double y1, double x11, double x21, double y2, double x12, double x22);
    }

    static final void connect(Renderer self, PangoRenderer.DrawTrapezoidSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoRenderer.class, "draw-trapezoid", after);
    }

    protected static final void receiveDrawTrapezoid(Signal handler, long source, int part, double y1, double x11, double x21, double y2, double x12, double x22) {
        ((PangoRenderer.DrawTrapezoidSignal) handler).onDrawTrapezoid((Renderer) objectFor(source), (RenderPart) enumFor(RenderPart.class, part), y1, x11, x21, y2, x12, x22);
    }

    interface DrawGlyphSignal extends Signal
    {
        void onDrawGlyph(Renderer source, Font font, FIXME glyph, double x, double y);
    }

    static final void connect(Renderer self, PangoRenderer.DrawGlyphSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoRenderer.class, "draw-glyph", after);
    }

    protected static final void receiveDrawGlyph(Signal handler, long source, long font, java.lang.Object glyph, double x, double y) {
        ((PangoRenderer.DrawGlyphSignal) handler).onDrawGlyph((Renderer) objectFor(source), (Font) objectFor(font), (FIXME) glyph, x, y);
    }

    interface PartChangedSignal extends Signal
    {
        void onPartChanged(Renderer source, RenderPart part);
    }

    static final void connect(Renderer self, PangoRenderer.PartChangedSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoRenderer.class, "part-changed", after);
    }

    protected static final void receivePartChanged(Signal handler, long source, int part) {
        ((PangoRenderer.PartChangedSignal) handler).onPartChanged((Renderer) objectFor(source), (RenderPart) enumFor(RenderPart.class, part));
    }

    interface BeginSignal extends Signal
    {
        void onBegin(Renderer source);
    }

    static final void connect(Renderer self, PangoRenderer.BeginSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoRenderer.class, "begin", after);
    }

    protected static final void receiveBegin(Signal handler, long source) {
        ((PangoRenderer.BeginSignal) handler).onBegin((Renderer) objectFor(source));
    }

    interface EndSignal extends Signal
    {
        void onEnd(Renderer source);
    }

    static final void connect(Renderer self, PangoRenderer.EndSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoRenderer.class, "end", after);
    }

    protected static final void receiveEnd(Signal handler, long source) {
        ((PangoRenderer.EndSignal) handler).onEnd((Renderer) objectFor(source));
    }

    interface PrepareRunSignal extends Signal
    {
        void onPrepareRun(Renderer source, FIXME run);
    }

    static final void connect(Renderer self, PangoRenderer.PrepareRunSignal handlerInstance, boolean after) {
        connectSignal(self, handlerInstance, PangoRenderer.class, "prepare-run", after);
    }

    protected static final void receivePrepareRun(Signal handler, long source, java.lang.Object run) {
        ((PangoRenderer.PrepareRunSignal) handler).onPrepareRun((Renderer) objectFor(source), (FIXME) run);
    }
}

