/*
 * GtkSourceBuffer.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.sourceview;

import org.freedesktop.bindings.BlacklistedMethodError;
import org.freedesktop.bindings.FIXME;
import org.gnome.gtk.TextIter;
import org.gnome.gtk.TextTagTable;
import org.gnome.sourceview.Language;
import org.gnome.sourceview.Mark;
import org.gnome.sourceview.Plumbing;
import org.gnome.sourceview.SourceBuffer;
import org.gnome.sourceview.StyleScheme;

final class GtkSourceBuffer extends Plumbing
{
    private GtkSourceBuffer() {}

    static final long createSourceBuffer(TextTagTable table) {
        long result;

        if (table == null) {
            throw new IllegalArgumentException("table can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_new(pointerOf(table));

            return result;
        }
    }

    private static native final long gtk_source_buffer_new(long table);

    static final long createSourceBufferWithLanguage(Language language) {
        long result;

        if (language == null) {
            throw new IllegalArgumentException("language can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_new_with_language(pointerOf(language));

            return result;
        }
    }

    private static native final long gtk_source_buffer_new_with_language(long language);

    static final boolean getHighlightSyntax(SourceBuffer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_get_highlight_syntax(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_buffer_get_highlight_syntax(long self);

    static final void setHighlightSyntax(SourceBuffer self, boolean highlight) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_buffer_set_highlight_syntax(pointerOf(self), highlight);
        }
    }

    private static native final void gtk_source_buffer_set_highlight_syntax(long self, boolean highlight);

    static final boolean getHighlightMatchingBrackets(SourceBuffer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_get_highlight_matching_brackets(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_buffer_get_highlight_matching_brackets(long self);

    static final void setHighlightMatchingBrackets(SourceBuffer self, boolean highlight) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_buffer_set_highlight_matching_brackets(pointerOf(self), highlight);
        }
    }

    private static native final void gtk_source_buffer_set_highlight_matching_brackets(long self, boolean highlight);

    static final int getMaxUndoLevels(SourceBuffer self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_get_max_undo_levels(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_source_buffer_get_max_undo_levels(long self);

    static final void setMaxUndoLevels(SourceBuffer self, int maxUndoLevels) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_buffer_set_max_undo_levels(pointerOf(self), maxUndoLevels);
        }
    }

    private static native final void gtk_source_buffer_set_max_undo_levels(long self, int maxUndoLevels);

    static final Language getLanguage(SourceBuffer self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_get_language(pointerOf(self));

            return (Language) objectFor(result);
        }
    }

    private static native final long gtk_source_buffer_get_language(long self);

    static final void setLanguage(SourceBuffer self, Language language) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_buffer_set_language(pointerOf(self), pointerOf(language));
        }
    }

    private static native final void gtk_source_buffer_set_language(long self, long language);

    static final boolean canUndo(SourceBuffer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_can_undo(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_buffer_can_undo(long self);

    static final boolean canRedo(SourceBuffer self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_can_redo(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_buffer_can_redo(long self);

    static final void undo(SourceBuffer self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_buffer_undo(pointerOf(self));
        }
    }

    private static native final void gtk_source_buffer_undo(long self);

    static final void redo(SourceBuffer self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_buffer_redo(pointerOf(self));
        }
    }

    private static native final void gtk_source_buffer_redo(long self);

    static final void beginNotUndoableAction(SourceBuffer self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_buffer_begin_not_undoable_action(pointerOf(self));
        }
    }

    private static native final void gtk_source_buffer_begin_not_undoable_action(long self);

    static final void endNotUndoableAction(SourceBuffer self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_buffer_end_not_undoable_action(pointerOf(self));
        }
    }

    private static native final void gtk_source_buffer_end_not_undoable_action(long self);

    static final StyleScheme getStyleScheme(SourceBuffer self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_get_style_scheme(pointerOf(self));

            return (StyleScheme) objectFor(result);
        }
    }

    private static native final long gtk_source_buffer_get_style_scheme(long self);

    static final void setStyleScheme(SourceBuffer self, StyleScheme scheme) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (scheme == null) {
            throw new IllegalArgumentException("scheme can't be null");
        }

        synchronized (lock) {
            gtk_source_buffer_set_style_scheme(pointerOf(self), pointerOf(scheme));
        }
    }

    private static native final void gtk_source_buffer_set_style_scheme(long self, long scheme);

    static final void ensureHighlight(SourceBuffer self, TextIter start, TextIter end) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            gtk_source_buffer_ensure_highlight(pointerOf(self), pointerOf(start), pointerOf(end));
        }
    }

    private static native final void gtk_source_buffer_ensure_highlight(long self, long start, long end);

    static final Mark createSourceMark(SourceBuffer self, String name, String category, org.gnome.gtk.TextIter where) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (category == null) {
            throw new IllegalArgumentException("category can't be null");
        }

        if (where == null) {
            throw new IllegalArgumentException("where can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_create_source_mark(pointerOf(self), name, category, pointerOf(where));

            return (Mark) objectFor(result);
        }
    }

    private static native final long gtk_source_buffer_create_source_mark(long self, String name, String category, long where);

    static final boolean forwardIterToSourceMark(SourceBuffer self, TextIter iter, String category) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_forward_iter_to_source_mark(pointerOf(self), pointerOf(iter), category);

            return result;
        }
    }

    private static native final boolean gtk_source_buffer_forward_iter_to_source_mark(long self, long iter, String category);

    static final boolean backwardIterToSourceMark(SourceBuffer self, TextIter iter, String category) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (iter == null) {
            throw new IllegalArgumentException("iter can't be null");
        }

        synchronized (lock) {
            result = gtk_source_buffer_backward_iter_to_source_mark(pointerOf(self), pointerOf(iter), category);

            return result;
        }
    }

    private static native final boolean gtk_source_buffer_backward_iter_to_source_mark(long self, long iter, String category);

    static final FIXME getSourceMarksAtIter(SourceBuffer self, TextIter iter, String category) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GSList*");
    }

    static final FIXME getSourceMarksAtLine(SourceBuffer self, int line, String category) throws BlacklistedMethodError {
        throw new BlacklistedMethodError("GSList*");
    }

    static final void removeSourceMarks(SourceBuffer self, TextIter start, TextIter end, String category) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (start == null) {
            throw new IllegalArgumentException("start can't be null");
        }

        if (end == null) {
            throw new IllegalArgumentException("end can't be null");
        }

        synchronized (lock) {
            gtk_source_buffer_remove_source_marks(pointerOf(self), pointerOf(start), pointerOf(end), category);
        }
    }

    private static native final void gtk_source_buffer_remove_source_marks(long self, long start, long end, String category);
}

