/*
 * GtkSourceLanguage.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <gtksourceview/gtksourcelanguage.h>
#include "bindings_java.h"
#include "org_gnome_sourceview_GtkSourceLanguage.h"

JNIEXPORT jstring JNICALL
Java_org_gnome_sourceview_GtkSourceLanguage_gtk_1source_1language_1get_1id
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkSourceLanguage* self;

	// convert parameter self
	self = (GtkSourceLanguage*) _self;

	// call function
	result = gtk_source_language_get_id(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_sourceview_GtkSourceLanguage_gtk_1source_1language_1get_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkSourceLanguage* self;

	// convert parameter self
	self = (GtkSourceLanguage*) _self;

	// call function
	result = gtk_source_language_get_name(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_sourceview_GtkSourceLanguage_gtk_1source_1language_1get_1section
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkSourceLanguage* self;

	// convert parameter self
	self = (GtkSourceLanguage*) _self;

	// call function
	result = gtk_source_language_get_section(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceLanguage_gtk_1source_1language_1get_1hidden
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceLanguage* self;

	// convert parameter self
	self = (GtkSourceLanguage*) _self;

	// call function
	result = gtk_source_language_get_hidden(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_sourceview_GtkSourceLanguage_gtk_1source_1language_1get_1metadata
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _name
)
{
	const gchar* result;
	jstring _result;
	GtkSourceLanguage* self;
	const gchar* name;

	// convert parameter self
	self = (GtkSourceLanguage*) _self;

	// convert parameter name
	name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
	if (name == NULL) {
		return NULL; // Java Exception already thrown
	}

	// call function
	result = gtk_source_language_get_metadata(self, name);

	// cleanup parameter self

	// cleanup parameter name
	(*env)->ReleaseStringUTFChars(env, _name, name);

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jobjectArray JNICALL
Java_org_gnome_sourceview_GtkSourceLanguage_gtk_1source_1language_1get_1mime_1types
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar** result;
	jobjectArray _result;
	GtkSourceLanguage* self;

	// convert parameter self
	self = (GtkSourceLanguage*) _self;

	// call function
	result = gtk_source_language_get_mime_types(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jobjectArray) bindings_java_convert_gchararray_to_jarray(env, (const gchar**)result);

	// and finally
	return _result;
}

JNIEXPORT jobjectArray JNICALL
Java_org_gnome_sourceview_GtkSourceLanguage_gtk_1source_1language_1get_1globs
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar** result;
	jobjectArray _result;
	GtkSourceLanguage* self;

	// convert parameter self
	self = (GtkSourceLanguage*) _self;

	// call function
	result = gtk_source_language_get_globs(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jobjectArray) bindings_java_convert_gchararray_to_jarray(env, (const gchar**)result);

	// and finally
	return _result;
}

JNIEXPORT jobjectArray JNICALL
Java_org_gnome_sourceview_GtkSourceLanguage_gtk_1source_1language_1get_1style_1ids
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gchar** result;
	jobjectArray _result;
	GtkSourceLanguage* self;

	// convert parameter self
	self = (GtkSourceLanguage*) _self;

	// call function
	result = gtk_source_language_get_style_ids(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jobjectArray) bindings_java_convert_gchararray_to_jarray(env, (const gchar**)result);

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_sourceview_GtkSourceLanguage_gtk_1source_1language_1get_1style_1name
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _styleId
)
{
	const char* result;
	jstring _result;
	GtkSourceLanguage* self;
	const char* styleId;

	// convert parameter self
	self = (GtkSourceLanguage*) _self;

	// convert parameter styleId
	styleId = (const char*) (*env)->GetStringUTFChars(env, _styleId, NULL);
	if (styleId == NULL) {
		return NULL; // Java Exception already thrown
	}

	// call function
	result = gtk_source_language_get_style_name(self, styleId);

	// cleanup parameter self

	// cleanup parameter styleId
	(*env)->ReleaseStringUTFChars(env, _styleId, styleId);

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}
