/*
 * GtkSourceLanguage.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.sourceview;

import org.gnome.sourceview.Language;
import org.gnome.sourceview.Plumbing;

final class GtkSourceLanguage extends Plumbing
{
    private GtkSourceLanguage() {}

    static final String getId(Language self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_get_id(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_source_language_get_id(long self);

    static final String getName(Language self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_get_name(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_source_language_get_name(long self);

    static final String getSection(Language self) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_get_section(pointerOf(self));

            return result;
        }
    }

    private static native final String gtk_source_language_get_section(long self);

    static final boolean getHidden(Language self) {
        boolean result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_get_hidden(pointerOf(self));

            return result;
        }
    }

    private static native final boolean gtk_source_language_get_hidden(long self);

    static final String getMetadata(Language self, String name) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (name == null) {
            throw new IllegalArgumentException("name can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_get_metadata(pointerOf(self), name);

            return result;
        }
    }

    private static native final String gtk_source_language_get_metadata(long self, String name);

    static final String[] getMimeTypes(Language self) {
        String[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_get_mime_types(pointerOf(self));

            return result;
        }
    }

    private static native final String[] gtk_source_language_get_mime_types(long self);

    static final String[] getGlobs(Language self) {
        String[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_get_globs(pointerOf(self));

            return result;
        }
    }

    private static native final String[] gtk_source_language_get_globs(long self);

    static final String[] getStyleIds(Language self) {
        String[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_get_style_ids(pointerOf(self));

            return result;
        }
    }

    private static native final String[] gtk_source_language_get_style_ids(long self);

    static final String getStyleName(Language self, String styleId) {
        String result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (styleId == null) {
            throw new IllegalArgumentException("styleId can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_get_style_name(pointerOf(self), styleId);

            return result;
        }
    }

    private static native final String gtk_source_language_get_style_name(long self, String styleId);
}

