/*
 * GtkSourceLanguageManager.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.sourceview;

import org.gnome.sourceview.Language;
import org.gnome.sourceview.LanguageManager;
import org.gnome.sourceview.Plumbing;

final class GtkSourceLanguageManager extends Plumbing
{
    private GtkSourceLanguageManager() {}

    static final long createLanguageManager() {
        long result;

        synchronized (lock) {
            result = gtk_source_language_manager_new();

            return result;
        }
    }

    private static native final long gtk_source_language_manager_new();

    static final LanguageManager getDefault() {
        long result;

        synchronized (lock) {
            result = gtk_source_language_manager_get_default();

            return (LanguageManager) objectFor(result);
        }
    }

    private static native final long gtk_source_language_manager_get_default();

    static final String[] getLanguageIds(LanguageManager self) {
        String[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_manager_get_language_ids(pointerOf(self));

            return result;
        }
    }

    private static native final String[] gtk_source_language_manager_get_language_ids(long self);

    static final Language getLanguage(LanguageManager self, String id) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (id == null) {
            throw new IllegalArgumentException("id can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_manager_get_language(pointerOf(self), id);

            return (Language) objectFor(result);
        }
    }

    private static native final long gtk_source_language_manager_get_language(long self, String id);

    static final String[] getSearchPath(LanguageManager self) {
        String[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_manager_get_search_path(pointerOf(self));

            return result;
        }
    }

    private static native final String[] gtk_source_language_manager_get_search_path(long self);

    static final void setSearchPath(LanguageManager self, String[] dirs) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (dirs == null) {
            throw new IllegalArgumentException("dirs can't be null");
        }

        synchronized (lock) {
            gtk_source_language_manager_set_search_path(pointerOf(self), dirs);
        }
    }

    private static native final void gtk_source_language_manager_set_search_path(long self, String[] dirs);

    static final Language guessLanguage(LanguageManager self, String filename, String contentType) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_language_manager_guess_language(pointerOf(self), filename, contentType);

            return (Language) objectFor(result);
        }
    }

    private static native final long gtk_source_language_manager_guess_language(long self, String filename, String contentType);
}

