/*
 * GtkSourceMark.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <gtksourceview/gtksourcemark.h>
#include "bindings_java.h"
#include "org_gnome_sourceview_GtkSourceMark.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceMark_gtk_1source_1mark_1new
(
	JNIEnv* env,
	jclass cls,
	jstring _name,
	jstring _category
)
{
	GtkSourceMark* result;
	jlong _result;
	const gchar* name;
	const gchar* category;

	// convert parameter name
	if (_name == NULL) {
		name = NULL;
	} else {
		name = (const gchar*) (*env)->GetStringUTFChars(env, _name, NULL);
		if (name == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// convert parameter category
	category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
	if (category == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_source_mark_new(name, category);

	// cleanup parameter name
	if (name != NULL) {
		(*env)->ReleaseStringUTFChars(env, _name, name);
	}

	// cleanup parameter category
	(*env)->ReleaseStringUTFChars(env, _category, category);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jstring JNICALL
Java_org_gnome_sourceview_GtkSourceMark_gtk_1source_1mark_1get_1category
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	const gchar* result;
	jstring _result;
	GtkSourceMark* self;

	// convert parameter self
	self = (GtkSourceMark*) _self;

	// call function
	result = gtk_source_mark_get_category(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jstring) (*env)->NewStringUTF(env, result);

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceMark_gtk_1source_1mark_1next
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _category
)
{
	GtkSourceMark* result;
	jlong _result;
	GtkSourceMark* self;
	const gchar* category;

	// convert parameter self
	self = (GtkSourceMark*) _self;

	// convert parameter category
	if (_category == NULL) {
		category = NULL;
	} else {
		category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
		if (category == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_source_mark_next(self, category);

	// cleanup parameter self

	// cleanup parameter category
	if (category != NULL) {
		(*env)->ReleaseStringUTFChars(env, _category, category);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceMark_gtk_1source_1mark_1prev
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _category
)
{
	GtkSourceMark* result;
	jlong _result;
	GtkSourceMark* self;
	const gchar* category;

	// convert parameter self
	self = (GtkSourceMark*) _self;

	// convert parameter category
	if (_category == NULL) {
		category = NULL;
	} else {
		category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
		if (category == NULL) {
			return 0L; // Java Exception already thrown
		}
	}

	// call function
	result = gtk_source_mark_prev(self, category);

	// cleanup parameter self

	// cleanup parameter category
	if (category != NULL) {
		(*env)->ReleaseStringUTFChars(env, _category, category);
	}

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}
