/*
 * GtkSourceStyleSchemeManager.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.sourceview;

import org.gnome.sourceview.Plumbing;
import org.gnome.sourceview.StyleScheme;
import org.gnome.sourceview.StyleSchemeManager;

final class GtkSourceStyleSchemeManager extends Plumbing
{
    private GtkSourceStyleSchemeManager() {}

    static final long createStyleSchemeManager() {
        long result;

        synchronized (lock) {
            result = gtk_source_style_scheme_manager_new();

            return result;
        }
    }

    private static native final long gtk_source_style_scheme_manager_new();

    static final void setSearchPath(StyleSchemeManager self, String[] path) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            gtk_source_style_scheme_manager_set_search_path(pointerOf(self), path);
        }
    }

    private static native final void gtk_source_style_scheme_manager_set_search_path(long self, String[] path);

    static final String[] getSearchPath(StyleSchemeManager self) {
        String[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_style_scheme_manager_get_search_path(pointerOf(self));

            return result;
        }
    }

    private static native final String[] gtk_source_style_scheme_manager_get_search_path(long self);

    static final void appendSearchPath(StyleSchemeManager self, String path) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            gtk_source_style_scheme_manager_append_search_path(pointerOf(self), path);
        }
    }

    private static native final void gtk_source_style_scheme_manager_append_search_path(long self, String path);

    static final void prependSearchPath(StyleSchemeManager self, String path) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (path == null) {
            throw new IllegalArgumentException("path can't be null");
        }

        synchronized (lock) {
            gtk_source_style_scheme_manager_prepend_search_path(pointerOf(self), path);
        }
    }

    private static native final void gtk_source_style_scheme_manager_prepend_search_path(long self, String path);

    static final String[] getSchemeIds(StyleSchemeManager self) {
        String[] result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_source_style_scheme_manager_get_scheme_ids(pointerOf(self));

            return result;
        }
    }

    private static native final String[] gtk_source_style_scheme_manager_get_scheme_ids(long self);

    static final StyleScheme getScheme(StyleSchemeManager self, String schemeId) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (schemeId == null) {
            throw new IllegalArgumentException("schemeId can't be null");
        }

        synchronized (lock) {
            result = gtk_source_style_scheme_manager_get_scheme(pointerOf(self), schemeId);

            return (StyleScheme) objectFor(result);
        }
    }

    private static native final long gtk_source_style_scheme_manager_get_scheme(long self, String schemeId);

    static final void forceRescan(StyleSchemeManager self) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_source_style_scheme_manager_force_rescan(pointerOf(self));
        }
    }

    private static native final void gtk_source_style_scheme_manager_force_rescan(long self);
}

