/*
 * GtkSourceView.c
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */

#include <jni.h>
#include <gtk/gtk.h>
#include <gtksourceview/gtksourceview.h>
#include "bindings_java.h"
#include "org_gnome_sourceview_GtkSourceView.h"

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1new
(
	JNIEnv* env,
	jclass cls
)
{
	GtkWidget* result;
	jlong _result;

	// call function
	result = gtk_source_view_new();

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1new_1with_1buffer
(
	JNIEnv* env,
	jclass cls,
	jlong _buffer
)
{
	GtkWidget* result;
	jlong _result;
	GtkSourceBuffer* buffer;

	// convert parameter buffer
	buffer = (GtkSourceBuffer*) _buffer;

	// call function
	result = gtk_source_view_new_with_buffer(buffer);

	// cleanup parameter buffer

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, TRUE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1show_1line_1numbers
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _show
)
{
	GtkSourceView* self;
	gboolean show;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter show
	show = (gboolean) _show;

	// call function
	gtk_source_view_set_show_line_numbers(self, show);

	// cleanup parameter self

	// cleanup parameter show
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1show_1line_1numbers
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceView* self;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// call function
	result = gtk_source_view_get_show_line_numbers(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1indent_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _width
)
{
	GtkSourceView* self;
	guint width;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter width
	width = (guint) _width;

	// call function
	gtk_source_view_set_indent_width(self, width);

	// cleanup parameter self

	// cleanup parameter width
}

JNIEXPORT jint JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1indent_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint result;
	jint _result;
	GtkSourceView* self;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// call function
	result = gtk_source_view_get_indent_width(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1tab_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _width
)
{
	GtkSourceView* self;
	guint width;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter width
	width = (guint) _width;

	// call function
	gtk_source_view_set_tab_width(self, width);

	// cleanup parameter self

	// cleanup parameter width
}

JNIEXPORT jint JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1tab_1width
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint result;
	jint _result;
	GtkSourceView* self;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// call function
	result = gtk_source_view_get_tab_width(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1auto_1indent
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _enable
)
{
	GtkSourceView* self;
	gboolean enable;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter enable
	enable = (gboolean) _enable;

	// call function
	gtk_source_view_set_auto_indent(self, enable);

	// cleanup parameter self

	// cleanup parameter enable
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1auto_1indent
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceView* self;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// call function
	result = gtk_source_view_get_auto_indent(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1insert_1spaces_1instead_1of_1tabs
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _enable
)
{
	GtkSourceView* self;
	gboolean enable;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter enable
	enable = (gboolean) _enable;

	// call function
	gtk_source_view_set_insert_spaces_instead_of_tabs(self, enable);

	// cleanup parameter self

	// cleanup parameter enable
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1insert_1spaces_1instead_1of_1tabs
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceView* self;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// call function
	result = gtk_source_view_get_insert_spaces_instead_of_tabs(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1indent_1on_1tab
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _enable
)
{
	GtkSourceView* self;
	gboolean enable;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter enable
	enable = (gboolean) _enable;

	// call function
	gtk_source_view_set_indent_on_tab(self, enable);

	// cleanup parameter self

	// cleanup parameter enable
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1indent_1on_1tab
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceView* self;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// call function
	result = gtk_source_view_get_indent_on_tab(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1highlight_1current_1line
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _show
)
{
	GtkSourceView* self;
	gboolean show;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter show
	show = (gboolean) _show;

	// call function
	gtk_source_view_set_highlight_current_line(self, show);

	// cleanup parameter self

	// cleanup parameter show
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1highlight_1current_1line
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceView* self;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// call function
	result = gtk_source_view_get_highlight_current_line(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1show_1right_1margin
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _show
)
{
	GtkSourceView* self;
	gboolean show;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter show
	show = (gboolean) _show;

	// call function
	gtk_source_view_set_show_right_margin(self, show);

	// cleanup parameter self

	// cleanup parameter show
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1show_1right_1margin
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceView* self;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// call function
	result = gtk_source_view_get_show_right_margin(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1right_1margin_1position
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _pos
)
{
	GtkSourceView* self;
	guint pos;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter pos
	pos = (guint) _pos;

	// call function
	gtk_source_view_set_right_margin_position(self, pos);

	// cleanup parameter self

	// cleanup parameter pos
}

JNIEXPORT jint JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1right_1margin_1position
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	guint result;
	jint _result;
	GtkSourceView* self;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// call function
	result = gtk_source_view_get_right_margin_position(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1show_1line_1marks
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jboolean _show
)
{
	GtkSourceView* self;
	gboolean show;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter show
	show = (gboolean) _show;

	// call function
	gtk_source_view_set_show_line_marks(self, show);

	// cleanup parameter self

	// cleanup parameter show
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1show_1line_1marks
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	gboolean result;
	jboolean _result;
	GtkSourceView* self;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// call function
	result = gtk_source_view_get_show_line_marks(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1mark_1category_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _category,
	jlong _pixbuf
)
{
	GtkSourceView* self;
	const gchar* category;
	GdkPixbuf* pixbuf;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter category
	category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
	if (category == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter pixbuf
	pixbuf = (GdkPixbuf*) _pixbuf;

	// call function
	gtk_source_view_set_mark_category_pixbuf(self, category, pixbuf);

	// cleanup parameter self

	// cleanup parameter category
	(*env)->ReleaseStringUTFChars(env, _category, category);

	// cleanup parameter pixbuf
}

JNIEXPORT jlong JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1mark_1category_1pixbuf
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _category
)
{
	GdkPixbuf* result;
	jlong _result;
	GtkSourceView* self;
	const gchar* category;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter category
	category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
	if (category == NULL) {
		return 0L; // Java Exception already thrown
	}

	// call function
	result = gtk_source_view_get_mark_category_pixbuf(self, category);

	// cleanup parameter self

	// cleanup parameter category
	(*env)->ReleaseStringUTFChars(env, _category, category);

	// translate return value to JNI type
	_result = (jlong) result;

	// cleanup return value
	if (result != NULL) {
		bindings_java_memory_cleanup((GObject*)result, FALSE);
	}

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1mark_1category_1priority
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _category,
	jint _priority
)
{
	GtkSourceView* self;
	const gchar* category;
	gint priority;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter category
	category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
	if (category == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter priority
	priority = (gint) _priority;

	// call function
	gtk_source_view_set_mark_category_priority(self, category, priority);

	// cleanup parameter self

	// cleanup parameter category
	(*env)->ReleaseStringUTFChars(env, _category, category);

	// cleanup parameter priority
}

JNIEXPORT jint JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1mark_1category_1priority
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _category
)
{
	gint result;
	jint _result;
	GtkSourceView* self;
	const gchar* category;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter category
	category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
	if (category == NULL) {
		return  0; // Java Exception already thrown
	}

	// call function
	result = gtk_source_view_get_mark_category_priority(self, category);

	// cleanup parameter self

	// cleanup parameter category
	(*env)->ReleaseStringUTFChars(env, _category, category);

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1smart_1home_1end
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jint _smartHe
)
{
	GtkSourceView* self;
	GtkSourceSmartHomeEndType smartHe;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter smartHe
	smartHe = (GtkSourceSmartHomeEndType) _smartHe;

	// call function
	gtk_source_view_set_smart_home_end(self, smartHe);

	// cleanup parameter self

	// cleanup parameter smartHe
}

JNIEXPORT jint JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1smart_1home_1end
(
	JNIEnv* env,
	jclass cls,
	jlong _self
)
{
	GtkSourceSmartHomeEndType result;
	jint _result;
	GtkSourceView* self;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// call function
	result = gtk_source_view_get_smart_home_end(self);

	// cleanup parameter self

	// translate return value to JNI type
	_result = (jint) result;

	// and finally
	return _result;
}

JNIEXPORT void JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1set_1mark_1category_1background
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _category,
	jlong _color
)
{
	GtkSourceView* self;
	const gchar* category;
	const GdkColor* color;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter category
	category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
	if (category == NULL) {
		return; // Java Exception already thrown
	}

	// convert parameter color
	color = (const GdkColor*) _color;

	// call function
	gtk_source_view_set_mark_category_background(self, category, color);

	// cleanup parameter self

	// cleanup parameter category
	(*env)->ReleaseStringUTFChars(env, _category, category);

	// cleanup parameter color
}

JNIEXPORT jboolean JNICALL
Java_org_gnome_sourceview_GtkSourceView_gtk_1source_1view_1get_1mark_1category_1background
(
	JNIEnv* env,
	jclass cls,
	jlong _self,
	jstring _category,
	jlong _dest
)
{
	gboolean result;
	jboolean _result;
	GtkSourceView* self;
	const gchar* category;
	GdkColor* dest;

	// convert parameter self
	self = (GtkSourceView*) _self;

	// convert parameter category
	category = (const gchar*) (*env)->GetStringUTFChars(env, _category, NULL);
	if (category == NULL) {
		return  JNI_FALSE; // Java Exception already thrown
	}

	// convert parameter dest
	dest = (GdkColor*) _dest;

	// call function
	result = gtk_source_view_get_mark_category_background(self, category, dest);

	// cleanup parameter self

	// cleanup parameter category
	(*env)->ReleaseStringUTFChars(env, _category, category);

	// cleanup parameter dest

	// translate return value to JNI type
	_result = (jboolean) result;

	// and finally
	return _result;
}
