/*
 * GtkPrintUnixDialog.java
 *
 * Copyright (c) 2006-2009 Operational Dynamics Consulting Pty Ltd, and Others
 *
 * The code in this file, and the program it is a part of, are made available
 * to you by the authors under the terms of the "GNU General Public Licence,
 * version 2" plus the "Classpath Exception" (you may link to this code as a
 * library into other programs provided you don't make a derivation of it).
 * See the LICENCE file for the terms governing usage and redistribution.
 *
 *                      THIS FILE IS GENERATED CODE!
 *
 * To modify its contents or behaviour, either update the generation program,
 * change the information in the source defs file, or implement an override for
 * this class.
 */
package org.gnome.unixprint;

import org.gnome.gtk.PageSetup;
import org.gnome.gtk.PrintSettings;
import org.gnome.gtk.Widget;
import org.gnome.gtk.Window;
import org.gnome.unixprint.Plumbing;
import org.gnome.unixprint.PrintCapabilities;
import org.gnome.unixprint.PrintUnixDialog;
import org.gnome.unixprint.Printer;

final class GtkPrintUnixDialog extends Plumbing
{
    private GtkPrintUnixDialog() {}

    static final long createPrintUnixDialog(String title, Window parent) {
        long result;

        synchronized (lock) {
            result = gtk_print_unix_dialog_new(title, pointerOf(parent));

            return result;
        }
    }

    private static native final long gtk_print_unix_dialog_new(String title, long parent);

    static final void setPageSetup(PrintUnixDialog self, PageSetup pageSetup) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (pageSetup == null) {
            throw new IllegalArgumentException("pageSetup can't be null");
        }

        synchronized (lock) {
            gtk_print_unix_dialog_set_page_setup(pointerOf(self), pointerOf(pageSetup));
        }
    }

    private static native final void gtk_print_unix_dialog_set_page_setup(long self, long pageSetup);

    static final PageSetup getPageSetup(PrintUnixDialog self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_unix_dialog_get_page_setup(pointerOf(self));

            return (PageSetup) objectFor(result);
        }
    }

    private static native final long gtk_print_unix_dialog_get_page_setup(long self);

    static final void setCurrentPage(PrintUnixDialog self, int currentPage) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_unix_dialog_set_current_page(pointerOf(self), currentPage);
        }
    }

    private static native final void gtk_print_unix_dialog_set_current_page(long self, int currentPage);

    static final int getCurrentPage(PrintUnixDialog self) {
        int result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_unix_dialog_get_current_page(pointerOf(self));

            return result;
        }
    }

    private static native final int gtk_print_unix_dialog_get_current_page(long self);

    static final void setSettings(PrintUnixDialog self, PrintSettings settings) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            gtk_print_unix_dialog_set_settings(pointerOf(self), pointerOf(settings));
        }
    }

    private static native final void gtk_print_unix_dialog_set_settings(long self, long settings);

    static final PrintSettings getSettings(PrintUnixDialog self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_unix_dialog_get_settings(pointerOf(self));

            return (PrintSettings) objectFor(result);
        }
    }

    private static native final long gtk_print_unix_dialog_get_settings(long self);

    static final Printer getSelectedPrinter(PrintUnixDialog self) {
        long result;

        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        synchronized (lock) {
            result = gtk_print_unix_dialog_get_selected_printer(pointerOf(self));

            return (Printer) objectFor(result);
        }
    }

    private static native final long gtk_print_unix_dialog_get_selected_printer(long self);

    static final void addCustomTab(PrintUnixDialog self, Widget child, Widget tabLabel) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (child == null) {
            throw new IllegalArgumentException("child can't be null");
        }

        if (tabLabel == null) {
            throw new IllegalArgumentException("tabLabel can't be null");
        }

        synchronized (lock) {
            gtk_print_unix_dialog_add_custom_tab(pointerOf(self), pointerOf(child), pointerOf(tabLabel));
        }
    }

    private static native final void gtk_print_unix_dialog_add_custom_tab(long self, long child, long tabLabel);

    static final void setManualCapabilities(PrintUnixDialog self, PrintCapabilities capabilities) {
        if (self == null) {
            throw new IllegalArgumentException("self can't be null");
        }

        if (capabilities == null) {
            throw new IllegalArgumentException("capabilities can't be null");
        }

        synchronized (lock) {
            gtk_print_unix_dialog_set_manual_capabilities(pointerOf(self), numOf(capabilities));
        }
    }

    private static native final void gtk_print_unix_dialog_set_manual_capabilities(long self, int capabilities);
}

